

/*********************************************************************************************************************/
/*-----------------------------------------------------Includes------------------------------------------------------*/
/*********************************************************************************************************************/
#include "Ifx_Types.h"
#include "IfxStm.h"
#include "Ifx_reg.h"
#include "IfxPort.h"
#include "IfxScuRcu.h"
#include "IfxGeth_Eth.h"
#include "Ifx_Console.h"
#include "Configuration.h"
#include "ConfigurationIsr.h"
#include "Ifx_Lwip.h"
#include "Echo.h"
#include "Ifx_Console.h"
#include "UART_Logging.h"
#include "lwiperf.h"
#include "Bsp.h"
#include "TCA9539.h"
#include "tztek_can.h"
#include "tztek_gpio.h"
#include "tztek_uart.h"
#include "tztek_adc.h"
#include "tztek_spi.h"
#include "DAC53401.h"
#include "tztek_gps.h"

/* FreeRTOS*** Add by Turing, 2022.2.14 */
#include "FreeRTOS.h"
#include "task.h"
// #include "drv.h"
#include "semphr.h"
#include "queue.h"

#include "UDP_Com.h"
#include "TCP_Server.h"

/*********************************************************************************************************************/
/*-------------------------------------------------Global variables--------------------------------------------------*/
/*********************************************************************************************************************/
#define LED_PWR &MODULE_P34, 4

#define RGMII_RXCTL &MODULE_P11, 11
#define RGMII_RD0 &MODULE_P11, 10
#define RGMII_RD1 &MODULE_P11, 9
#define RGMII_RD2 &MODULE_P11, 8
#define RGMII_RD3 &MODULE_P11, 7

#define RGMII_TXCTL &MODULE_P11, 11
#define RGMII_TD0 &MODULE_P11, 10
#define RGMII_TD1 &MODULE_P11, 9
#define RGMII_TD2 &MODULE_P11, 8
#define RGMII_TD3 &MODULE_P11, 7

IfxCpu_syncEvent g_cpuSyncEvent = 0;
//extern Ifx_Lwip g_Lwip;

void instruct_delay(int times)
{
    int delay_nums = 0;
    for (int i = 0; i < times; i++)
    {
        delay_nums = 50000000;
        while (delay_nums--)
            ;
    }
}

//void ethernet_sendtest1(void)
//{
//    int8_t err;
//    //    uint8_t dstAddr[6] = {0xB0, 0x25, 0xAA, 0x2E, 0x9D, 0x32};
//    uint8_t dstAddr[6] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
//    uint8_t frame_data[] =
//        {
//            /* 以太网帧格式 */
//            0xff, 0xff, 0xff, 0xff, 0xff, 0xff,                                   /* 远端MAC */
//            0x01, 0x02, 0x03, 0x04, 0x05, 0x06,                                   /* 本地MAC */
//            0x8, 0x0,                                                             /* ip类型 */
//            0x45, 0x0, 0x0, 0x26 /*l*/, 0x0, 0x0, 0x0, 0x0, 0xFF, 0x11, 0x0, 0x0, /* UDP报头 */
//            0xC0, 0xA8, 0x37, 0x6E,                                               /* 本地IP */
//            0xC0, 0xA8, 0x37, 0xC7,                                               /* 远端IP */
//            0x22, 0xB0,                                                           /* 本地端口 */
//            0x22, 0xB1,                                                           /* 远端端口 */
//            0x0, 0x12,                                                            /* UDP长度 */
//            0x0, 0x0,                                                             /* UDP校验和 */
//            0x68, 0x65, 0x6C, 0x6C, 0x6F, 0x20, 0x7A, 0x6F, 0x72, 0x62            /* 数据 */
//        };
//
//    struct pbuf *p;
//
//    /* 分配缓冲区空间 */
//    p = pbuf_alloc(PBUF_TRANSPORT, 0x26 + 14, PBUF_POOL);
//
//    if (p != NULL)
//    {
//        /* 填充缓冲区数据 */
//        pbuf_take(p, frame_data, 0x26 + 14);
//
//        /* 把数据直接通过底层发送 */
//        //         g_Lwip.netif.linkoutput(&g_Lwip.netif, p);
//        err = ethernet_output(&g_Lwip.netif, p, (const struct eth_addr *)g_Lwip.netif.hwaddr, (const struct eth_addr *)dstAddr, ETHTYPE_IP);
//        if (err != ERR_OK)
//        {
//            Ifx_Console_print("etharp_request err:%d.\r\n", err);
//        }
//        else
//        {
////            Ifx_Console_print("MAC send...\r\n");
//        }
//
//        /* 释放缓冲区空间 */
//        pbuf_free(p);
//    }
//}
//
///* LWIPerf娴嬮�熸姤鍛� *** Add by Turing, 2022.4.1  */
//#if LWIP_TCP
//static void
//lwiperf_report(void *arg, enum lwiperf_report_type report_type,
//               const ip_addr_t *local_addr, u16_t local_port, const ip_addr_t *remote_addr, u16_t remote_port,
//               u32_t bytes_transferred, u32_t ms_duration, u32_t bandwidth_kbitpsec)
//{
//    LWIP_UNUSED_ARG(arg);
//    LWIP_UNUSED_ARG(local_addr);
//    LWIP_UNUSED_ARG(local_port);
//
//    Ifx_Console_print("IPERF report: type=%d, remote: %s:%d, total bytes: %" U32_F ", duration in ms: %" U32_F ", kbits/s: %" U32_F "\n",
//                      (int)report_type, ipaddr_ntoa(remote_addr), (int)remote_port, bytes_transferred, ms_duration, bandwidth_kbitpsec);
//}
//#endif

void test_task1(void *pvParameters)
{
    Ifx_Console_print("task1 create.\r\n");
    while (1)
    {
        Ifx_Console_print("task1 start.\r\n");
        vTaskDelay(1000);
        Ifx_Console_print("task1 end.\r\n");
        vTaskDelay(1000);
    }
}
void test_task2(void *pvParameters)
{
    Ifx_Console_print("task1 create.\r\n");
    while (1)
    {
        Ifx_Console_print("task2 start.\r\n");
        vTaskDelay(100);
        Ifx_Console_print("task2 end.\r\n");
        vTaskDelay(100);
    }
}
/*********************************************************************************************************************/
/*---------------------------------------------Function Implementations----------------------------------------------*/
/*********************************************************************************************************************/
void core0_main(void)
{
//    BaseType_t ret0 = 0;
//    int i = 0;
    char *version = "V1.0.0.9";
    /* Enable the global interrupts of this CPU */
    IfxCpu_enableInterrupts();

    /* !!WATCHDOG0 AND SAFETY WATCHDOG ARE DISABLED HERE!!
     * Enable the watchdogs and service them periodically if it is required
     */
    IfxScuWdt_disableCpuWatchdog(IfxScuWdt_getCpuWatchdogPassword());
    IfxScuWdt_disableSafetyWatchdog(IfxScuWdt_getSafetyWatchdogPassword());

    /* Wait for CPU sync event: wait until all CPUs are in CpuX_Main to avoid variables' initialization problems */
    IfxCpu_emitEvent(&g_cpuSyncEvent);
    IfxCpu_waitEvent(&g_cpuSyncEvent, 1);

    initUART();
    can_init();
    tztek_uart_6_11_init();
    tztek_gpio_init();
    tztek_adc_init();
    tztek_DAC53401_Init();
//    tztek_spi_init();         /* spi初始化与数据接收在Cpu3_Main函数中执行 */

    waitTime(IfxStm_getTicksFromMilliseconds(BSP_DEFAULT_TIMER, 3000));
    //    TCA9539_init();
    Ifx_Console_print("\r\n\r\n*****************  C22EC49N2:Orin*2+TC397*2  ********************\r\n");
    Ifx_Console_print("Version : TC397_B_%s\r\n\r\n\r\n", version);

    IfxStm_CompareConfig stmCompareConfig; /* STM Configuration declaration                */

    IfxStm_initCompareConfig(&stmCompareConfig); /* Initialize a default configuration for STM   */

    stmCompareConfig.triggerPriority = ISR_PRIORITY_OS_TICK;               /* Priority of the interrupt generated by STM   */
    stmCompareConfig.comparatorInterrupt = IfxStm_ComparatorInterrupt_ir0; /* Select the request source 0                  */
    stmCompareConfig.ticks = IFX_CFG_STM_TICKS_PER_MS * 10;                /* First interrupt shall occur after 10 ms      */
    stmCompareConfig.typeOfService = IfxSrc_Tos_cpu0;                      /* CPU0 serves the interrupts                   */

    IfxStm_initCompare(&MODULE_STM0, &stmCompareConfig); /* Initialize the Compare functionality         */

    IfxGeth_enableModule(&MODULE_GETH); /* Enable Gigabit Ethernet Media Access Controller (GETH) module*/

    /* Define a MAC Address */
    eth_addr_t ethAddr;
    ethAddr.addr[0] = 0x02;
    ethAddr.addr[1] = 0x02;
    ethAddr.addr[2] = 0x03;
    ethAddr.addr[3] = 0x04;
    ethAddr.addr[4] = 0x05;
    ethAddr.addr[5] = 0x06;

    Ifx_Lwip_init(ethAddr); /* Initialize LwIP with the MAC address                         */

//    echoInit(); /* Initialize ECHO application                                  */

    UDP_Init();
    TCP_Init();

    // ip_addr_t  perf_server_ip;
    // IP_ADDR4( &perf_server_ip, 192, 168, 55, 110 );
    // lwiperf_start_tcp_server( &perf_server_ip, 5001, NULL, NULL );
    // Ifx_Console_print("Iperf server start!\r\n");

    // ip_addr_t  perf_remote_server_ip;
    // IP_ADDR4( &perf_remote_server_ip, 192, 168, 55, 100 );
    // lwiperf_start_tcp_client_default(&perf_remote_server_ip, lwiperf_report, NULL);
    // Ifx_Console_print("Iperf client start!\r\n");

    //    ret0 = xTaskCreate(test_task1, "test_task1", 1024, NULL, 3, NULL);
    //    ret0 = xTaskCreate(test_task2, "test_task2", 1024, NULL, 3, NULL);
    //    vTaskStartScheduler();
    unsigned short udpState = 0,udpState_Pre = 0;
    unsigned short sysCout = 0;
    while (1)
    {

//        tztek_can_test();
        tztek_gpio_test();
        tztek_uart_test();
        tztek_adc_test();
        tztek_dac_Test();
        tztek_spi_test();
        tztek_uart_6_RingBack_Test();

        Ifx_Lwip_pollTimerFlags();   /* Poll LwIP timers and trigger protocols execution if required */
        Ifx_Lwip_pollReceiveFlags(); /* Receive data package through ETH                             */
//        if (i == 100000)
//        {
//            ethernet_sendtest1();
//            i = 0;
//        }
//        i++;

        TCPServerConnect();

        //UDP测试
        udpState = UDP_Open(&UDPCom_GNSS);
        if(udpState_Pre != udpState)
        {
            Ifx_Console_print("UDP State Change is %i \r\n", udpState);
        }

        udpState_Pre = udpState;
        sysCout ++;
        if(sysCout == 50)
        {
            sysCout = 0;
//            UDP_Send(&UDPCom_GNSS);
        }

        waitTime(IfxStm_getTicksFromMilliseconds(BSP_DEFAULT_TIMER, 10));  //延时函数，20221108
    }
}

/* This interrupt is raised by the STM0 */
IFX_INTERRUPT(updateLwIPStackISR, 0, ISR_PRIORITY_OS_TICK);

/* ISR to update LwIP stack */
void updateLwIPStackISR(void)
{
    /* Configure STM to generate an interrupt in 1 ms */
    IfxStm_increaseCompare(&MODULE_STM0, IfxStm_Comparator_0, IFX_CFG_STM_TICKS_PER_MS);

    g_TickCount_1ms++;      /* Increase LwIP system time                                    */
    Ifx_Lwip_onTimerTick(); /* Every 1 ms LwIP timers are increased for all the enabled
                             * protocols (ARP, TCP, DHCP, LINK)                             */
}
