
#ifndef UDP_COM_H_
#define UDP_COM_H_

#include <stdint.h>
#include <stdbool.h>
#include <math.h>
#include <string.h>
#include "Ifx_Console.h"

#include "lwip/opt.h"
#include "lwip/debug.h"
#include "lwip/stats.h"
//#include "lwip/tcp.h"

#include "Ifx_Lwip.h"
#include "lwip/pbuf.h"
#include "lwip/udp.h"

//UDP协议端口号
// Socket defines
#define UDP_PORT_NUMBER_CLIENT       8866//CLIENT端
#define UDP_PORT_NUMBER_SERVER       7070//SERVER端

//#define UDP_CLIENT_IPAdd           "192.168.20.159" //ClientIPstring
#define UDP_SERVER_IPAdd             "192.168.20.111" //ServerIPstring

#define UDP_SEND_BUF_LENGTH_MAX      20000
#define UDP_RECV_BUF_LENGTH_MAX      20000  //接收障碍物列表数据最大buffer空间

typedef struct UDPCom_typ
{
    struct udp_pcb *UDPpcb;
    unsigned char PreCheckOKFlag;
    unsigned char FrameGetFailedFlag;

    ip_addr_t IPAddress_Client;
    ip_addr_t IPAddress_Server;
    unsigned short PortNum_Client;
    unsigned short PortNum_Server;
    unsigned short ErrorID;
    bool Connected;
    bool Connected_Pre;
    bool Connected_Delay;
    bool NewDataArrived;
    signed short SendResult;
    signed short RecvResult;
    signed short CloseResult;
    unsigned short RecvTimeOutCount;
    unsigned long OpenIdent;
    unsigned short RecvErrorCount;
    unsigned short SendErrorCount;
    unsigned short RecvOKCount;
    unsigned short SendOKCount;
    unsigned short SendDataCount;
    unsigned short RecvDataCount;
    unsigned short FrameGetFailedCount;
    unsigned short SendDataLen;
    unsigned short RecvDataLen;
    unsigned char OpenStatus;
    unsigned char SendStatus;
    unsigned char RecvStatus;
    unsigned char CloseStatus;
    unsigned char SendDataBuffer[UDP_SEND_BUF_LENGTH_MAX];
    unsigned char RecvDataBuffer[UDP_RECV_BUF_LENGTH_MAX];
    unsigned short RecvOKCount_Pending;
    unsigned short RecvTimeOutCount_Pending;
    unsigned short RecvDataCount_Pending;
    unsigned short RecvBufferLen_Pending;
    unsigned char RecvStatus_Pending;
} UDPCom_typ;

extern struct UDPCom_typ UDPCom_GNSS;

void UDP_Init(void);
unsigned short UDP_Open(struct UDPCom_typ *com);
void UDP_Send(struct UDPCom_typ *com);
void UDP_Recv(void *arg, struct udp_pcb *upcb, struct pbuf *p, const ip_addr_t *addr, u16_t port);



#endif /* UDP_COM_H_ */
