/**
 * \file IfxFlash_cfg.c
 * \brief FLASH on-chip implementation data
 *
 * \version iLLD_1_0_1_12_0
 * \copyright Copyright (c) 2019 Infineon Technologies AG. All rights reserved.
 *
 *
 *                                 IMPORTANT NOTICE
 *
 * Use of this file is subject to the terms of use agreed between (i) you or
 * the company in which ordinary course of business you are acting and (ii)
 * Infineon Technologies AG or its licensees. If and as long as no such terms
 * of use are agreed, use of this file is subject to following:
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer, must
 * be included in all copies of the Software, in whole or in part, and all
 * derivative works of the Software, unless such copies or derivative works are
 * solely in the form of machine-executable object code generated by a source
 * language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 */

/******************************************************************************/
/*----------------------------------Includes----------------------------------*/
/******************************************************************************/

#include "IfxFlash_cfg.h"

/******************************************************************************/
/*-----------------------Exported Variables/Constants-------------------------*/
/******************************************************************************/

IFX_CONST IfxFlash_flashSector IfxFlash_dFlashTableCfsLog[IFXFLASH_DFLASH_NUM_CFS_LOG_SECTORS] = {
    {0xaf800000, 0xaf800fff}, //CFS0
    {0xaf801000, 0xaf801fff}, //CFS1
    {0xaf802000, 0xaf802fff}, //CFS2
    {0xaf803000, 0xaf803fff}, //CFS3
    {0xaf804000, 0xaf804fff}, //CFS4
    {0xaf805000, 0xaf805fff}, //CFS5
    {0xaf806000, 0xaf806fff}, //CFS6
    {0xaf807000, 0xaf807fff}, //CFS7
    {0xaf808000, 0xaf808fff}, //CFS8
    {0xaf809000, 0xaf809fff}, //CFS9
    {0xaf80a000, 0xaf80afff}, //CFS10
    {0xaf80b000, 0xaf80bfff}, //CFS11
    {0xaf80c000, 0xaf80cfff}, //CFS12
    {0xaf80d000, 0xaf80dfff}, //CFS13
    {0xaf80e000, 0xaf80efff}, //CFS14
    {0xaf80f000, 0xaf80ffff}, //CFS15
}


;

IFX_CONST IfxFlash_flashSector IfxFlash_dFlashTableEepLog[IFXFLASH_DFLASH_NUM_LOG_SECTORS] = {
    {0xAF000000, 0xAF000FFF},
    {0xAF001000, 0xAF001FFF},
    {0xAF002000, 0xAF002FFF},
    {0xAF003000, 0xAF003FFF},
    {0xAF004000, 0xAF004FFF},
    {0xAF005000, 0xAF005FFF},
    {0xAF006000, 0xAF006FFF},
    {0xAF007000, 0xAF007FFF},
    {0xAF008000, 0xAF008FFF},
    {0xAF009000, 0xAF009FFF},
    {0xAF00A000, 0xAF00AFFF},
    {0xAF00B000, 0xAF00BFFF},
    {0xAF00C000, 0xAF00CFFF},
    {0xAF00D000, 0xAF00DFFF},
    {0xAF00E000, 0xAF00EFFF},
    {0xAF00F000, 0xAF00FFFF},
    {0xAF010000, 0xAF010FFF},
    {0xAF011000, 0xAF011FFF},
    {0xAF012000, 0xAF012FFF},
    {0xAF013000, 0xAF013FFF},
    {0xAF014000, 0xAF014FFF},
    {0xAF015000, 0xAF015FFF},
    {0xAF016000, 0xAF016FFF},
    {0xAF017000, 0xAF017FFF},
    {0xAF018000, 0xAF018FFF},
    {0xAF019000, 0xAF019FFF},
    {0xAF01A000, 0xAF01AFFF},
    {0xAF01B000, 0xAF01BFFF},
    {0xAF01C000, 0xAF01CFFF},
    {0xAF01D000, 0xAF01DFFF},
    {0xAF01E000, 0xAF01EFFF},
    {0xAF01F000, 0xAF01FFFF},
    {0xAF020000, 0xAF020FFF},
    {0xAF021000, 0xAF021FFF},
    {0xAF022000, 0xAF022FFF},
    {0xAF023000, 0xAF023FFF},
    {0xAF024000, 0xAF024FFF},
    {0xAF025000, 0xAF025FFF},
    {0xAF026000, 0xAF026FFF},
    {0xAF027000, 0xAF027FFF},
    {0xAF028000, 0xAF028FFF},
    {0xAF029000, 0xAF029FFF},
    {0xAF02A000, 0xAF02AFFF},
    {0xAF02B000, 0xAF02BFFF},
    {0xAF02C000, 0xAF02CFFF},
    {0xAF02D000, 0xAF02DFFF},
    {0xAF02E000, 0xAF02EFFF},
    {0xAF02F000, 0xAF02FFFF},
    {0xAF030000, 0xAF030FFF},
    {0xAF031000, 0xAF031FFF},
    {0xAF032000, 0xAF032FFF},
    {0xAF033000, 0xAF033FFF},
    {0xAF034000, 0xAF034FFF},
    {0xAF035000, 0xAF035FFF},
    {0xAF036000, 0xAF036FFF},
    {0xAF037000, 0xAF037FFF},
    {0xAF038000, 0xAF038FFF},
    {0xAF039000, 0xAF039FFF},
    {0xAF03A000, 0xAF03AFFF},
    {0xAF03B000, 0xAF03BFFF},
    {0xAF03C000, 0xAF03CFFF},
    {0xAF03D000, 0xAF03DFFF},
    {0xAF03E000, 0xAF03EFFF},
    {0xAF03F000, 0xAF03FFFF},
    {0xAF040000, 0xAF040FFF},
    {0xAF041000, 0xAF041FFF},
    {0xAF042000, 0xAF042FFF},
    {0xAF043000, 0xAF043FFF},
    {0xAF044000, 0xAF044FFF},
    {0xAF045000, 0xAF045FFF},
    {0xAF046000, 0xAF046FFF},
    {0xAF047000, 0xAF047FFF},
    {0xAF048000, 0xAF048FFF},
    {0xAF049000, 0xAF049FFF},
    {0xAF04A000, 0xAF04AFFF},
    {0xAF04B000, 0xAF04BFFF},
    {0xAF04C000, 0xAF04CFFF},
    {0xAF04D000, 0xAF04DFFF},
    {0xAF04E000, 0xAF04EFFF},
    {0xAF04F000, 0xAF04FFFF},
    {0xAF050000, 0xAF050FFF},
    {0xAF051000, 0xAF051FFF},
    {0xAF052000, 0xAF052FFF},
    {0xAF053000, 0xAF053FFF},
    {0xAF054000, 0xAF054FFF},
    {0xAF055000, 0xAF055FFF},
    {0xAF056000, 0xAF056FFF},
    {0xAF057000, 0xAF057FFF},
    {0xAF058000, 0xAF058FFF},
    {0xAF059000, 0xAF059FFF},
    {0xAF05A000, 0xAF05AFFF},
    {0xAF05B000, 0xAF05BFFF},
    {0xAF05C000, 0xAF05CFFF},
    {0xAF05D000, 0xAF05DFFF},
    {0xAF05E000, 0xAF05EFFF},
    {0xAF05F000, 0xAF05FFFF},
    {0xAF060000, 0xAF060FFF},
    {0xAF061000, 0xAF061FFF},
    {0xAF062000, 0xAF062FFF},
    {0xAF063000, 0xAF063FFF},
    {0xAF064000, 0xAF064FFF},
    {0xAF065000, 0xAF065FFF},
    {0xAF066000, 0xAF066FFF},
    {0xAF067000, 0xAF067FFF},
    {0xAF068000, 0xAF068FFF},
    {0xAF069000, 0xAF069FFF},
    {0xAF06A000, 0xAF06AFFF},
    {0xAF06B000, 0xAF06BFFF},
    {0xAF06C000, 0xAF06CFFF},
    {0xAF06D000, 0xAF06DFFF},
    {0xAF06E000, 0xAF06EFFF},
    {0xAF06F000, 0xAF06FFFF},
    {0xAF070000, 0xAF070FFF},
    {0xAF071000, 0xAF071FFF},
    {0xAF072000, 0xAF072FFF},
    {0xAF073000, 0xAF073FFF},
    {0xAF074000, 0xAF074FFF},
    {0xAF075000, 0xAF075FFF},
    {0xAF076000, 0xAF076FFF},
    {0xAF077000, 0xAF077FFF},
    {0xAF078000, 0xAF078FFF},
    {0xAF079000, 0xAF079FFF},
    {0xAF07A000, 0xAF07AFFF},
    {0xAF07B000, 0xAF07BFFF},
    {0xAF07C000, 0xAF07CFFF},
    {0xAF07D000, 0xAF07DFFF},
    {0xAF07E000, 0xAF07EFFF},
    {0xAF07F000, 0xAF07FFFF},
    {0xAF080000, 0xAF080FFF},
    {0xAF081000, 0xAF081FFF},
    {0xAF082000, 0xAF082FFF},
    {0xAF083000, 0xAF083FFF},
    {0xAF084000, 0xAF084FFF},
    {0xAF085000, 0xAF085FFF},
    {0xAF086000, 0xAF086FFF},
    {0xAF087000, 0xAF087FFF},
    {0xAF088000, 0xAF088FFF},
    {0xAF089000, 0xAF089FFF},
    {0xAF08A000, 0xAF08AFFF},
    {0xAF08B000, 0xAF08BFFF},
    {0xAF08C000, 0xAF08CFFF},
    {0xAF08D000, 0xAF08DFFF},
    {0xAF08E000, 0xAF08EFFF},
    {0xAF08F000, 0xAF08FFFF},
    {0xAF090000, 0xAF090FFF},
    {0xAF091000, 0xAF091FFF},
    {0xAF092000, 0xAF092FFF},
    {0xAF093000, 0xAF093FFF},
    {0xAF094000, 0xAF094FFF},
    {0xAF095000, 0xAF095FFF},
    {0xAF096000, 0xAF096FFF},
    {0xAF097000, 0xAF097FFF},
    {0xAF098000, 0xAF098FFF},
    {0xAF099000, 0xAF099FFF},
    {0xAF09A000, 0xAF09AFFF},
    {0xAF09B000, 0xAF09BFFF},
    {0xAF09C000, 0xAF09CFFF},
    {0xAF09D000, 0xAF09DFFF},
    {0xAF09E000, 0xAF09EFFF},
    {0xAF09F000, 0xAF09FFFF},
    {0xAF0A0000, 0xAF0A0FFF},
    {0xAF0A1000, 0xAF0A1FFF},
    {0xAF0A2000, 0xAF0A2FFF},
    {0xAF0A3000, 0xAF0A3FFF},
    {0xAF0A4000, 0xAF0A4FFF},
    {0xAF0A5000, 0xAF0A5FFF},
    {0xAF0A6000, 0xAF0A6FFF},
    {0xAF0A7000, 0xAF0A7FFF},
    {0xAF0A8000, 0xAF0A8FFF},
    {0xAF0A9000, 0xAF0A9FFF},
    {0xAF0AA000, 0xAF0AAFFF},
    {0xAF0AB000, 0xAF0ABFFF},
    {0xAF0AC000, 0xAF0ACFFF},
    {0xAF0AD000, 0xAF0ADFFF},
    {0xAF0AE000, 0xAF0AEFFF},
    {0xAF0AF000, 0xAF0AFFFF},
    {0xAF0B0000, 0xAF0B0FFF},
    {0xAF0B1000, 0xAF0B1FFF},
    {0xAF0B2000, 0xAF0B2FFF},
    {0xAF0B3000, 0xAF0B3FFF},
    {0xAF0B4000, 0xAF0B4FFF},
    {0xAF0B5000, 0xAF0B5FFF},
    {0xAF0B6000, 0xAF0B6FFF},
    {0xAF0B7000, 0xAF0B7FFF},
    {0xAF0B8000, 0xAF0B8FFF},
    {0xAF0B9000, 0xAF0B9FFF},
    {0xAF0BA000, 0xAF0BAFFF},
    {0xAF0BB000, 0xAF0BBFFF},
    {0xAF0BC000, 0xAF0BCFFF},
    {0xAF0BD000, 0xAF0BDFFF},
    {0xAF0BE000, 0xAF0BEFFF},
    {0xAF0BF000, 0xAF0BFFFF},
    {0xAF0C0000, 0xAF0C0FFF},
    {0xAF0C1000, 0xAF0C1FFF},
    {0xAF0C2000, 0xAF0C2FFF},
    {0xAF0C3000, 0xAF0C3FFF},
    {0xAF0C4000, 0xAF0C4FFF},
    {0xAF0C5000, 0xAF0C5FFF},
    {0xAF0C6000, 0xAF0C6FFF},
    {0xAF0C7000, 0xAF0C7FFF},
    {0xAF0C8000, 0xAF0C8FFF},
    {0xAF0C9000, 0xAF0C9FFF},
    {0xAF0CA000, 0xAF0CAFFF},
    {0xAF0CB000, 0xAF0CBFFF},
    {0xAF0CC000, 0xAF0CCFFF},
    {0xAF0CD000, 0xAF0CDFFF},
    {0xAF0CE000, 0xAF0CEFFF},
    {0xAF0CF000, 0xAF0CFFFF},
    {0xAF0D0000, 0xAF0D0FFF},
    {0xAF0D1000, 0xAF0D1FFF},
    {0xAF0D2000, 0xAF0D2FFF},
    {0xAF0D3000, 0xAF0D3FFF},
    {0xAF0D4000, 0xAF0D4FFF},
    {0xAF0D5000, 0xAF0D5FFF},
    {0xAF0D6000, 0xAF0D6FFF},
    {0xAF0D7000, 0xAF0D7FFF},
    {0xAF0D8000, 0xAF0D8FFF},
    {0xAF0D9000, 0xAF0D9FFF},
    {0xAF0DA000, 0xAF0DAFFF},
    {0xAF0DB000, 0xAF0DBFFF},
    {0xAF0DC000, 0xAF0DCFFF},
    {0xAF0DD000, 0xAF0DDFFF},
    {0xAF0DE000, 0xAF0DEFFF},
    {0xAF0DF000, 0xAF0DFFFF},
    {0xAF0E0000, 0xAF0E0FFF},
    {0xAF0E1000, 0xAF0E1FFF},
    {0xAF0E2000, 0xAF0E2FFF},
    {0xAF0E3000, 0xAF0E3FFF},
    {0xAF0E4000, 0xAF0E4FFF},
    {0xAF0E5000, 0xAF0E5FFF},
    {0xAF0E6000, 0xAF0E6FFF},
    {0xAF0E7000, 0xAF0E7FFF},
    {0xAF0E8000, 0xAF0E8FFF},
    {0xAF0E9000, 0xAF0E9FFF},
    {0xAF0EA000, 0xAF0EAFFF},
    {0xAF0EB000, 0xAF0EBFFF},
    {0xAF0EC000, 0xAF0ECFFF},
    {0xAF0ED000, 0xAF0EDFFF},
    {0xAF0EE000, 0xAF0EEFFF},
    {0xAF0EF000, 0xAF0EFFFF},
    {0xAF0F0000, 0xAF0F0FFF},
    {0xAF0F1000, 0xAF0F1FFF},
    {0xAF0F2000, 0xAF0F2FFF},
    {0xAF0F3000, 0xAF0F3FFF},
    {0xAF0F4000, 0xAF0F4FFF},
    {0xAF0F5000, 0xAF0F5FFF},
    {0xAF0F6000, 0xAF0F6FFF},
    {0xAF0F7000, 0xAF0F7FFF},
    {0xAF0F8000, 0xAF0F8FFF},
    {0xAF0F9000, 0xAF0F9FFF},
    {0xAF0FA000, 0xAF0FAFFF},
    {0xAF0FB000, 0xAF0FBFFF},
    {0xAF0FC000, 0xAF0FCFFF},
    {0xAF0FD000, 0xAF0FDFFF},
    {0xAF0FE000, 0xAF0FEFFF},
    {0xAF0FF000, 0xAF0FFFFF},
};

IFX_CONST IfxFlash_flashSector IfxFlash_dFlashTableHsmLog[IFXFLASH_DFLASH_NUM_HSM_LOG_SECTORS] = {
    {0xAFC00000, 0xAFC00FFF},   //HSM0
    {0xAFC01000, 0xAFC01FFF},   //HSM1
    {0xAFC02000, 0xAFC02FFF},   //HSM2
    {0xAFC03000, 0xAFC03FFF},   //HSM3
    {0xAFC04000, 0xAFC04FFF},   //HSM4
    {0xAFC05000, 0xAFC05FFF},   //HSM5
    {0xAFC06000, 0xAFC06FFF},   //HSM6
    {0xAFC07000, 0xAFC07FFF},   //HSM7
    {0xAFC08000, 0xAFC08FFF},   //HSM8
    {0xAFC09000, 0xAFC09FFF},   //HSM9
    {0xAFC0A000, 0xAFC0AFFF},   //HSM10
    {0xAFC0B000, 0xAFC0BFFF},   //HSM11
    {0xAFC0C000, 0xAFC0CFFF},   //HSM12
    {0xAFC0D000, 0xAFC0DFFF},   //HSM13
    {0xAFC0E000, 0xAFC0EFFF},   //HSM14
    {0xAFC0F000, 0xAFC0FFFF},   //HSM15
    {0xAFC10000, 0xAFC10FFF},   //HSM16
    {0xAFC11000, 0xAFC11FFF},   //HSM17
    {0xAFC12000, 0xAFC12FFF},   //HSM18
    {0xAFC13000, 0xAFC13FFF},   //HSM19
    {0xAFC14000, 0xAFC14FFF},   //HSM20
    {0xAFC15000, 0xAFC15FFF},   //HSM21
    {0xAFC16000, 0xAFC16FFF},   //HSM22
    {0xAFC17000, 0xAFC17FFF},   //HSM23
    {0xAFC18000, 0xAFC18FFF},   //HSM24
    {0xAFC19000, 0xAFC19FFF},   //HSM25
    {0xAFC1A000, 0xAFC1AFFF},   //HSM26
    {0xAFC1B000, 0xAFC1BFFF},   //HSM27
    {0xAFC1C000, 0xAFC1CFFF},   //HSM28
    {0xAFC1D000, 0xAFC1DFFF},   //HSM29
    {0xAFC1E000, 0xAFC1EFFF},   //HSM30
    {0xAFC1F000, 0xAFC1FFFF},   //HSM31
};

IFX_CONST IfxFlash_flashSector IfxFlash_dFlashTablePhys[IFXFLASH_DFLASH_NUM_PHYSICAL_SECTORS] = {
    {IFXFLASH_DFLASH_START, IFXFLASH_DFLASH_END},
};

IFX_CONST IfxFlash_flashSector IfxFlash_dFlashTableUcbLog[IFXFLASH_DFLASH_NUM_UCB_LOG_SECTORS] = {
    {0xAF400000, 0xAF4001FF},   //UCB0
    {0xAF400200, 0xAF4003FF},   //UCB1
    {0xAF400400, 0xAF4005FF},   //UCB2
    {0xAF400600, 0xAF4007FF},   //UCB3
    {0xAF400800, 0xAF4009FF},   //UCB4
    {0xAF400A00, 0xAF400BFF},   //UCB5
    {0xAF400C00, 0xAF400DFF},   //UCB6
    {0xAF400E00, 0xAF400FFF},   //UCB7
    {0xAF401000, 0xAF4011FF},   //UCB8
    {0xAF401200, 0xAF4013FF},   //UCB9
    {0xAF401400, 0xAF4015FF},   //UCB10
    {0xAF401600, 0xAF4017FF},   //UCB11
    {0xAF401800, 0xAF4019FF},   //UCB12
    {0xAF401A00, 0xAF401BFF},   //UCB13
    {0xAF401C00, 0xAF401DFF},   //UCB14
    {0xAF401E00, 0xAF401FFF},   //UCB15
    {0xAF402000, 0xAF4021FF},   //UCB16
    {0xAF402200, 0xAF4023FF},   //UCB17
    {0xAF402400, 0xAF4025FF},   //UCB18
    {0xAF402600, 0xAF4027FF},   //UCB19
    {0xAF402800, 0xAF4029FF},   //UCB20
    {0xAF402A00, 0xAF402BFF},   //UCB21
    {0xAF402C00, 0xAF402DFF},   //UCB22
    {0xAF402E00, 0xAF402FFF},   //UCB23
    {0xAF403000, 0xAF4031FF},   //UCB24
    {0xAF403200, 0xAF4033FF},   //UCB25
    {0xAF403400, 0xAF4035FF},   //UCB26
    {0xAF403600, 0xAF4037FF},   //UCB27
    {0xAF403800, 0xAF4039FF},   //UCB28
    {0xAF403A00, 0xAF403BFF},   //UCB29
    {0xAF403C00, 0xAF403DFF},   //UCB30
    {0xAF403E00, 0xAF403FFF},   //UCB31
    {0xAF404000, 0xAF4041FF},   //UCB32
    {0xAF404200, 0xAF4043FF},   //UCB33
    {0xAF404400, 0xAF4045FF},   //UCB34
    {0xAF404600, 0xAF4047FF},   //UCB35
    {0xAF404800, 0xAF4049FF},   //UCB36
    {0xAF404A00, 0xAF404BFF},   //UCB37
    {0xAF404C00, 0xAF404DFF},   //UCB38
    {0xAF404E00, 0xAF404FFF},   //UCB39
    {0xAF405000, 0xAF4051FF},   //UCB40
    {0xAF405200, 0xAF4053FF},   //UCB41
    {0xAF405400, 0xAF4055FF},   //UCB42
    {0xAF405600, 0xAF4057FF},   //UCB43
    {0xAF405800, 0xAF4059FF},   //UCB44
    {0xAF405A00, 0xAF405BFF},   //UCB45
    {0xAF405C00, 0xAF405DFF},   //UCB46
    {0xAF405E00, 0xAF405FFF},   //UCB47
};

IFX_CONST IfxFlash_flashSector IfxFlash_pFlashTableLog[IFXFLASH_PFLASH_NUM_LOG_SECTORS] = {
    {0xA0000000, 0xA0003FFF},      //   PF0 S0
    {0xA0004000, 0xA0007FFF},      //	PF0 S1
    {0xA0008000, 0xA000BFFF},      //	PF0 S2
    {0xA000C000, 0xA000FFFF},      //	PF0 S3
    {0xA0010000, 0xA0013FFF},      //	PF0 S4
    {0xA0014000, 0xA0017FFF},      //	PF0 S5
    {0xA0018000, 0xA001BFFF},      //	PF0 S6
    {0xA001C000, 0xA001FFFF},      //	PF0 S7
    {0xA0020000, 0xA0023FFF},      //	PF0 S8
    {0xA0024000, 0xA0027FFF},      //	PF0 S9
    {0xA0028000, 0xA002BFFF},      //	PF0 S10
    {0xA002C000, 0xA002FFFF},      //	PF0 S11
    {0xA0030000, 0xA0033FFF},      //	PF0 S12
    {0xA0034000, 0xA0037FFF},      //	PF0 S13
    {0xA0038000, 0xA003BFFF},      //	PF0 S14
    {0xA003C000, 0xA003FFFF},      //	PF0 S15
    {0xA0040000, 0xA0043FFF},      //	PF0 S16
    {0xA0044000, 0xA0047FFF},      //	PF0 S17
    {0xA0048000, 0xA004BFFF},      //	PF0 S18
    {0xA004C000, 0xA004FFFF},      //	PF0 S19
    {0xA0050000, 0xA0053FFF},      //	PF0 S20
    {0xA0054000, 0xA0057FFF},      //	PF0 S21
    {0xA0058000, 0xA005BFFF},      //	PF0 S22
    {0xA005C000, 0xA005FFFF},      //	PF0 S23
    {0xA0060000, 0xA0063FFF},      //	PF0 S24
    {0xA0064000, 0xA0067FFF},      //	PF0 S25
    {0xA0068000, 0xA006BFFF},      //	PF0 S26
    {0xA006C000, 0xA006FFFF},      //	PF0 S27
    {0xA0070000, 0xA0073FFF},      //	PF0 S28
    {0xA0074000, 0xA0077FFF},      //	PF0 S29
    {0xA0078000, 0xA007BFFF},      //	PF0 S30
    {0xA007C000, 0xA007FFFF},      //	PF0 S31
    {0xA0080000, 0xA0083FFF},      //	PF0 S32
    {0xA0084000, 0xA0087FFF},      //	PF0 S33
    {0xA0088000, 0xA008BFFF},      //	PF0 S34
    {0xA008C000, 0xA008FFFF},      //	PF0 S35
    {0xA0090000, 0xA0093FFF},      //	PF0 S36
    {0xA0094000, 0xA0097FFF},      //	PF0 S37
    {0xA0098000, 0xA009BFFF},      //	PF0 S38
    {0xA009C000, 0xA009FFFF},      //	PF0 S39
    {0xA00A0000, 0xA00A3FFF},      //	PF0 S40
    {0xA00A4000, 0xA00A7FFF},      //	PF0 S41
    {0xA00A8000, 0xA00ABFFF},      //	PF0 S42
    {0xA00AC000, 0xA00AFFFF},      //	PF0 S43
    {0xA00B0000, 0xA00B3FFF},      //	PF0 S44
    {0xA00B4000, 0xA00B7FFF},      //	PF0 S45
    {0xA00B8000, 0xA00BBFFF},      //	PF0 S46
    {0xA00BC000, 0xA00BFFFF},      //	PF0 S47
    {0xA00C0000, 0xA00C3FFF},      //	PF0 S48
    {0xA00C4000, 0xA00C7FFF},      //	PF0 S49
    {0xA00C8000, 0xA00CBFFF},      //	PF0 S50
    {0xA00CC000, 0xA00CFFFF},      //	PF0 S51
    {0xA00D0000, 0xA00D3FFF},      //	PF0 S52
    {0xA00D4000, 0xA00D7FFF},      //	PF0 S53
    {0xA00D8000, 0xA00DBFFF},      //	PF0 S54
    {0xA00DC000, 0xA00DFFFF},      //	PF0 S55
    {0xA00E0000, 0xA00E3FFF},      //	PF0 S56
    {0xA00E4000, 0xA00E7FFF},      //	PF0 S57
    {0xA00E8000, 0xA00EBFFF},      //	PF0 S58
    {0xA00EC000, 0xA00EFFFF},      //	PF0 S59
    {0xA00F0000, 0xA00F3FFF},      //	PF0 S60
    {0xA00F4000, 0xA00F7FFF},      //	PF0 S61
    {0xA00F8000, 0xA00FBFFF},      //	PF0 S62
    {0xA00FC000, 0xA00FFFFF},      //	PF0 S63
    {0xA0100000, 0xA0103FFF},      //	PF0 S64
    {0xA0104000, 0xA0107FFF},      //	PF0 S65
    {0xA0108000, 0xA010BFFF},      //	PF0 S66
    {0xA010C000, 0xA010FFFF},      //	PF0 S67
    {0xA0110000, 0xA0113FFF},      //	PF0 S68
    {0xA0114000, 0xA0117FFF},      //	PF0 S69
    {0xA0118000, 0xA011BFFF},      //	PF0 S70
    {0xA011C000, 0xA011FFFF},      //	PF0 S71
    {0xA0120000, 0xA0123FFF},      //	PF0 S72
    {0xA0124000, 0xA0127FFF},      //	PF0 S73
    {0xA0128000, 0xA012BFFF},      //	PF0 S74
    {0xA012C000, 0xA012FFFF},      //	PF0 S75
    {0xA0130000, 0xA0133FFF},      //	PF0 S76
    {0xA0134000, 0xA0137FFF},      //	PF0 S77
    {0xA0138000, 0xA013BFFF},      //	PF0 S78
    {0xA013C000, 0xA013FFFF},      //	PF0 S79
    {0xA0140000, 0xA0143FFF},      //	PF0 S80
    {0xA0144000, 0xA0147FFF},      //	PF0 S81
    {0xA0148000, 0xA014BFFF},      //	PF0 S82
    {0xA014C000, 0xA014FFFF},      //	PF0 S83
    {0xA0150000, 0xA0153FFF},      //	PF0 S84
    {0xA0154000, 0xA0157FFF},      //	PF0 S85
    {0xA0158000, 0xA015BFFF},      //	PF0 S86
    {0xA015C000, 0xA015FFFF},      //	PF0 S87
    {0xA0160000, 0xA0163FFF},      //	PF0 S88
    {0xA0164000, 0xA0167FFF},      //	PF0 S89
    {0xA0168000, 0xA016BFFF},      //	PF0 S90
    {0xA016C000, 0xA016FFFF},      //	PF0 S91
    {0xA0170000, 0xA0173FFF},      //	PF0 S92
    {0xA0174000, 0xA0177FFF},      //	PF0 S93
    {0xA0178000, 0xA017BFFF},      //	PF0 S94
    {0xA017C000, 0xA017FFFF},      //	PF0 S95
    {0xA0180000, 0xA0183FFF},      //	PF0 S96
    {0xA0184000, 0xA0187FFF},      //	PF0 S97
    {0xA0188000, 0xA018BFFF},      //	PF0 S98
    {0xA018C000, 0xA018FFFF},      //	PF0 S99
    {0xA0190000, 0xA0193FFF},      //	PF0 S100
    {0xA0194000, 0xA0197FFF},      //	PF0 S101
    {0xA0198000, 0xA019BFFF},      //	PF0 S102
    {0xA019C000, 0xA019FFFF},      //	PF0 S103
    {0xA01A0000, 0xA01A3FFF},      //	PF0 S104
    {0xA01A4000, 0xA01A7FFF},      //	PF0 S105
    {0xA01A8000, 0xA01ABFFF},      //	PF0 S106
    {0xA01AC000, 0xA01AFFFF},      //	PF0 S107
    {0xA01B0000, 0xA01B3FFF},      //	PF0 S108
    {0xA01B4000, 0xA01B7FFF},      //	PF0 S109
    {0xA01B8000, 0xA01BBFFF},      //	PF0 S110
    {0xA01BC000, 0xA01BFFFF},      //	PF0 S111
    {0xA01C0000, 0xA01C3FFF},      //	PF0 S112
    {0xA01C4000, 0xA01C7FFF},      //	PF0 S113
    {0xA01C8000, 0xA01CBFFF},      //	PF0 S114
    {0xA01CC000, 0xA01CFFFF},      //	PF0 S115
    {0xA01D0000, 0xA01D3FFF},      //	PF0 S116
    {0xA01D4000, 0xA01D7FFF},      //	PF0 S117
    {0xA01D8000, 0xA01DBFFF},      //	PF0 S118
    {0xA01DC000, 0xA01DFFFF},      //	PF0 S119
    {0xA01E0000, 0xA01E3FFF},      //	PF0 S120
    {0xA01E4000, 0xA01E7FFF},      //	PF0 S121
    {0xA01E8000, 0xA01EBFFF},      //	PF0 S122
    {0xA01EC000, 0xA01EFFFF},      //	PF0 S123
    {0xA01F0000, 0xA01F3FFF},      //	PF0 S124
    {0xA01F4000, 0xA01F7FFF},      //	PF0 S125
    {0xA01F8000, 0xA01FBFFF},      //	PF0 S126
    {0xA01FC000, 0xA01FFFFF},      //	PF0 S127
    {0xA0200000, 0xA0203FFF},      //	PF0 S128
    {0xA0204000, 0xA0207FFF},      //	PF0 S129
    {0xA0208000, 0xA020BFFF},      //	PF0 S130
    {0xA020C000, 0xA020FFFF},      //	PF0 S131
    {0xA0210000, 0xA0213FFF},      //	PF0 S132
    {0xA0214000, 0xA0217FFF},      //	PF0 S133
    {0xA0218000, 0xA021BFFF},      //	PF0 S134
    {0xA021C000, 0xA021FFFF},      //	PF0 S135
    {0xA0220000, 0xA0223FFF},      //	PF0 S136
    {0xA0224000, 0xA0227FFF},      //	PF0 S137
    {0xA0228000, 0xA022BFFF},      //	PF0 S138
    {0xA022C000, 0xA022FFFF},      //	PF0 S139
    {0xA0230000, 0xA0233FFF},      //	PF0 S140
    {0xA0234000, 0xA0237FFF},      //	PF0 S141
    {0xA0238000, 0xA023BFFF},      //	PF0 S142
    {0xA023C000, 0xA023FFFF},      //	PF0 S143
    {0xA0240000, 0xA0243FFF},      //	PF0 S144
    {0xA0244000, 0xA0247FFF},      //	PF0 S145
    {0xA0248000, 0xA024BFFF},      //	PF0 S146
    {0xA024C000, 0xA024FFFF},      //	PF0 S147
    {0xA0250000, 0xA0253FFF},      //	PF0 S148
    {0xA0254000, 0xA0257FFF},      //	PF0 S149
    {0xA0258000, 0xA025BFFF},      //	PF0 S150
    {0xA025C000, 0xA025FFFF},      //	PF0 S151
    {0xA0260000, 0xA0263FFF},      //	PF0 S152
    {0xA0264000, 0xA0267FFF},      //	PF0 S153
    {0xA0268000, 0xA026BFFF},      //	PF0 S154
    {0xA026C000, 0xA026FFFF},      //	PF0 S155
    {0xA0270000, 0xA0273FFF},      //	PF0 S156
    {0xA0274000, 0xA0277FFF},      //	PF0 S157
    {0xA0278000, 0xA027BFFF},      //	PF0 S158
    {0xA027C000, 0xA027FFFF},      //	PF0 S159
    {0xA0280000, 0xA0283FFF},      //	PF0 S160
    {0xA0284000, 0xA0287FFF},      //	PF0 S161
    {0xA0288000, 0xA028BFFF},      //	PF0 S162
    {0xA028C000, 0xA028FFFF},      //	PF0 S163
    {0xA0290000, 0xA0293FFF},      //	PF0 S164
    {0xA0294000, 0xA0297FFF},      //	PF0 S165
    {0xA0298000, 0xA029BFFF},      //	PF0 S166
    {0xA029C000, 0xA029FFFF},      //	PF0 S167
    {0xA02A0000, 0xA02A3FFF},      //	PF0 S168
    {0xA02A4000, 0xA02A7FFF},      //	PF0 S169
    {0xA02A8000, 0xA02ABFFF},      //	PF0 S170
    {0xA02AC000, 0xA02AFFFF},      //	PF0 S171
    {0xA02B0000, 0xA02B3FFF},      //	PF0 S172
    {0xA02B4000, 0xA02B7FFF},      //	PF0 S173
    {0xA02B8000, 0xA02BBFFF},      //	PF0 S174
    {0xA02BC000, 0xA02BFFFF},      //	PF0 S175
    {0xA02C0000, 0xA02C3FFF},      //	PF0 S176
    {0xA02C4000, 0xA02C7FFF},      //	PF0 S177
    {0xA02C8000, 0xA02CBFFF},      //	PF0 S178
    {0xA02CC000, 0xA02CFFFF},      //	PF0 S179
    {0xA02D0000, 0xA02D3FFF},      //	PF0 S180
    {0xA02D4000, 0xA02D7FFF},      //	PF0 S181
    {0xA02D8000, 0xA02DBFFF},      //	PF0 S182
    {0xA02DC000, 0xA02DFFFF},      //	PF0 S183
    {0xA02E0000, 0xA02E3FFF},      //	PF0 S184
    {0xA02E4000, 0xA02E7FFF},      //	PF0 S185
    {0xA02E8000, 0xA02EBFFF},      //	PF0 S186
    {0xA02EC000, 0xA02EFFFF},      //	PF0 S187
    {0xA02F0000, 0xA02F3FFF},      //	PF0 S188
    {0xA02F4000, 0xA02F7FFF},      //	PF0 S189
    {0xA02F8000, 0xA02FBFFF},      //	PF0 S190
    {0xA02FC000, 0xA02FFFFF},      //	PF0 S191
    {0xA0300000, 0xA0303FFF},      //	PF1 S0
    {0xA0304000, 0xA0307FFF},      //	PF1 S1
    {0xA0308000, 0xA030BFFF},      //	PF1 S2
    {0xA030C000, 0xA030FFFF},      //	PF1 S3
    {0xA0310000, 0xA0313FFF},      //	PF1 S4
    {0xA0314000, 0xA0317FFF},      //	PF1 S5
    {0xA0318000, 0xA031BFFF},      //	PF1 S6
    {0xA031C000, 0xA031FFFF},      //	PF1 S7
    {0xA0320000, 0xA0323FFF},      //	PF1 S8
    {0xA0324000, 0xA0327FFF},      //	PF1 S9
    {0xA0328000, 0xA032BFFF},      //	PF1 S10
    {0xA032C000, 0xA032FFFF},      //	PF1 S11
    {0xA0330000, 0xA0333FFF},      //	PF1 S12
    {0xA0334000, 0xA0337FFF},      //	PF1 S13
    {0xA0338000, 0xA033BFFF},      //	PF1 S14
    {0xA033C000, 0xA033FFFF},      //	PF1 S15
    {0xA0340000, 0xA0343FFF},      //	PF1 S16
    {0xA0344000, 0xA0347FFF},      //	PF1 S17
    {0xA0348000, 0xA034BFFF},      //	PF1 S18
    {0xA034C000, 0xA034FFFF},      //	PF1 S19
    {0xA0350000, 0xA0353FFF},      //	PF1 S20
    {0xA0354000, 0xA0357FFF},      //	PF1 S21
    {0xA0358000, 0xA035BFFF},      //	PF1 S22
    {0xA035C000, 0xA035FFFF},      //	PF1 S23
    {0xA0360000, 0xA0363FFF},      //	PF1 S24
    {0xA0364000, 0xA0367FFF},      //	PF1 S25
    {0xA0368000, 0xA036BFFF},      //	PF1 S26
    {0xA036C000, 0xA036FFFF},      //	PF1 S27
    {0xA0370000, 0xA0373FFF},      //	PF1 S28
    {0xA0374000, 0xA0377FFF},      //	PF1 S29
    {0xA0378000, 0xA037BFFF},      //	PF1 S30
    {0xA037C000, 0xA037FFFF},      //	PF1 S31
    {0xA0380000, 0xA0383FFF},      //	PF1 S32
    {0xA0384000, 0xA0387FFF},      //	PF1 S33
    {0xA0388000, 0xA038BFFF},      //	PF1 S34
    {0xA038C000, 0xA038FFFF},      //	PF1 S35
    {0xA0390000, 0xA0393FFF},      //	PF1 S36
    {0xA0394000, 0xA0397FFF},      //	PF1 S37
    {0xA0398000, 0xA039BFFF},      //	PF1 S38
    {0xA039C000, 0xA039FFFF},      //	PF1 S39
    {0xA03A0000, 0xA03A3FFF},      //	PF1 S40
    {0xA03A4000, 0xA03A7FFF},      //	PF1 S41
    {0xA03A8000, 0xA03ABFFF},      //	PF1 S42
    {0xA03AC000, 0xA03AFFFF},      //	PF1 S43
    {0xA03B0000, 0xA03B3FFF},      //	PF1 S44
    {0xA03B4000, 0xA03B7FFF},      //	PF1 S45
    {0xA03B8000, 0xA03BBFFF},      //	PF1 S46
    {0xA03BC000, 0xA03BFFFF},      //	PF1 S47
    {0xA03C0000, 0xA03C3FFF},      //	PF1 S48
    {0xA03C4000, 0xA03C7FFF},      //	PF1 S49
    {0xA03C8000, 0xA03CBFFF},      //	PF1 S50
    {0xA03CC000, 0xA03CFFFF},      //	PF1 S51
    {0xA03D0000, 0xA03D3FFF},      //	PF1 S52
    {0xA03D4000, 0xA03D7FFF},      //	PF1 S53
    {0xA03D8000, 0xA03DBFFF},      //	PF1 S54
    {0xA03DC000, 0xA03DFFFF},      //	PF1 S55
    {0xA03E0000, 0xA03E3FFF},      //	PF1 S56
    {0xA03E4000, 0xA03E7FFF},      //	PF1 S57
    {0xA03E8000, 0xA03EBFFF},      //	PF1 S58
    {0xA03EC000, 0xA03EFFFF},      //	PF1 S59
    {0xA03F0000, 0xA03F3FFF},      //	PF1 S60
    {0xA03F4000, 0xA03F7FFF},      //	PF1 S61
    {0xA03F8000, 0xA03FBFFF},      //	PF1 S62
    {0xA03FC000, 0xA03FFFFF},      //	PF1 S63
    {0xA0400000, 0xA0403FFF},      //	PF1 S64
    {0xA0404000, 0xA0407FFF},      //	PF1 S65
    {0xA0408000, 0xA040BFFF},      //	PF1 S66
    {0xA040C000, 0xA040FFFF},      //	PF1 S67
    {0xA0410000, 0xA0413FFF},      //	PF1 S68
    {0xA0414000, 0xA0417FFF},      //	PF1 S69
    {0xA0418000, 0xA041BFFF},      //	PF1 S70
    {0xA041C000, 0xA041FFFF},      //	PF1 S71
    {0xA0420000, 0xA0423FFF},      //	PF1 S72
    {0xA0424000, 0xA0427FFF},      //	PF1 S73
    {0xA0428000, 0xA042BFFF},      //	PF1 S74
    {0xA042C000, 0xA042FFFF},      //	PF1 S75
    {0xA0430000, 0xA0433FFF},      //	PF1 S76
    {0xA0434000, 0xA0437FFF},      //	PF1 S77
    {0xA0438000, 0xA043BFFF},      //	PF1 S78
    {0xA043C000, 0xA043FFFF},      //	PF1 S79
    {0xA0440000, 0xA0443FFF},      //	PF1 S80
    {0xA0444000, 0xA0447FFF},      //	PF1 S81
    {0xA0448000, 0xA044BFFF},      //	PF1 S82
    {0xA044C000, 0xA044FFFF},      //	PF1 S83
    {0xA0450000, 0xA0453FFF},      //	PF1 S84
    {0xA0454000, 0xA0457FFF},      //	PF1 S85
    {0xA0458000, 0xA045BFFF},      //	PF1 S86
    {0xA045C000, 0xA045FFFF},      //	PF1 S87
    {0xA0460000, 0xA0463FFF},      //	PF1 S88
    {0xA0464000, 0xA0467FFF},      //	PF1 S89
    {0xA0468000, 0xA046BFFF},      //	PF1 S90
    {0xA046C000, 0xA046FFFF},      //	PF1 S91
    {0xA0470000, 0xA0473FFF},      //	PF1 S92
    {0xA0474000, 0xA0477FFF},      //	PF1 S93
    {0xA0478000, 0xA047BFFF},      //	PF1 S94
    {0xA047C000, 0xA047FFFF},      //	PF1 S95
    {0xA0480000, 0xA0483FFF},      //	PF1 S96
    {0xA0484000, 0xA0487FFF},      //	PF1 S97
    {0xA0488000, 0xA048BFFF},      //	PF1 S98
    {0xA048C000, 0xA048FFFF},      //	PF1 S99
    {0xA0490000, 0xA0493FFF},      //	PF1 S100
    {0xA0494000, 0xA0497FFF},      //	PF1 S101
    {0xA0498000, 0xA049BFFF},      //	PF1 S102
    {0xA049C000, 0xA049FFFF},      //	PF1 S103
    {0xA04A0000, 0xA04A3FFF},      //	PF1 S104
    {0xA04A4000, 0xA04A7FFF},      //	PF1 S105
    {0xA04A8000, 0xA04ABFFF},      //	PF1 S106
    {0xA04AC000, 0xA04AFFFF},      //	PF1 S107
    {0xA04B0000, 0xA04B3FFF},      //	PF1 S108
    {0xA04B4000, 0xA04B7FFF},      //	PF1 S109
    {0xA04B8000, 0xA04BBFFF},      //	PF1 S110
    {0xA04BC000, 0xA04BFFFF},      //	PF1 S111
    {0xA04C0000, 0xA04C3FFF},      //	PF1 S112
    {0xA04C4000, 0xA04C7FFF},      //	PF1 S113
    {0xA04C8000, 0xA04CBFFF},      //	PF1 S114
    {0xA04CC000, 0xA04CFFFF},      //	PF1 S115
    {0xA04D0000, 0xA04D3FFF},      //	PF1 S116
    {0xA04D4000, 0xA04D7FFF},      //	PF1 S117
    {0xA04D8000, 0xA04DBFFF},      //	PF1 S118
    {0xA04DC000, 0xA04DFFFF},      //	PF1 S119
    {0xA04E0000, 0xA04E3FFF},      //	PF1 S120
    {0xA04E4000, 0xA04E7FFF},      //	PF1 S121
    {0xA04E8000, 0xA04EBFFF},      //	PF1 S122
    {0xA04EC000, 0xA04EFFFF},      //	PF1 S123
    {0xA04F0000, 0xA04F3FFF},      //	PF1 S124
    {0xA04F4000, 0xA04F7FFF},      //	PF1 S125
    {0xA04F8000, 0xA04FBFFF},      //	PF1 S126
    {0xA04FC000, 0xA04FFFFF},      //	PF1 S127
    {0xA0500000, 0xA0503FFF},      //	PF1 S128
    {0xA0504000, 0xA0507FFF},      //	PF1 S129
    {0xA0508000, 0xA050BFFF},      //	PF1 S130
    {0xA050C000, 0xA050FFFF},      //	PF1 S131
    {0xA0510000, 0xA0513FFF},      //	PF1 S132
    {0xA0514000, 0xA0517FFF},      //	PF1 S133
    {0xA0518000, 0xA051BFFF},      //	PF1 S134
    {0xA051C000, 0xA051FFFF},      //	PF1 S135
    {0xA0520000, 0xA0523FFF},      //	PF1 S136
    {0xA0524000, 0xA0527FFF},      //	PF1 S137
    {0xA0528000, 0xA052BFFF},      //	PF1 S138
    {0xA052C000, 0xA052FFFF},      //	PF1 S139
    {0xA0530000, 0xA0533FFF},      //	PF1 S140
    {0xA0534000, 0xA0537FFF},      //	PF1 S141
    {0xA0538000, 0xA053BFFF},      //	PF1 S142
    {0xA053C000, 0xA053FFFF},      //	PF1 S143
    {0xA0540000, 0xA0543FFF},      //	PF1 S144
    {0xA0544000, 0xA0547FFF},      //	PF1 S145
    {0xA0548000, 0xA054BFFF},      //	PF1 S146
    {0xA054C000, 0xA054FFFF},      //	PF1 S147
    {0xA0550000, 0xA0553FFF},      //	PF1 S148
    {0xA0554000, 0xA0557FFF},      //	PF1 S149
    {0xA0558000, 0xA055BFFF},      //	PF1 S150
    {0xA055C000, 0xA055FFFF},      //	PF1 S151
    {0xA0560000, 0xA0563FFF},      //	PF1 S152
    {0xA0564000, 0xA0567FFF},      //	PF1 S153
    {0xA0568000, 0xA056BFFF},      //	PF1 S154
    {0xA056C000, 0xA056FFFF},      //	PF1 S155
    {0xA0570000, 0xA0573FFF},      //	PF1 S156
    {0xA0574000, 0xA0577FFF},      //	PF1 S157
    {0xA0578000, 0xA057BFFF},      //	PF1 S158
    {0xA057C000, 0xA057FFFF},      //	PF1 S159
    {0xA0580000, 0xA0583FFF},      //	PF1 S160
    {0xA0584000, 0xA0587FFF},      //	PF1 S161
    {0xA0588000, 0xA058BFFF},      //	PF1 S162
    {0xA058C000, 0xA058FFFF},      //	PF1 S163
    {0xA0590000, 0xA0593FFF},      //	PF1 S164
    {0xA0594000, 0xA0597FFF},      //	PF1 S165
    {0xA0598000, 0xA059BFFF},      //	PF1 S166
    {0xA059C000, 0xA059FFFF},      //	PF1 S167
    {0xA05A0000, 0xA05A3FFF},      //	PF1 S168
    {0xA05A4000, 0xA05A7FFF},      //	PF1 S169
    {0xA05A8000, 0xA05ABFFF},      //	PF1 S170
    {0xA05AC000, 0xA05AFFFF},      //	PF1 S171
    {0xA05B0000, 0xA05B3FFF},      //	PF1 S172
    {0xA05B4000, 0xA05B7FFF},      //	PF1 S173
    {0xA05B8000, 0xA05BBFFF},      //	PF1 S174
    {0xA05BC000, 0xA05BFFFF},      //	PF1 S175
    {0xA05C0000, 0xA05C3FFF},      //	PF1 S176
    {0xA05C4000, 0xA05C7FFF},      //	PF1 S177
    {0xA05C8000, 0xA05CBFFF},      //	PF1 S178
    {0xA05CC000, 0xA05CFFFF},      //	PF1 S179
    {0xA05D0000, 0xA05D3FFF},      //	PF1 S180
    {0xA05D4000, 0xA05D7FFF},      //	PF1 S181
    {0xA05D8000, 0xA05DBFFF},      //	PF1 S182
    {0xA05DC000, 0xA05DFFFF},      //	PF1 S183
    {0xA05E0000, 0xA05E3FFF},      //	PF1 S184
    {0xA05E4000, 0xA05E7FFF},      //	PF1 S185
    {0xA05E8000, 0xA05EBFFF},      //	PF1 S186
    {0xA05EC000, 0xA05EFFFF},      //	PF1 S187
    {0xA05F0000, 0xA05F3FFF},      //	PF1 S188
    {0xA05F4000, 0xA05F7FFF},      //	PF1 S189
    {0xA05F8000, 0xA05FBFFF},      //	PF1 S190
    {0xA05FC000, 0xA05FFFFF},      //	PF1 S191
    {0xA0600000, 0xA0603FFF},      //	PF2 S0
    {0xA0604000, 0xA0607FFF},      //	PF2 S1
    {0xA0608000, 0xA060BFFF},      //	PF2 S2
    {0xA060C000, 0xA060FFFF},      //	PF2 S3
    {0xA0610000, 0xA0613FFF},      //	PF2 S4
    {0xA0614000, 0xA0617FFF},      //	PF2 S5
    {0xA0618000, 0xA061BFFF},      //	PF2 S6
    {0xA061C000, 0xA061FFFF},      //	PF2 S7
    {0xA0620000, 0xA0623FFF},      //	PF2 S8
    {0xA0624000, 0xA0627FFF},      //	PF2 S9
    {0xA0628000, 0xA062BFFF},      //	PF2 S10
    {0xA062C000, 0xA062FFFF},      //	PF2 S11
    {0xA0630000, 0xA0633FFF},      //	PF2 S12
    {0xA0634000, 0xA0637FFF},      //	PF2 S13
    {0xA0638000, 0xA063BFFF},      //	PF2 S14
    {0xA063C000, 0xA063FFFF},      //	PF2 S15
    {0xA0640000, 0xA0643FFF},      //	PF2 S16
    {0xA0644000, 0xA0647FFF},      //	PF2 S17
    {0xA0648000, 0xA064BFFF},      //	PF2 S18
    {0xA064C000, 0xA064FFFF},      //	PF2 S19
    {0xA0650000, 0xA0653FFF},      //	PF2 S20
    {0xA0654000, 0xA0657FFF},      //	PF2 S21
    {0xA0658000, 0xA065BFFF},      //	PF2 S22
    {0xA065C000, 0xA065FFFF},      //	PF2 S23
    {0xA0660000, 0xA0663FFF},      //	PF2 S24
    {0xA0664000, 0xA0667FFF},      //	PF2 S25
    {0xA0668000, 0xA066BFFF},      //	PF2 S26
    {0xA066C000, 0xA066FFFF},      //	PF2 S27
    {0xA0670000, 0xA0673FFF},      //	PF2 S28
    {0xA0674000, 0xA0677FFF},      //	PF2 S29
    {0xA0678000, 0xA067BFFF},      //	PF2 S30
    {0xA067C000, 0xA067FFFF},      //	PF2 S31
    {0xA0680000, 0xA0683FFF},      //	PF2 S32
    {0xA0684000, 0xA0687FFF},      //	PF2 S33
    {0xA0688000, 0xA068BFFF},      //	PF2 S34
    {0xA068C000, 0xA068FFFF},      //	PF2 S35
    {0xA0690000, 0xA0693FFF},      //	PF2 S36
    {0xA0694000, 0xA0697FFF},      //	PF2 S37
    {0xA0698000, 0xA069BFFF},      //	PF2 S38
    {0xA069C000, 0xA069FFFF},      //	PF2 S39
    {0xA06A0000, 0xA06A3FFF},      //	PF2 S40
    {0xA06A4000, 0xA06A7FFF},      //	PF2 S41
    {0xA06A8000, 0xA06ABFFF},      //	PF2 S42
    {0xA06AC000, 0xA06AFFFF},      //	PF2 S43
    {0xA06B0000, 0xA06B3FFF},      //	PF2 S44
    {0xA06B4000, 0xA06B7FFF},      //	PF2 S45
    {0xA06B8000, 0xA06BBFFF},      //	PF2 S46
    {0xA06BC000, 0xA06BFFFF},      //	PF2 S47
    {0xA06C0000, 0xA06C3FFF},      //	PF2 S48
    {0xA06C4000, 0xA06C7FFF},      //	PF2 S49
    {0xA06C8000, 0xA06CBFFF},      //	PF2 S50
    {0xA06CC000, 0xA06CFFFF},      //	PF2 S51
    {0xA06D0000, 0xA06D3FFF},      //	PF2 S52
    {0xA06D4000, 0xA06D7FFF},      //	PF2 S53
    {0xA06D8000, 0xA06DBFFF},      //	PF2 S54
    {0xA06DC000, 0xA06DFFFF},      //	PF2 S55
    {0xA06E0000, 0xA06E3FFF},      //	PF2 S56
    {0xA06E4000, 0xA06E7FFF},      //	PF2 S57
    {0xA06E8000, 0xA06EBFFF},      //	PF2 S58
    {0xA06EC000, 0xA06EFFFF},      //	PF2 S59
    {0xA06F0000, 0xA06F3FFF},      //	PF2 S60
    {0xA06F4000, 0xA06F7FFF},      //	PF2 S61
    {0xA06F8000, 0xA06FBFFF},      //	PF2 S62
    {0xA06FC000, 0xA06FFFFF},      //	PF2 S63
    {0xA0700000, 0xA0703FFF},      //	PF2 S64
    {0xA0704000, 0xA0707FFF},      //	PF2 S65
    {0xA0708000, 0xA070BFFF},      //	PF2 S66
    {0xA070C000, 0xA070FFFF},      //	PF2 S67
    {0xA0710000, 0xA0713FFF},      //	PF2 S68
    {0xA0714000, 0xA0717FFF},      //	PF2 S69
    {0xA0718000, 0xA071BFFF},      //	PF2 S70
    {0xA071C000, 0xA071FFFF},      //	PF2 S71
    {0xA0720000, 0xA0723FFF},      //	PF2 S72
    {0xA0724000, 0xA0727FFF},      //	PF2 S73
    {0xA0728000, 0xA072BFFF},      //	PF2 S74
    {0xA072C000, 0xA072FFFF},      //	PF2 S75
    {0xA0730000, 0xA0733FFF},      //	PF2 S76
    {0xA0734000, 0xA0737FFF},      //	PF2 S77
    {0xA0738000, 0xA073BFFF},      //	PF2 S78
    {0xA073C000, 0xA073FFFF},      //	PF2 S79
    {0xA0740000, 0xA0743FFF},      //	PF2 S80
    {0xA0744000, 0xA0747FFF},      //	PF2 S81
    {0xA0748000, 0xA074BFFF},      //	PF2 S82
    {0xA074C000, 0xA074FFFF},      //	PF2 S83
    {0xA0750000, 0xA0753FFF},      //	PF2 S84
    {0xA0754000, 0xA0757FFF},      //	PF2 S85
    {0xA0758000, 0xA075BFFF},      //	PF2 S86
    {0xA075C000, 0xA075FFFF},      //	PF2 S87
    {0xA0760000, 0xA0763FFF},      //	PF2 S88
    {0xA0764000, 0xA0767FFF},      //	PF2 S89
    {0xA0768000, 0xA076BFFF},      //	PF2 S90
    {0xA076C000, 0xA076FFFF},      //	PF2 S91
    {0xA0770000, 0xA0773FFF},      //	PF2 S92
    {0xA0774000, 0xA0777FFF},      //	PF2 S93
    {0xA0778000, 0xA077BFFF},      //	PF2 S94
    {0xA077C000, 0xA077FFFF},      //	PF2 S95
    {0xA0780000, 0xA0783FFF},      //	PF2 S96
    {0xA0784000, 0xA0787FFF},      //	PF2 S97
    {0xA0788000, 0xA078BFFF},      //	PF2 S98
    {0xA078C000, 0xA078FFFF},      //	PF2 S99
    {0xA0790000, 0xA0793FFF},      //	PF2 S100
    {0xA0794000, 0xA0797FFF},      //	PF2 S101
    {0xA0798000, 0xA079BFFF},      //	PF2 S102
    {0xA079C000, 0xA079FFFF},      //	PF2 S103
    {0xA07A0000, 0xA07A3FFF},      //	PF2 S104
    {0xA07A4000, 0xA07A7FFF},      //	PF2 S105
    {0xA07A8000, 0xA07ABFFF},      //	PF2 S106
    {0xA07AC000, 0xA07AFFFF},      //	PF2 S107
    {0xA07B0000, 0xA07B3FFF},      //	PF2 S108
    {0xA07B4000, 0xA07B7FFF},      //	PF2 S109
    {0xA07B8000, 0xA07BBFFF},      //	PF2 S110
    {0xA07BC000, 0xA07BFFFF},      //	PF2 S111
    {0xA07C0000, 0xA07C3FFF},      //	PF2 S112
    {0xA07C4000, 0xA07C7FFF},      //	PF2 S113
    {0xA07C8000, 0xA07CBFFF},      //	PF2 S114
    {0xA07CC000, 0xA07CFFFF},      //	PF2 S115
    {0xA07D0000, 0xA07D3FFF},      //	PF2 S116
    {0xA07D4000, 0xA07D7FFF},      //	PF2 S117
    {0xA07D8000, 0xA07DBFFF},      //	PF2 S118
    {0xA07DC000, 0xA07DFFFF},      //	PF2 S119
    {0xA07E0000, 0xA07E3FFF},      //	PF2 S120
    {0xA07E4000, 0xA07E7FFF},      //	PF2 S121
    {0xA07E8000, 0xA07EBFFF},      //	PF2 S122
    {0xA07EC000, 0xA07EFFFF},      //	PF2 S123
    {0xA07F0000, 0xA07F3FFF},      //	PF2 S124
    {0xA07F4000, 0xA07F7FFF},      //	PF2 S125
    {0xA07F8000, 0xA07FBFFF},      //	PF2 S126
    {0xA07FC000, 0xA07FFFFF},      //	PF2 S127
    {0xA0800000, 0xA0803FFF},      //	PF2 S128
    {0xA0804000, 0xA0807FFF},      //	PF2 S129
    {0xA0808000, 0xA080BFFF},      //	PF2 S130
    {0xA080C000, 0xA080FFFF},      //	PF2 S131
    {0xA0810000, 0xA0813FFF},      //	PF2 S132
    {0xA0814000, 0xA0817FFF},      //	PF2 S133
    {0xA0818000, 0xA081BFFF},      //	PF2 S134
    {0xA081C000, 0xA081FFFF},      //	PF2 S135
    {0xA0820000, 0xA0823FFF},      //	PF2 S136
    {0xA0824000, 0xA0827FFF},      //	PF2 S137
    {0xA0828000, 0xA082BFFF},      //	PF2 S138
    {0xA082C000, 0xA082FFFF},      //	PF2 S139
    {0xA0830000, 0xA0833FFF},      //	PF2 S140
    {0xA0834000, 0xA0837FFF},      //	PF2 S141
    {0xA0838000, 0xA083BFFF},      //	PF2 S142
    {0xA083C000, 0xA083FFFF},      //	PF2 S143
    {0xA0840000, 0xA0843FFF},      //	PF2 S144
    {0xA0844000, 0xA0847FFF},      //	PF2 S145
    {0xA0848000, 0xA084BFFF},      //	PF2 S146
    {0xA084C000, 0xA084FFFF},      //	PF2 S147
    {0xA0850000, 0xA0853FFF},      //	PF2 S148
    {0xA0854000, 0xA0857FFF},      //	PF2 S149
    {0xA0858000, 0xA085BFFF},      //	PF2 S150
    {0xA085C000, 0xA085FFFF},      //	PF2 S151
    {0xA0860000, 0xA0863FFF},      //	PF2 S152
    {0xA0864000, 0xA0867FFF},      //	PF2 S153
    {0xA0868000, 0xA086BFFF},      //	PF2 S154
    {0xA086C000, 0xA086FFFF},      //	PF2 S155
    {0xA0870000, 0xA0873FFF},      //	PF2 S156
    {0xA0874000, 0xA0877FFF},      //	PF2 S157
    {0xA0878000, 0xA087BFFF},      //	PF2 S158
    {0xA087C000, 0xA087FFFF},      //	PF2 S159
    {0xA0880000, 0xA0883FFF},      //	PF2 S160
    {0xA0884000, 0xA0887FFF},      //	PF2 S161
    {0xA0888000, 0xA088BFFF},      //	PF2 S162
    {0xA088C000, 0xA088FFFF},      //	PF2 S163
    {0xA0890000, 0xA0893FFF},      //	PF2 S164
    {0xA0894000, 0xA0897FFF},      //	PF2 S165
    {0xA0898000, 0xA089BFFF},      //	PF2 S166
    {0xA089C000, 0xA089FFFF},      //	PF2 S167
    {0xA08A0000, 0xA08A3FFF},      //	PF2 S168
    {0xA08A4000, 0xA08A7FFF},      //	PF2 S169
    {0xA08A8000, 0xA08ABFFF},      //	PF2 S170
    {0xA08AC000, 0xA08AFFFF},      //	PF2 S171
    {0xA08B0000, 0xA08B3FFF},      //	PF2 S172
    {0xA08B4000, 0xA08B7FFF},      //	PF2 S173
    {0xA08B8000, 0xA08BBFFF},      //	PF2 S174
    {0xA08BC000, 0xA08BFFFF},      //	PF2 S175
    {0xA08C0000, 0xA08C3FFF},      //	PF2 S176
    {0xA08C4000, 0xA08C7FFF},      //	PF2 S177
    {0xA08C8000, 0xA08CBFFF},      //	PF2 S178
    {0xA08CC000, 0xA08CFFFF},      //	PF2 S179
    {0xA08D0000, 0xA08D3FFF},      //	PF2 S180
    {0xA08D4000, 0xA08D7FFF},      //	PF2 S181
    {0xA08D8000, 0xA08DBFFF},      //	PF2 S182
    {0xA08DC000, 0xA08DFFFF},      //	PF2 S183
    {0xA08E0000, 0xA08E3FFF},      //	PF2 S184
    {0xA08E4000, 0xA08E7FFF},      //	PF2 S185
    {0xA08E8000, 0xA08EBFFF},      //	PF2 S186
    {0xA08EC000, 0xA08EFFFF},      //	PF2 S187
    {0xA08F0000, 0xA08F3FFF},      //	PF2 S188
    {0xA08F4000, 0xA08F7FFF},      //	PF2 S189
    {0xA08F8000, 0xA08FBFFF},      //	PF2 S190
    {0xA08FC000, 0xA08FFFFF},      //	PF2 S191
    {0xA0900000, 0xA0903FFF},      //	PF3 S0
    {0xA0904000, 0xA0907FFF},      //	PF3 S1
    {0xA0908000, 0xA090BFFF},      //	PF3 S2
    {0xA090C000, 0xA090FFFF},      //	PF3 S3
    {0xA0910000, 0xA0913FFF},      //	PF3 S4
    {0xA0914000, 0xA0917FFF},      //	PF3 S5
    {0xA0918000, 0xA091BFFF},      //	PF3 S6
    {0xA091C000, 0xA091FFFF},      //	PF3 S7
    {0xA0920000, 0xA0923FFF},      //	PF3 S8
    {0xA0924000, 0xA0927FFF},      //	PF3 S9
    {0xA0928000, 0xA092BFFF},      //	PF3 S10
    {0xA092C000, 0xA092FFFF},      //	PF3 S11
    {0xA0930000, 0xA0933FFF},      //	PF3 S12
    {0xA0934000, 0xA0937FFF},      //	PF3 S13
    {0xA0938000, 0xA093BFFF},      //	PF3 S14
    {0xA093C000, 0xA093FFFF},      //	PF3 S15
    {0xA0940000, 0xA0943FFF},      //	PF3 S16
    {0xA0944000, 0xA0947FFF},      //	PF3 S17
    {0xA0948000, 0xA094BFFF},      //	PF3 S18
    {0xA094C000, 0xA094FFFF},      //	PF3 S19
    {0xA0950000, 0xA0953FFF},      //	PF3 S20
    {0xA0954000, 0xA0957FFF},      //	PF3 S21
    {0xA0958000, 0xA095BFFF},      //	PF3 S22
    {0xA095C000, 0xA095FFFF},      //	PF3 S23
    {0xA0960000, 0xA0963FFF},      //	PF3 S24
    {0xA0964000, 0xA0967FFF},      //	PF3 S25
    {0xA0968000, 0xA096BFFF},      //	PF3 S26
    {0xA096C000, 0xA096FFFF},      //	PF3 S27
    {0xA0970000, 0xA0973FFF},      //	PF3 S28
    {0xA0974000, 0xA0977FFF},      //	PF3 S29
    {0xA0978000, 0xA097BFFF},      //	PF3 S30
    {0xA097C000, 0xA097FFFF},      //	PF3 S31
    {0xA0980000, 0xA0983FFF},      //	PF3 S32
    {0xA0984000, 0xA0987FFF},      //	PF3 S33
    {0xA0988000, 0xA098BFFF},      //	PF3 S34
    {0xA098C000, 0xA098FFFF},      //	PF3 S35
    {0xA0990000, 0xA0993FFF},      //	PF3 S36
    {0xA0994000, 0xA0997FFF},      //	PF3 S37
    {0xA0998000, 0xA099BFFF},      //	PF3 S38
    {0xA099C000, 0xA099FFFF},      //	PF3 S39
    {0xA09A0000, 0xA09A3FFF},      //	PF3 S40
    {0xA09A4000, 0xA09A7FFF},      //	PF3 S41
    {0xA09A8000, 0xA09ABFFF},      //	PF3 S42
    {0xA09AC000, 0xA09AFFFF},      //	PF3 S43
    {0xA09B0000, 0xA09B3FFF},      //	PF3 S44
    {0xA09B4000, 0xA09B7FFF},      //	PF3 S45
    {0xA09B8000, 0xA09BBFFF},      //	PF3 S46
    {0xA09BC000, 0xA09BFFFF},      //	PF3 S47
    {0xA09C0000, 0xA09C3FFF},      //	PF3 S48
    {0xA09C4000, 0xA09C7FFF},      //	PF3 S49
    {0xA09C8000, 0xA09CBFFF},      //	PF3 S50
    {0xA09CC000, 0xA09CFFFF},      //	PF3 S51
    {0xA09D0000, 0xA09D3FFF},      //	PF3 S52
    {0xA09D4000, 0xA09D7FFF},      //	PF3 S53
    {0xA09D8000, 0xA09DBFFF},      //	PF3 S54
    {0xA09DC000, 0xA09DFFFF},      //	PF3 S55
    {0xA09E0000, 0xA09E3FFF},      //	PF3 S56
    {0xA09E4000, 0xA09E7FFF},      //	PF3 S57
    {0xA09E8000, 0xA09EBFFF},      //	PF3 S58
    {0xA09EC000, 0xA09EFFFF},      //	PF3 S59
    {0xA09F0000, 0xA09F3FFF},      //	PF3 S60
    {0xA09F4000, 0xA09F7FFF},      //	PF3 S61
    {0xA09F8000, 0xA09FBFFF},      //	PF3 S62
    {0xA09FC000, 0xA09FFFFF},      //	PF3 S63

    {0xA0A00000, 0xA0A03FFF},      //	PF3 S64
    {0xA0A04000, 0xA0A07FFF},      //	PF3 S65
    {0xA0A08000, 0xA0A0BFFF},      //	PF3 S66
    {0xA0A0C000, 0xA0A0FFFF},      //	PF3 S67
    {0xA0A10000, 0xA0A13FFF},      //	PF3 S68
    {0xA0A14000, 0xA0A17FFF},      //	PF3 S69
    {0xA0A18000, 0xA0A1BFFF},      //	PF3 S70
    {0xA0A1C000, 0xA0A1FFFF},      //	PF3 S71
    {0xA0A20000, 0xA0A23FFF},      //	PF3 S72
    {0xA0A24000, 0xA0A27FFF},      //	PF3 S73
    {0xA0A28000, 0xA0A2BFFF},      //	PF3 S74
    {0xA0A2C000, 0xA0A2FFFF},      //	PF3 S75
    {0xA0A30000, 0xA0A33FFF},      //	PF3 S76
    {0xA0A34000, 0xA0A37FFF},      //	PF3 S77
    {0xA0A38000, 0xA0A3BFFF},      //	PF3 S78
    {0xA0A3C000, 0xA0A3FFFF},      //	PF3 S79
    {0xA0A40000, 0xA0A43FFF},      //	PF3 S80
    {0xA0A44000, 0xA0A47FFF},      //	PF3 S81
    {0xA0A48000, 0xA0A4BFFF},      //	PF3 S82
    {0xA0A4C000, 0xA0A4FFFF},      //	PF3 S83
    {0xA0A50000, 0xA0A53FFF},      //	PF3 S84
    {0xA0A54000, 0xA0A57FFF},      //	PF3 S85
    {0xA0A58000, 0xA0A5BFFF},      //	PF3 S86
    {0xA0A5C000, 0xA0A5FFFF},      //	PF3 S87
    {0xA0A60000, 0xA0A63FFF},      //	PF3 S88
    {0xA0A64000, 0xA0A67FFF},      //	PF3 S89
    {0xA0A68000, 0xA0A6BFFF},      //	PF3 S90
    {0xA0A6C000, 0xA0A6FFFF},      //	PF3 S91
    {0xA0A70000, 0xA0A73FFF},      //	PF3 S92
    {0xA0A74000, 0xA0A77FFF},      //	PF3 S93
    {0xA0A78000, 0xA0A7BFFF},      //	PF3 S94
    {0xA0A7C000, 0xA0A7FFFF},      //	PF3 S95
    {0xA0A80000, 0xA0A83FFF},      //	PF3 S96
    {0xA0A84000, 0xA0A87FFF},      //	PF3 S97
    {0xA0A88000, 0xA0A8BFFF},      //	PF3 S98
    {0xA0A8C000, 0xA0A8FFFF},      //	PF3 S99
    {0xA0A90000, 0xA0A93FFF},      //	PF3 S100
    {0xA0A94000, 0xA0A97FFF},      //	PF3 S101
    {0xA0A98000, 0xA0A9BFFF},      //	PF3 S102
    {0xA0A9C000, 0xA0A9FFFF},      //	PF3 S103
    {0xA0AA0000, 0xA0AA3FFF},      //	PF3 S104
    {0xA0AA4000, 0xA0AA7FFF},      //	PF3 S105
    {0xA0AA8000, 0xA0AABFFF},      //	PF3 S106
    {0xA0AAC000, 0xA0AAFFFF},      //	PF3 S107
    {0xA0AB0000, 0xA0AB3FFF},      //	PF3 S108
    {0xA0AB4000, 0xA0AB7FFF},      //	PF3 S109
    {0xA0AB8000, 0xA0ABBFFF},      //	PF3 S110
    {0xA0ABC000, 0xA0ABFFFF},      //	PF3 S111
    {0xA0AC0000, 0xA0AC3FFF},      //	PF3 S112
    {0xA0AC4000, 0xA0AC7FFF},      //	PF3 S113
    {0xA0AC8000, 0xA0ACBFFF},      //	PF3 S114
    {0xA0ACC000, 0xA0ACFFFF},      //	PF3 S115
    {0xA0AD0000, 0xA0AD3FFF},      //	PF3 S116
    {0xA0AD4000, 0xA0AD7FFF},      //	PF3 S117
    {0xA0AD8000, 0xA0ADBFFF},      //	PF3 S118
    {0xA0ADC000, 0xA0ADFFFF},      //	PF3 S119
    {0xA0AE0000, 0xA0AE3FFF},      //	PF3 S120
    {0xA0AE4000, 0xA0AE7FFF},      //	PF3 S121
    {0xA0AE8000, 0xA0AEBFFF},      //	PF3 S122
    {0xA0AEC000, 0xA0AEFFFF},      //	PF3 S123
    {0xA0AF0000, 0xA0AF3FFF},      //	PF3 S124
    {0xA0AF4000, 0xA0AF7FFF},      //	PF3 S125
    {0xA0AF8000, 0xA0AFBFFF},      //	PF3 S126
    {0xA0AFC000, 0xA0AFFFFF},      //	PF3 S127
    {0xA0B00000, 0xA0B03FFF},      //	PF3 S128
    {0xA0B04000, 0xA0B07FFF},      //	PF3 S129
    {0xA0B08000, 0xA0B0BFFF},      //	PF3 S130
    {0xA0B0C000, 0xA0B0FFFF},      //	PF3 S131
    {0xA0B10000, 0xA0B13FFF},      //	PF3 S132
    {0xA0B14000, 0xA0B17FFF},      //	PF3 S133
    {0xA0B18000, 0xA0B1BFFF},      //	PF3 S134
    {0xA0B1C000, 0xA0B1FFFF},      //	PF3 S135
    {0xA0B20000, 0xA0B23FFF},      //	PF3 S136
    {0xA0B24000, 0xA0B27FFF},      //	PF3 S137
    {0xA0B28000, 0xA0B2BFFF},      //	PF3 S138
    {0xA0B2C000, 0xA0B2FFFF},      //	PF3 S139
    {0xA0B30000, 0xA0B33FFF},      //	PF3 S140
    {0xA0B34000, 0xA0B37FFF},      //	PF3 S141
    {0xA0B38000, 0xA0B3BFFF},      //	PF3 S142
    {0xA0B3C000, 0xA0B3FFFF},      //	PF3 S143
    {0xA0B40000, 0xA0B43FFF},      //	PF3 S144
    {0xA0B44000, 0xA0B47FFF},      //	PF3 S145
    {0xA0B48000, 0xA0B4BFFF},      //	PF3 S146
    {0xA0B4C000, 0xA0B4FFFF},      //	PF3 S147
    {0xA0B50000, 0xA0B53FFF},      //	PF3 S148
    {0xA0B54000, 0xA0B57FFF},      //	PF3 S149
    {0xA0B58000, 0xA0B5BFFF},      //	PF3 S150
    {0xA0B5C000, 0xA0B5FFFF},      //	PF3 S151
    {0xA0B60000, 0xA0B63FFF},      //	PF3 S152
    {0xA0B64000, 0xA0B67FFF},      //	PF3 S153
    {0xA0B68000, 0xA0B6BFFF},      //	PF3 S154
    {0xA0B6C000, 0xA0B6FFFF},      //	PF3 S155
    {0xA0B70000, 0xA0B73FFF},      //	PF3 S156
    {0xA0B74000, 0xA0B77FFF},      //	PF3 S157
    {0xA0B78000, 0xA0B7BFFF},      //	PF3 S158
    {0xA0B7C000, 0xA0B7FFFF},      //	PF3 S159
    {0xA0B80000, 0xA0B83FFF},      //	PF3 S160
    {0xA0B84000, 0xA0B87FFF},      //	PF3 S161
    {0xA0B88000, 0xA0B8BFFF},      //	PF3 S162
    {0xA0B8C000, 0xA0B8FFFF},      //	PF3 S163
    {0xA0B90000, 0xA0B93FFF},      //	PF3 S164
    {0xA0B94000, 0xA0B97FFF},      //	PF3 S165
    {0xA0B98000, 0xA0B9BFFF},      //	PF3 S166
    {0xA0B9C000, 0xA0B9FFFF},      //	PF3 S167
    {0xA0BA0000, 0xA0BA3FFF},      //	PF3 S168
    {0xA0BA4000, 0xA0BA7FFF},      //	PF3 S169
    {0xA0BA8000, 0xA0BABFFF},      //	PF3 S170
    {0xA0BAC000, 0xA0BAFFFF},      //	PF3 S171
    {0xA0BB0000, 0xA0BB3FFF},      //	PF3 S172
    {0xA0BB4000, 0xA0BB7FFF},      //	PF3 S173
    {0xA0BB8000, 0xA0BBBFFF},      //	PF3 S174
    {0xA0BBC000, 0xA0BBFFFF},      //	PF3 S175
    {0xA0BC0000, 0xA0BC3FFF},      //	PF3 S176
    {0xA0BC4000, 0xA0BC7FFF},      //	PF3 S177
    {0xA0BC8000, 0xA0BCBFFF},      //	PF3 S178
    {0xA0BCC000, 0xA0BCFFFF},      //	PF3 S179
    {0xA0BD0000, 0xA0BD3FFF},      //	PF3 S180
    {0xA0BD4000, 0xA0BD7FFF},      //	PF3 S181
    {0xA0BD8000, 0xA0BDBFFF},      //	PF3 S182
    {0xA0BDC000, 0xA0BDFFFF},      //	PF3 S183
    {0xA0BE0000, 0xA0BE3FFF},      //	PF3 S184
    {0xA0BE4000, 0xA0BE7FFF},      //	PF3 S185
    {0xA0BE8000, 0xA0BEBFFF},      //	PF3 S186
    {0xA0BEC000, 0xA0BEFFFF},      //	PF3 S187
    {0xA0BF0000, 0xA0BF3FFF},      //	PF3 S188
    {0xA0BF4000, 0xA0BF7FFF},      //	PF3 S189
    {0xA0BF8000, 0xA0BFBFFF},      //	PF3 S190
    {0xA0BFC000, 0xA0BFFFFF},      //	PF3 S191
    {0xA0C00000, 0xA0C03FFF},      //	PF4 S0
    {0xA0C04000, 0xA0C07FFF},      //	PF4 S1
    {0xA0C08000, 0xA0C0BFFF},      //	PF4 S2
    {0xA0C0C000, 0xA0C0FFFF},      //	PF4 S3
    {0xA0C10000, 0xA0C13FFF},      //	PF4 S4
    {0xA0C14000, 0xA0C17FFF},      //	PF4 S5
    {0xA0C18000, 0xA0C1BFFF},      //	PF4 S6
    {0xA0C1C000, 0xA0C1FFFF},      //	PF4 S7
    {0xA0C20000, 0xA0C23FFF},      //	PF4 S8
    {0xA0C24000, 0xA0C27FFF},      //	PF4 S9
    {0xA0C28000, 0xA0C2BFFF},      //	PF4 S10
    {0xA0C2C000, 0xA0C2FFFF},      //	PF4 S11
    {0xA0C30000, 0xA0C33FFF},      //	PF4 S12
    {0xA0C34000, 0xA0C37FFF},      //	PF4 S13
    {0xA0C38000, 0xA0C3BFFF},      //	PF4 S14
    {0xA0C3C000, 0xA0C3FFFF},      //	PF4 S15
    {0xA0C40000, 0xA0C43FFF},      //	PF4 S16
    {0xA0C44000, 0xA0C47FFF},      //	PF4 S17
    {0xA0C48000, 0xA0C4BFFF},      //	PF4 S18
    {0xA0C4C000, 0xA0C4FFFF},      //	PF4 S19
    {0xA0C50000, 0xA0C53FFF},      //	PF4 S20
    {0xA0C54000, 0xA0C57FFF},      //	PF4 S21
    {0xA0C58000, 0xA0C5BFFF},      //	PF4 S22
    {0xA0C5C000, 0xA0C5FFFF},      //	PF4 S23
    {0xA0C60000, 0xA0C63FFF},      //	PF4 S24
    {0xA0C64000, 0xA0C67FFF},      //	PF4 S25
    {0xA0C68000, 0xA0C6BFFF},      //	PF4 S26
    {0xA0C6C000, 0xA0C6FFFF},      //	PF4 S27
    {0xA0C70000, 0xA0C73FFF},      //	PF4 S28
    {0xA0C74000, 0xA0C77FFF},      //	PF4 S29
    {0xA0C78000, 0xA0C7BFFF},      //	PF4 S30
    {0xA0C7C000, 0xA0C7FFFF},      //	PF4 S31
    {0xA0C80000, 0xA0C83FFF},      //	PF4 S32
    {0xA0C84000, 0xA0C87FFF},      //	PF4 S33
    {0xA0C88000, 0xA0C8BFFF},      //	PF4 S34
    {0xA0C8C000, 0xA0C8FFFF},      //	PF4 S35
    {0xA0C90000, 0xA0C93FFF},      //	PF4 S36
    {0xA0C94000, 0xA0C97FFF},      //	PF4 S37
    {0xA0C98000, 0xA0C9BFFF},      //	PF4 S38
    {0xA0C9C000, 0xA0C9FFFF},      //	PF4 S39
    {0xA0CA0000, 0xA0CA3FFF},      //	PF4 S40
    {0xA0CA4000, 0xA0CA7FFF},      //	PF4 S41
    {0xA0CA8000, 0xA0CABFFF},      //	PF4 S42
    {0xA0CAC000, 0xA0CAFFFF},      //	PF4 S43
    {0xA0CB0000, 0xA0CB3FFF},      //	PF4 S44
    {0xA0CB4000, 0xA0CB7FFF},      //	PF4 S45
    {0xA0CB8000, 0xA0CBBFFF},      //	PF4 S46
    {0xA0CBC000, 0xA0CBFFFF},      //	PF4 S47
    {0xA0CC0000, 0xA0CC3FFF},      //	PF4 S48
    {0xA0CC4000, 0xA0CC7FFF},      //	PF4 S49
    {0xA0CC8000, 0xA0CCBFFF},      //	PF4 S50
    {0xA0CCC000, 0xA0CCFFFF},      //	PF4 S51
    {0xA0CD0000, 0xA0CD3FFF},      //	PF4 S52
    {0xA0CD4000, 0xA0CD7FFF},      //	PF4 S53
    {0xA0CD8000, 0xA0CDBFFF},      //	PF4 S54
    {0xA0CDC000, 0xA0CDFFFF},      //	PF4 S55
    {0xA0CE0000, 0xA0CE3FFF},      //	PF4 S56
    {0xA0CE4000, 0xA0CE7FFF},      //	PF4 S57
    {0xA0CE8000, 0xA0CEBFFF},      //	PF4 S58
    {0xA0CEC000, 0xA0CEFFFF},      //	PF4 S59
    {0xA0CF0000, 0xA0CF3FFF},      //	PF4 S60
    {0xA0CF4000, 0xA0CF7FFF},      //	PF4 S61
    {0xA0CF8000, 0xA0CFBFFF},      //	PF4 S62
    {0xA0CFC000, 0xA0CFFFFF},      //	PF4 S63
    {0xA0D00000, 0xA0D03FFF},      //	PF4 S64
    {0xA0D04000, 0xA0D07FFF},      //	PF4 S65
    {0xA0D08000, 0xA0D0BFFF},      //	PF4 S66
    {0xA0D0C000, 0xA0D0FFFF},      //	PF4 S67
    {0xA0D10000, 0xA0D13FFF},      //	PF4 S68
    {0xA0D14000, 0xA0D17FFF},      //	PF4 S69
    {0xA0D18000, 0xA0D1BFFF},      //	PF4 S70
    {0xA0D1C000, 0xA0D1FFFF},      //	PF4 S71
    {0xA0D20000, 0xA0D23FFF},      //	PF4 S72
    {0xA0D24000, 0xA0D27FFF},      //	PF4 S73
    {0xA0D28000, 0xA0D2BFFF},      //	PF4 S74
    {0xA0D2C000, 0xA0D2FFFF},      //	PF4 S75
    {0xA0D30000, 0xA0D33FFF},      //	PF4 S76
    {0xA0D34000, 0xA0D37FFF},      //	PF4 S77
    {0xA0D38000, 0xA0D3BFFF},      //	PF4 S78
    {0xA0D3C000, 0xA0D3FFFF},      //	PF4 S79
    {0xA0D40000, 0xA0D43FFF},      //	PF4 S80
    {0xA0D44000, 0xA0D47FFF},      //	PF4 S81
    {0xA0D48000, 0xA0D4BFFF},      //	PF4 S82
    {0xA0D4C000, 0xA0D4FFFF},      //	PF4 S83
    {0xA0D50000, 0xA0D53FFF},      //	PF4 S84
    {0xA0D54000, 0xA0D57FFF},      //	PF4 S85
    {0xA0D58000, 0xA0D5BFFF},      //	PF4 S86
    {0xA0D5C000, 0xA0D5FFFF},      //	PF4 S87
    {0xA0D60000, 0xA0D63FFF},      //	PF4 S88
    {0xA0D64000, 0xA0D67FFF},      //	PF4 S89
    {0xA0D68000, 0xA0D6BFFF},      //	PF4 S90
    {0xA0D6C000, 0xA0D6FFFF},      //	PF4 S91
    {0xA0D70000, 0xA0D73FFF},      //	PF4 S92
    {0xA0D74000, 0xA0D77FFF},      //	PF4 S93
    {0xA0D78000, 0xA0D7BFFF},      //	PF4 S94
    {0xA0D7C000, 0xA0D7FFFF},      //	PF4 S95
    {0xA0D80000, 0xA0D83FFF},      //	PF4 S96
    {0xA0D84000, 0xA0D87FFF},      //	PF4 S97
    {0xA0D88000, 0xA0D8BFFF},      //	PF4 S98
    {0xA0D8C000, 0xA0D8FFFF},      //	PF4 S99
    {0xA0D90000, 0xA0D93FFF},      //	PF4 S100
    {0xA0D94000, 0xA0D97FFF},      //	PF4 S101
    {0xA0D98000, 0xA0D9BFFF},      //	PF4 S102
    {0xA0D9C000, 0xA0D9FFFF},      //	PF4 S103
    {0xA0DA0000, 0xA0DA3FFF},      //	PF4 S104
    {0xA0DA4000, 0xA0DA7FFF},      //	PF4 S105
    {0xA0DA8000, 0xA0DABFFF},      //	PF4 S106
    {0xA0DAC000, 0xA0DAFFFF},      //	PF4 S107
    {0xA0DB0000, 0xA0DB3FFF},      //	PF4 S108
    {0xA0DB4000, 0xA0DB7FFF},      //	PF4 S109
    {0xA0DB8000, 0xA0DBBFFF},      //	PF4 S110
    {0xA0DBC000, 0xA0DBFFFF},      //	PF4 S111
    {0xA0DC0000, 0xA0DC3FFF},      //	PF4 S112
    {0xA0DC4000, 0xA0DC7FFF},      //	PF4 S113
    {0xA0DC8000, 0xA0DCBFFF},      //	PF4 S114
    {0xA0DCC000, 0xA0DCFFFF},      //	PF4 S115
    {0xA0DD0000, 0xA0DD3FFF},      //	PF4 S116
    {0xA0DD4000, 0xA0DD7FFF},      //	PF4 S117
    {0xA0DD8000, 0xA0DDBFFF},      //	PF4 S118
    {0xA0DDC000, 0xA0DDFFFF},      //	PF4 S119
    {0xA0DE0000, 0xA0DE3FFF},      //	PF4 S120
    {0xA0DE4000, 0xA0DE7FFF},      //	PF4 S121
    {0xA0DE8000, 0xA0DEBFFF},      //	PF4 S122
    {0xA0DEC000, 0xA0DEFFFF},      //	PF4 S123
    {0xA0DF0000, 0xA0DF3FFF},      //	PF4 S124
    {0xA0DF4000, 0xA0DF7FFF},      //	PF4 S125
    {0xA0DF8000, 0xA0DFBFFF},      //	PF4 S126
    {0xA0DFC000, 0xA0DFFFFF},      //	PF4 S127
    {0xA0E00000, 0xA0E03FFF},      //	PF4 S128
    {0xA0E04000, 0xA0E07FFF},      //	PF4 S129
    {0xA0E08000, 0xA0E0BFFF},      //	PF4 S130
    {0xA0E0C000, 0xA0E0FFFF},      //	PF4 S131
    {0xA0E10000, 0xA0E13FFF},      //	PF4 S132
    {0xA0E14000, 0xA0E17FFF},      //	PF4 S133
    {0xA0E18000, 0xA0E1BFFF},      //	PF4 S134
    {0xA0E1C000, 0xA0E1FFFF},      //	PF4 S135
    {0xA0E20000, 0xA0E23FFF},      //	PF4 S136
    {0xA0E24000, 0xA0E27FFF},      //	PF4 S137
    {0xA0E28000, 0xA0E2BFFF},      //	PF4 S138
    {0xA0E2C000, 0xA0E2FFFF},      //	PF4 S139
    {0xA0E30000, 0xA0E33FFF},      //	PF4 S140
    {0xA0E34000, 0xA0E37FFF},      //	PF4 S141
    {0xA0E38000, 0xA0E3BFFF},      //	PF4 S142
    {0xA0E3C000, 0xA0E3FFFF},      //	PF4 S143
    {0xA0E40000, 0xA0E43FFF},      //	PF4 S144
    {0xA0E44000, 0xA0E47FFF},      //	PF4 S145
    {0xA0E48000, 0xA0E4BFFF},      //	PF4 S146
    {0xA0E4C000, 0xA0E4FFFF},      //	PF4 S147
    {0xA0E50000, 0xA0E53FFF},      //	PF4 S148
    {0xA0E54000, 0xA0E57FFF},      //	PF4 S149
    {0xA0E58000, 0xA0E5BFFF},      //	PF4 S150
    {0xA0E5C000, 0xA0E5FFFF},      //	PF4 S151
    {0xA0E60000, 0xA0E63FFF},      //	PF4 S152
    {0xA0E64000, 0xA0E67FFF},      //	PF4 S153
    {0xA0E68000, 0xA0E6BFFF},      //	PF4 S154
    {0xA0E6C000, 0xA0E6FFFF},      //	PF4 S155
    {0xA0E70000, 0xA0E73FFF},      //	PF4 S156
    {0xA0E74000, 0xA0E77FFF},      //	PF4 S157
    {0xA0E78000, 0xA0E7BFFF},      //	PF4 S158
    {0xA0E7C000, 0xA0E7FFFF},      //	PF4 S159
    {0xA0E80000, 0xA0E83FFF},      //	PF4 S160
    {0xA0E84000, 0xA0E87FFF},      //	PF4 S161
    {0xA0E88000, 0xA0E8BFFF},      //	PF4 S162
    {0xA0E8C000, 0xA0E8FFFF},      //	PF4 S163
    {0xA0E90000, 0xA0E93FFF},      //	PF4 S164
    {0xA0E94000, 0xA0E97FFF},      //	PF4 S165
    {0xA0E98000, 0xA0E9BFFF},      //	PF4 S166
    {0xA0E9C000, 0xA0E9FFFF},      //	PF4 S167
    {0xA0EA0000, 0xA0EA3FFF},      //	PF4 S168
    {0xA0EA4000, 0xA0EA7FFF},      //	PF4 S169
    {0xA0EA8000, 0xA0EABFFF},      //	PF4 S170
    {0xA0EAC000, 0xA0EAFFFF},      //	PF4 S171
    {0xA0EB0000, 0xA0EB3FFF},      //	PF4 S172
    {0xA0EB4000, 0xA0EB7FFF},      //	PF4 S173
    {0xA0EB8000, 0xA0EBBFFF},      //	PF4 S174
    {0xA0EBC000, 0xA0EBFFFF},      //	PF4 S175
    {0xA0EC0000, 0xA0EC3FFF},      //	PF4 S176
    {0xA0EC4000, 0xA0EC7FFF},      //	PF4 S177
    {0xA0EC8000, 0xA0ECBFFF},      //	PF4 S178
    {0xA0ECC000, 0xA0ECFFFF},      //	PF4 S179
    {0xA0ED0000, 0xA0ED3FFF},      //	PF4 S180
    {0xA0ED4000, 0xA0ED7FFF},      //	PF4 S181
    {0xA0ED8000, 0xA0EDBFFF},      //	PF4 S182
    {0xA0EDC000, 0xA0EDFFFF},      //	PF4 S183
    {0xA0EE0000, 0xA0EE3FFF},      //	PF4 S184
    {0xA0EE4000, 0xA0EE7FFF},      //	PF4 S185
    {0xA0EE8000, 0xA0EEBFFF},      //	PF4 S186
    {0xA0EEC000, 0xA0EEFFFF},      //	PF4 S187
    {0xA0EF0000, 0xA0EF3FFF},      //	PF4 S188
    {0xA0EF4000, 0xA0EF7FFF},      //	PF4 S189
    {0xA0EF8000, 0xA0EFBFFF},      //	PF4 S190
    {0xA0EFC000, 0xA0EFFFFF},      //	PF4 S191
    {0xA0F00000, 0xA0F03FFF},      //	PF5 S0
    {0xA0F04000, 0xA0F07FFF},      //	PF5 S1
    {0xA0F08000, 0xA0F0BFFF},      //	PF5 S2
    {0xA0F0C000, 0xA0F0FFFF},      //	PF5 S3
    {0xA0F10000, 0xA0F13FFF},      //	PF5 S4
    {0xA0F14000, 0xA0F17FFF},      //	PF5 S5
    {0xA0F18000, 0xA0F1BFFF},      //	PF5 S6
    {0xA0F1C000, 0xA0F1FFFF},      //	PF5 S7
    {0xA0F20000, 0xA0F23FFF},      //	PF5 S8
    {0xA0F24000, 0xA0F27FFF},      //	PF5 S9
    {0xA0F28000, 0xA0F2BFFF},      //	PF5 S10
    {0xA0F2C000, 0xA0F2FFFF},      //	PF5 S11
    {0xA0F30000, 0xA0F33FFF},      //	PF5 S12
    {0xA0F34000, 0xA0F37FFF},      //	PF5 S13
    {0xA0F38000, 0xA0F3BFFF},      //	PF5 S14
    {0xA0F3C000, 0xA0F3FFFF},      //	PF5 S15
    {0xA0F40000, 0xA0F43FFF},      //	PF5 S16
    {0xA0F44000, 0xA0F47FFF},      //	PF5 S17
    {0xA0F48000, 0xA0F4BFFF},      //	PF5 S18
    {0xA0F4C000, 0xA0F4FFFF},      //	PF5 S19
    {0xA0F50000, 0xA0F53FFF},      //	PF5 S20
    {0xA0F54000, 0xA0F57FFF},      //	PF5 S21
    {0xA0F58000, 0xA0F5BFFF},      //	PF5 S22
    {0xA0F5C000, 0xA0F5FFFF},      //	PF5 S23
    {0xA0F60000, 0xA0F63FFF},      //	PF5 S24
    {0xA0F64000, 0xA0F67FFF},      //	PF5 S25
    {0xA0F68000, 0xA0F6BFFF},      //	PF5 S26
    {0xA0F6C000, 0xA0F6FFFF},      //	PF5 S27
    {0xA0F70000, 0xA0F73FFF},      //	PF5 S28
    {0xA0F74000, 0xA0F77FFF},      //	PF5 S29
    {0xA0F78000, 0xA0F7BFFF},      //	PF5 S30
    {0xA0F7C000, 0xA0F7FFFF},      //	PF5 S31
    {0xA0F80000, 0xA0F83FFF},      //	PF5 S32
    {0xA0F84000, 0xA0F87FFF},      //	PF5 S33
    {0xA0F88000, 0xA0F8BFFF},      //	PF5 S34
    {0xA0F8C000, 0xA0F8FFFF},      //	PF5 S35
    {0xA0F90000, 0xA0F93FFF},      //	PF5 S36
    {0xA0F94000, 0xA0F97FFF},      //	PF5 S37
    {0xA0F98000, 0xA0F9BFFF},      //	PF5 S38
    {0xA0F9C000, 0xA0F9FFFF},      //	PF5 S39
    {0xA0FA0000, 0xA0FA3FFF},      //	PF5 S40
    {0xA0FA4000, 0xA0FA7FFF},      //	PF5 S41
    {0xA0FA8000, 0xA0FABFFF},      //	PF5 S42
    {0xA0FAC000, 0xA0FAFFFF},      //	PF5 S43
    {0xA0FB0000, 0xA0FB3FFF},      //	PF5 S44
    {0xA0FB4000, 0xA0FB7FFF},      //	PF5 S45
    {0xA0FB8000, 0xA0FBBFFF},      //	PF5 S46
    {0xA0FBC000, 0xA0FBFFFF},      //	PF5 S47
    {0xA0FC0000, 0xA0FC3FFF},      //	PF5 S48
    {0xA0FC4000, 0xA0FC7FFF},      //	PF5 S49
    {0xA0FC8000, 0xA0FCBFFF},      //	PF5 S50
    {0xA0FCC000, 0xA0FCFFFF},      //	PF5 S51
    {0xA0FD0000, 0xA0FD3FFF},      //	PF5 S52
    {0xA0FD4000, 0xA0FD7FFF},      //	PF5 S53
    {0xA0FD8000, 0xA0FDBFFF},      //	PF5 S54
    {0xA0FDC000, 0xA0FDFFFF},      //	PF5 S55
    {0xA0FE0000, 0xA0FE3FFF},      //	PF5 S56
    {0xA0FE4000, 0xA0FE7FFF},      //	PF5 S57
    {0xA0FE8000, 0xA0FEBFFF},      //	PF5 S58
    {0xA0FEC000, 0xA0FEFFFF},      //	PF5 S59
    {0xA0FF0000, 0xA0FF3FFF},      //	PF5 S60
    {0xA0FF4000, 0xA0FF7FFF},      //	PF5 S61
    {0xA0FF8000, 0xA0FFBFFF},      //	PF5 S62
    {0xA0FFC000, 0xA0FFFFFF},      //	PF5 S63
};

IFX_CONST IfxFlash_flashSector IfxFlash_pFlashTablePhys[IFXFLASH_PFLASH_NUM_PHYSICAL_SECTORS] = {
    {0xA0000000, 0xA00FFFFF},     /* PF0 PS0*/
    {0xA0100000, 0xA01FFFFF},     /* PF0 PS1*/
    {0xA0200000, 0xA02FFFFF},     /* PF0 PS2*/
    {0xA0300000, 0xA03FFFFF},     /* PF1 PS0*/
    {0xA0400000, 0xA04FFFFF},     /* PF1 PS1*/
    {0xA0500000, 0xA05FFFFF},     /* PF1 PS2*/
    {0xA0600000, 0xA06FFFFF},     /* PF2 PS0*/
    {0xA0700000, 0xA07FFFFF},     /* PF2 PS1*/
    {0xA0800000, 0xA08FFFFF},     /* PF2 PS2*/
    {0xA0900000, 0xA09FFFFF},     /* PF3 PS0*/
    {0xA0A00000, 0xA0AFFFFF},     /* PF3 PS1*/
    {0xA0B00000, 0xA0BFFFFF},     /* PF3 PS2*/
    {0xA0C00000, 0xA0CFFFFF},     /* PF4 PS0*/
    {0xA0D00000, 0xA0DFFFFF},     /* PF4 PS1*/
    {0xA0E00000, 0xA0EFFFFF},     /* PF4 PS2*/
    {0xA0F00000, 0xA0FFFFFF},     /* PF5 PS0*/
};
