#include "tztek_can.h"
#include "Ifx_Types.h"
#include "IfxPort.h"
#include "Bsp.h"


#define CAN_RESEND_CNT 10
/* *** Add by Turing, 2022.2.14 */

McmcanType  g_mcmcan00;                 
McmcanType  g_mcmcan01;                 
McmcanType  g_mcmcan02;                 
McmcanType  g_mcmcan03;                 
McmcanType  g_mcmcan10;                 
McmcanType  g_mcmcan11;                 
McmcanType  g_mcmcan12;                 
McmcanType  g_mcmcan13;
/* *** Add by yinjun, 2022.9.5 */
McmcanType  g_mcmcan20;
McmcanType  g_mcmcan21;
McmcanType  g_mcmcan22;
McmcanType  g_mcmcan23;


//for 510v_r1.2 can0(can00)
IFX_CONST IfxCan_Can_Pins Can00_pins = {
       &IfxCan_TXD00_P02_0_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD00A_P02_1_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can01(can01)
IFX_CONST IfxCan_Can_Pins Can01_pins = {
       &IfxCan_TXD01_P01_3_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD01C_P01_4_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};

//for 510v_r1.2 can2(can02)
IFX_CONST IfxCan_Can_Pins Can02_pins = {
       &IfxCan_TXD02_P02_2_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD02B_P02_3_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can3(can03)
IFX_CONST IfxCan_Can_Pins Can03_pins = {
       &IfxCan_TXD03_P00_2_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD03A_P00_3_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};

//for 510v_r1.2 can10 ---------OK
IFX_CONST IfxCan_Can_Pins Can10_pins = {
       &IfxCan_TXD10_P00_0_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD10A_P00_1_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can11(can11)
IFX_CONST IfxCan_Can_Pins Can11_pins = {
       &IfxCan_TXD11_P00_4_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD11B_P00_5_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can12(can12)
IFX_CONST IfxCan_Can_Pins Can12_pins = {
       &IfxCan_TXD12_P10_7_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD12B_P10_8_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can13(can13)
IFX_CONST IfxCan_Can_Pins Can13_pins = {
//       &IfxCan_TXD13_P14_6_OUT,   IfxPort_OutputMode_pushPull,
//       &IfxCan_RXD13A_P14_7_IN,   IfxPort_InputMode_pullUp,
       &IfxCan_TXD13_P22_4_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD13C_P22_5_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};

/* *** Add by yinjun, 2022.9.5 */
//for 510v_r1.2 can20 ---------OK
IFX_CONST IfxCan_Can_Pins Can20_pins = {
       &IfxCan_TXD20_P34_1_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD20C_P34_2_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};

//for 510v_r1.2 can21(can21)
IFX_CONST IfxCan_Can_Pins Can21_pins = {
       &IfxCan_TXD21_P20_3_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD21C_P20_0_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};

//for 510v_r1.2 can22(can22)
IFX_CONST IfxCan_Can_Pins Can22_pins = {
       &IfxCan_TXD22_P22_8_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD22E_P22_9_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};
//for 510v_r1.2 can23(can23)
IFX_CONST IfxCan_Can_Pins Can23_pins = {
       &IfxCan_TXD23_P22_10_OUT,   IfxPort_OutputMode_pushPull,
       &IfxCan_RXD23E_P22_11_IN,   IfxPort_InputMode_pullUp,
       IfxPort_PadDriver_cmosAutomotiveSpeed4
};


IFX_INTERRUPT(can00IsrTxHandler, 1, ISR_PRIORITY_CAN00_TX);
void can00IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan00.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can00: send data interrupt\r\n");
}

IFX_INTERRUPT(can01IsrTxHandler, 1, ISR_PRIORITY_CAN01_TX);
void can01IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan01.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can01: send data interrupt\r\n");
}

IFX_INTERRUPT(can02IsrTxHandler, 1, ISR_PRIORITY_CAN02_TX);
void can02IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan02.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can02: send data interrupt\r\n");
}

IFX_INTERRUPT(can03IsrTxHandler, 1, ISR_PRIORITY_CAN03_TX);
void can03IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan03.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can03: send data interrupt\r\n");
}

IFX_INTERRUPT(can10IsrTxHandler, 1, ISR_PRIORITY_CAN10_TX);
void can10IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan10.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can10: send data interrupt\r\n");
}

IFX_INTERRUPT(can11IsrTxHandler, 1, ISR_PRIORITY_CAN11_TX);
void can11IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan11.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can11: send data interrupt\r\n");
}

IFX_INTERRUPT(can12IsrTxHandler, 1, ISR_PRIORITY_CAN12_TX);
void can12IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan12.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can12: send data interrupt\r\n");
}

IFX_INTERRUPT(can13IsrTxHandler, 1, ISR_PRIORITY_CAN13_TX);
void can13IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan13.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can13: send data interrupt\r\n");
}

/* *** Add by yinjun, 2022.9.5 */
IFX_INTERRUPT(can20IsrTxHandler, 1, ISR_PRIORITY_CAN20_TX);
void can20IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan20.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can10: send data interrupt\r\n");
}

IFX_INTERRUPT(can21IsrTxHandler, 1, ISR_PRIORITY_CAN21_TX);
void can21IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan21.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can11: send data interrupt\r\n");
}

IFX_INTERRUPT(can22IsrTxHandler, 1, ISR_PRIORITY_CAN22_TX);
void can22IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan22.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can12: send data interrupt\r\n");
}

IFX_INTERRUPT(can23IsrTxHandler, 1, ISR_PRIORITY_CAN23_TX);
void can23IsrTxHandler(void)
{
    /* Clear the "Transmission Completed" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan23.canNode.node, IfxCan_Interrupt_transmissionCompleted);

    //Ifx_Console_print("can13: send data interrupt\r\n");
}


/*
 *  Add by yinjun, 2022.9.6
 *  return received data in the interrupt
 */

IFX_INTERRUPT(can00IsrRxHandler, 1, ISR_PRIORITY_CAN00_RX);
void can00IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan00.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan00.canNode, &g_mcmcan00.rxMsg, g_mcmcan00.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan00.rxData,8);
    sendDataCAN00(g_mcmcan00.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can01IsrRxHandler, 1, ISR_PRIORITY_CAN01_RX);
void can01IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan01.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan01.canNode.node, g_mcmcan01.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan01.canNode, &g_mcmcan01.rxMsg, g_mcmcan01.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan01.rxData,8);
    sendDataCAN01(g_mcmcan01.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can02IsrRxHandler, 1, ISR_PRIORITY_CAN02_RX);
void can02IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan02.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan02.canNode, &g_mcmcan02.rxMsg, g_mcmcan02.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan02.rxData,8);
    sendDataCAN02(g_mcmcan02.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can03IsrRxHandler, 1, ISR_PRIORITY_CAN03_RX);
void can03IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan03.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan03.canNode, &g_mcmcan03.rxMsg, g_mcmcan03.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan03.rxData,8);
    sendDataCAN03(g_mcmcan03.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can10IsrRxHandler, 1, ISR_PRIORITY_CAN10_RX);
void can10IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan10.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan10.canNode, &g_mcmcan10.rxMsg, g_mcmcan10.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan10.rxData,8);
    sendDataCAN10(g_mcmcan10.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can11IsrRxHandler, 1, ISR_PRIORITY_CAN11_RX);
void can11IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan11.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan11.canNode, &g_mcmcan11.rxMsg, g_mcmcan11.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan11.rxData,8);
    sendDataCAN11(g_mcmcan11.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can12IsrRxHandler, 1, ISR_PRIORITY_CAN12_RX);
void can12IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan12.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan12.canNode, &g_mcmcan12.rxMsg, g_mcmcan12.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan12.rxData,8);
    sendDataCAN12(g_mcmcan12.rxMsg.messageId, bufSend);

}

IFX_INTERRUPT(can13IsrRxHandler, 1, ISR_PRIORITY_CAN13_RX);
void can13IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan13.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan13.canNode, &g_mcmcan13.rxMsg, g_mcmcan13.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan13.rxData,8);
    sendDataCAN13(g_mcmcan13.rxMsg.messageId, bufSend);
}


/* *** Add by yinjun, 2022.9.5 */
IFX_INTERRUPT(can20IsrRxHandler, 1, ISR_PRIORITY_CAN20_RX);
void can20IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan20.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan20.canNode, &g_mcmcan20.rxMsg, g_mcmcan20.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan20.rxData,8);
    sendDataCAN20(g_mcmcan20.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can21IsrRxHandler, 1, ISR_PRIORITY_CAN21_RX);
void can21IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan21.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan21.canNode, &g_mcmcan21.rxMsg, g_mcmcan21.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan21.rxData,8);
    sendDataCAN21(g_mcmcan21.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can22IsrRxHandler, 1, ISR_PRIORITY_CAN22_RX);
void can22IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan22.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan22.canNode, &g_mcmcan22.rxMsg, g_mcmcan22.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan22.rxData,8);
    sendDataCAN22(g_mcmcan22.rxMsg.messageId, bufSend);
}

IFX_INTERRUPT(can23IsrRxHandler, 1, ISR_PRIORITY_CAN23_RX);
void can23IsrRxHandler(void)
{
    /* Clear the "Message stored to Dedicated RX Buffer" interrupt flag */
    IfxCan_Node_clearInterruptFlag(g_mcmcan23.canNode.node, IfxCan_Interrupt_rxFifo0NewMessage);
    /* Clear the "New Data" flag; as long as the "New Data" flag is set, the respective Rx buffer is
     * locked against updates from received matching frames.
     */
    // IfxCan_Node_clearRxBufferNewDataFlag(g_mcmcan00.canNode.node, g_mcmcan00.canFilter.rxBufferOffset);
    /* Read the received CAN message */
    IfxCan_Can_readMessage(&g_mcmcan23.canNode, &g_mcmcan23.rxMsg, g_mcmcan23.rxData);
    uint8 bufSend[8];
    memcpy(bufSend,g_mcmcan23.rxData,8);
    sendDataCAN23(g_mcmcan23.rxMsg.messageId, bufSend);
}


/* *** Add by yinjun, 2022.9.6
 *  delete transmit interrupt configuration
 *  modify receive interrupt interruptline
 */

void initCAN00(void)
{

    IfxCan_Can_initModuleConfig(&g_mcmcan00.canConfig, &MODULE_CAN0);
    IfxCan_Can_initModule(&g_mcmcan00.canModule, &g_mcmcan00.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan00.canNodeConfig, &g_mcmcan00.canModule);    //set default node value

    g_mcmcan00.canNodeConfig.nodeId = IfxCan_NodeId_0;  //4 node in 1 module
    g_mcmcan00.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan00.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan00.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan00.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan00.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan00.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan00.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan00.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan00.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan00.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan00.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan00.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan00.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan00.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan00.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan00.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan00.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan00.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan00.canNodeConfig.messageRAM.baseAddress = MODULE_CAN0_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan00.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan00.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan00.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan00.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan00.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes

/*
    //transmit interrupt
    g_mcmcan00.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan00.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN00_TX;
    g_mcmcan00.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_12;
    g_mcmcan00.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/

    //receive interrupt
    g_mcmcan00.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan00.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN00_RX;
    g_mcmcan00.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_0;
    g_mcmcan00.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan00.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan00.canNodeConfig.pins = &Can00_pins;
    IfxCan_Can_initNode(&g_mcmcan00.canNode, &g_mcmcan00.canNodeConfig);

    //std filter 0
    g_mcmcan00.canFilter.number = 0;
    g_mcmcan00.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan00.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan00.canFilter.id1 = 0;
    g_mcmcan00.canFilter.id2 = 0;
    g_mcmcan00.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan00.canNode), &(g_mcmcan00.canFilter));

    g_mcmcan00.canFilter.number = 0;
    g_mcmcan00.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan00.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan00.canFilter.id1 = 0;
    g_mcmcan00.canFilter.id2 = 0;
    g_mcmcan00.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan00.canNode), &(g_mcmcan00.canFilter));

    g_mcmcan00.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN01(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan01.canConfig, &MODULE_CAN0);
    IfxCan_Can_initModule(&g_mcmcan01.canModule, &g_mcmcan01.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan01.canNodeConfig, &g_mcmcan01.canModule);    //set default node value

    g_mcmcan01.canNodeConfig.nodeId = IfxCan_NodeId_1;  //4 node in 1 module
    g_mcmcan01.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan01.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan01.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan01.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan01.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan01.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan01.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan01.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan01.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan01.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan01.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan01.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan01.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan01.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan01.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan01.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan01.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan01.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan01.canNodeConfig.messageRAM.baseAddress = MODULE_CAN0_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan01.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan01.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan01.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan01.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan01.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan01.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan01.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN01_TX;
    g_mcmcan01.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_2;
    g_mcmcan01.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan01.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan01.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN01_RX;
    g_mcmcan01.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_1;
    g_mcmcan01.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan01.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan01.canNodeConfig.pins = &Can01_pins;
    IfxCan_Can_initNode(&g_mcmcan01.canNode, &g_mcmcan01.canNodeConfig);

    //std filter 0
    g_mcmcan01.canFilter.number = 0;
    g_mcmcan01.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan01.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan01.canFilter.id1 = 0;
    g_mcmcan01.canFilter.id2 = 0;
    g_mcmcan01.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan01.canNode), &(g_mcmcan01.canFilter));

    g_mcmcan01.canFilter.number = 0;
    g_mcmcan01.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan01.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan01.canFilter.id1 = 0;
    g_mcmcan01.canFilter.id2 = 0;
    g_mcmcan01.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan01.canNode), &(g_mcmcan01.canFilter));

    g_mcmcan01.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN02(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan02.canConfig, &MODULE_CAN0);
    IfxCan_Can_initModule(&g_mcmcan02.canModule, &g_mcmcan02.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan02.canNodeConfig, &g_mcmcan02.canModule);    //set default node value

    g_mcmcan02.canNodeConfig.nodeId = IfxCan_NodeId_2;  //4 node in 1 module
    g_mcmcan02.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan02.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan02.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan02.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan02.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan02.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan02.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan02.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan02.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan02.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan02.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan02.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan02.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan02.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan02.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan02.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan02.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan02.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan02.canNodeConfig.messageRAM.baseAddress = MODULE_CAN0_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan02.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan02.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan02.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan02.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan02.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan02.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan02.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN02_TX;
    g_mcmcan02.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_4;
    g_mcmcan02.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan02.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan02.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN02_RX;
    g_mcmcan02.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_2;
    g_mcmcan02.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan02.canNodeConfig.baudRate.baudrate = 250000;
 
    g_mcmcan02.canNodeConfig.pins = &Can02_pins;
    IfxCan_Can_initNode(&g_mcmcan02.canNode, &g_mcmcan02.canNodeConfig);

    //std filter 0
//    g_mcmcan02.canFilter.number = 0;
//    g_mcmcan02.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
//    g_mcmcan02.canFilter.type = IfxCan_FilterType_classic;
//    g_mcmcan02.canFilter.id1 = 0;
//    g_mcmcan02.canFilter.id2 = 0;
//    g_mcmcan02.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
//    IfxCan_Can_setStandardFilter(&(g_mcmcan02.canNode), &(g_mcmcan02.canFilter));

    //CAN通讯掩码测试,掩码过滤，20221116
    g_mcmcan02.canFilter.number = 0;
    g_mcmcan02.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan02.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan02.canFilter.id1 = 0;
    g_mcmcan02.canFilter.id2 = 0xFFFFFFE0;
    g_mcmcan02.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan02.canNode), &(g_mcmcan02.canFilter));

//    g_mcmcan02.canFilter.number = 0;
//    g_mcmcan02.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
//    g_mcmcan02.canFilter.type = IfxCan_FilterType_classic;
//    g_mcmcan02.canFilter.id1 = 0;
//    g_mcmcan02.canFilter.id2 = 0;
//    g_mcmcan02.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
//    IfxCan_Can_setExtendedFilter(&(g_mcmcan02.canNode), &(g_mcmcan02.canFilter));

    g_mcmcan02.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN03(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan03.canConfig, &MODULE_CAN0);
    IfxCan_Can_initModule(&g_mcmcan03.canModule, &g_mcmcan03.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan03.canNodeConfig, &g_mcmcan03.canModule);    //set default node value

    g_mcmcan03.canNodeConfig.nodeId = IfxCan_NodeId_3;  //4 node in 1 module
    g_mcmcan03.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan03.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan03.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan03.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan03.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan03.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan03.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan03.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan03.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan03.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan03.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan03.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan03.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan03.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan03.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan03.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan03.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan03.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan03.canNodeConfig.messageRAM.baseAddress = MODULE_CAN0_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan03.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan03.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan03.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan03.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan03.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan03.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan03.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN03_TX;
    g_mcmcan03.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_6;
    g_mcmcan03.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan03.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan03.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN03_RX;
    g_mcmcan03.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_3;
    g_mcmcan03.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan03.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan03.canNodeConfig.pins = &Can03_pins;
    IfxCan_Can_initNode(&g_mcmcan03.canNode, &g_mcmcan03.canNodeConfig);

    //std filter 0
    g_mcmcan03.canFilter.number = 0;
    g_mcmcan03.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan03.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan03.canFilter.id1 = 0;
    g_mcmcan03.canFilter.id2 = 0;
    g_mcmcan03.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan03.canNode), &(g_mcmcan03.canFilter));

    g_mcmcan03.canFilter.number = 0;
    g_mcmcan03.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan03.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan03.canFilter.id1 = 0;
    g_mcmcan03.canFilter.id2 = 0;
    g_mcmcan03.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan03.canNode), &(g_mcmcan03.canFilter));

    g_mcmcan03.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN10(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan10.canConfig, &MODULE_CAN1);
    IfxCan_Can_initModule(&g_mcmcan10.canModule, &g_mcmcan10.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan10.canNodeConfig, &g_mcmcan10.canModule);    //set default node value

    g_mcmcan10.canNodeConfig.nodeId = IfxCan_NodeId_0;  //4 node in 1 module
    g_mcmcan10.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan10.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan10.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan10.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan10.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan10.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan10.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan10.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan10.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan10.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan10.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan10.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan10.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan10.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan10.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan10.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan10.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan10.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan10.canNodeConfig.messageRAM.baseAddress = MODULE_CAN1_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan10.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan10.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan10.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan10.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan10.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan10.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan10.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN10_TX;
    g_mcmcan10.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_8;
    g_mcmcan10.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan10.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan10.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN10_RX;
    g_mcmcan10.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_4;
    g_mcmcan10.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan10.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan10.canNodeConfig.pins = &Can10_pins;
    IfxCan_Can_initNode(&g_mcmcan10.canNode, &g_mcmcan10.canNodeConfig);

    //std filter 0
    g_mcmcan10.canFilter.number = 0;
    g_mcmcan10.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan10.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan10.canFilter.id1 = 0;
    g_mcmcan10.canFilter.id2 = 0;
    g_mcmcan10.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan10.canNode), &(g_mcmcan10.canFilter));

    g_mcmcan10.canFilter.number = 0;
    g_mcmcan10.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan10.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan10.canFilter.id1 = 0;
    g_mcmcan10.canFilter.id2 = 0;
    g_mcmcan10.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan10.canNode), &(g_mcmcan10.canFilter));

    g_mcmcan10.rxMsg.readFromRxFifo0 = TRUE;
}

void initCAN11(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan11.canConfig, &MODULE_CAN1);
    IfxCan_Can_initModule(&g_mcmcan11.canModule, &g_mcmcan11.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan11.canNodeConfig, &g_mcmcan11.canModule);    //set default node value

    g_mcmcan11.canNodeConfig.nodeId = IfxCan_NodeId_1;  //4 node in 1 module
    g_mcmcan11.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan11.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan11.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan11.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan11.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan11.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan11.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan11.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan11.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan11.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan11.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan11.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan11.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan11.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan11.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan11.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan11.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan11.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan11.canNodeConfig.messageRAM.baseAddress = MODULE_CAN1_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan11.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan11.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan11.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan11.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan11.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan11.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan11.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN11_TX;
    g_mcmcan11.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_10;
    g_mcmcan11.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan11.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan11.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN11_RX;
    g_mcmcan11.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_5;
    g_mcmcan11.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan11.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan11.canNodeConfig.pins = &Can11_pins;
    IfxCan_Can_initNode(&g_mcmcan11.canNode, &g_mcmcan11.canNodeConfig);

    //std filter 0
    g_mcmcan11.canFilter.number = 0;
    g_mcmcan11.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan11.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan11.canFilter.id1 = 0;
    g_mcmcan11.canFilter.id2 = 0;
    g_mcmcan11.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan11.canNode), &(g_mcmcan11.canFilter));

    g_mcmcan11.canFilter.number = 0;
    g_mcmcan11.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan11.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan11.canFilter.id1 = 0;
    g_mcmcan11.canFilter.id2 = 0;
    g_mcmcan11.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan11.canNode), &(g_mcmcan11.canFilter));

    g_mcmcan11.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN12(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan12.canConfig, &MODULE_CAN1);
    IfxCan_Can_initModule(&g_mcmcan12.canModule, &g_mcmcan12.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan12.canNodeConfig, &g_mcmcan12.canModule);    //set default node value

    g_mcmcan12.canNodeConfig.nodeId = IfxCan_NodeId_2;  //4 node in 1 module
    g_mcmcan12.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan12.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan12.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan12.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan12.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan12.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan12.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan12.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan12.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan12.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan12.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan12.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan12.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan12.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan12.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan12.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan12.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan12.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan12.canNodeConfig.messageRAM.baseAddress = MODULE_CAN1_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan12.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan12.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan12.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan12.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan12.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan12.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan12.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN12_TX;
    g_mcmcan12.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_12;
    g_mcmcan12.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan12.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan12.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN12_RX;
    g_mcmcan12.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_6;
    g_mcmcan12.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan12.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan12.canNodeConfig.pins = &Can12_pins;
    IfxCan_Can_initNode(&g_mcmcan12.canNode, &g_mcmcan12.canNodeConfig);

    //std filter 0
    g_mcmcan12.canFilter.number = 0;
    g_mcmcan12.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan12.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan12.canFilter.id1 = 0;
    g_mcmcan12.canFilter.id2 = 0;
    g_mcmcan12.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan12.canNode), &(g_mcmcan12.canFilter));

    g_mcmcan12.canFilter.number = 0;
    g_mcmcan12.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan12.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan12.canFilter.id1 = 0;
    g_mcmcan12.canFilter.id2 = 0;
    g_mcmcan12.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan12.canNode), &(g_mcmcan12.canFilter));

    g_mcmcan12.rxMsg.readFromRxFifo0 = TRUE;


}

void initCAN13(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan13.canConfig, &MODULE_CAN1);
    IfxCan_Can_initModule(&g_mcmcan13.canModule, &g_mcmcan13.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan13.canNodeConfig, &g_mcmcan13.canModule);    //set default node value

    g_mcmcan13.canNodeConfig.nodeId = IfxCan_NodeId_3;  //4 node in 1 module
    g_mcmcan13.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan13.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan13.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan13.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan13.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan13.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan13.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan13.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan13.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan13.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan13.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan13.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan13.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan13.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan13.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan13.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan13.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan13.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan13.canNodeConfig.messageRAM.baseAddress = MODULE_CAN1_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan13.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan13.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan13.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan13.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan13.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan13.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan13.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN13_TX;
    g_mcmcan13.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_14;
    g_mcmcan13.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan13.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan13.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN13_RX;
    g_mcmcan13.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_7;
    g_mcmcan13.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan13.canNodeConfig.baudRate.baudrate = 500000;    
 
    g_mcmcan13.canNodeConfig.pins = &Can13_pins;
    IfxCan_Can_initNode(&g_mcmcan13.canNode, &g_mcmcan13.canNodeConfig);

    //std filter 0
    g_mcmcan13.canFilter.number = 0;
    g_mcmcan13.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan13.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan13.canFilter.id1 = 0;
    g_mcmcan13.canFilter.id2 = 0;
    g_mcmcan13.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan13.canNode), &(g_mcmcan13.canFilter));

    g_mcmcan13.canFilter.number = 0;
    g_mcmcan13.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan13.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan13.canFilter.id1 = 0;
    g_mcmcan13.canFilter.id2 = 0;
    g_mcmcan13.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan13.canNode), &(g_mcmcan13.canFilter));

    g_mcmcan13.rxMsg.readFromRxFifo0 = TRUE;


}


/* *** Add by yinjun, 2022.9.5 */
void initCAN20(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan20.canConfig, &MODULE_CAN2);
    IfxCan_Can_initModule(&g_mcmcan20.canModule, &g_mcmcan20.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan20.canNodeConfig, &g_mcmcan20.canModule);    //set default node value

    g_mcmcan20.canNodeConfig.nodeId = IfxCan_NodeId_0;  //4 node in 1 module
    g_mcmcan20.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan20.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan20.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan20.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan20.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan20.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan20.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan20.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan20.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan20.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan20.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan20.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan20.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan20.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan20.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan20.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan20.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan20.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan20.canNodeConfig.messageRAM.baseAddress = MODULE_CAN2_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan20.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan20.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan10.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan20.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan20.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan20.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan20.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN20_TX;
    g_mcmcan20.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_8;
    g_mcmcan20.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan20.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan20.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN20_RX;
    g_mcmcan20.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_8;
    g_mcmcan20.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan20.canNodeConfig.baudRate.baudrate = 500000;

    g_mcmcan20.canNodeConfig.pins = &Can20_pins;
    IfxCan_Can_initNode(&g_mcmcan20.canNode, &g_mcmcan20.canNodeConfig);

    //std filter 0
    g_mcmcan20.canFilter.number = 0;
    g_mcmcan20.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan20.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan20.canFilter.id1 = 0;
    g_mcmcan20.canFilter.id2 = 0;
    g_mcmcan20.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan20.canNode), &(g_mcmcan20.canFilter));

    g_mcmcan20.canFilter.number = 0;
    g_mcmcan20.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan20.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan20.canFilter.id1 = 0;
    g_mcmcan20.canFilter.id2 = 0;
    g_mcmcan20.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan20.canNode), &(g_mcmcan20.canFilter));

    g_mcmcan20.rxMsg.readFromRxFifo0 = TRUE;
}

void initCAN21(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan21.canConfig, &MODULE_CAN2);
    IfxCan_Can_initModule(&g_mcmcan21.canModule, &g_mcmcan21.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan21.canNodeConfig, &g_mcmcan21.canModule);    //set default node value

    g_mcmcan21.canNodeConfig.nodeId = IfxCan_NodeId_1;  //4 node in 1 module
    g_mcmcan21.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan21.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan21.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan21.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan21.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan21.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan21.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan21.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan21.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan21.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan21.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan21.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan21.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan21.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan21.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan21.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan21.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan21.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan21.canNodeConfig.messageRAM.baseAddress = MODULE_CAN2_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan21.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan21.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan21.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan21.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan21.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes

    //transmit interrupt
//    g_mcmcan21.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
//    g_mcmcan21.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN21_TX;
//    g_mcmcan21.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_10;
//    g_mcmcan21.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;

    //receive interrupt
    g_mcmcan21.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan21.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN21_RX;
    g_mcmcan21.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_9;
    g_mcmcan21.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan21.canNodeConfig.baudRate.baudrate = 500000;

    g_mcmcan21.canNodeConfig.pins = &Can21_pins;
    IfxCan_Can_initNode(&g_mcmcan21.canNode, &g_mcmcan21.canNodeConfig);

    //std filter 0
    g_mcmcan21.canFilter.number = 0;
    g_mcmcan21.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan21.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan21.canFilter.id1 = 0;
    g_mcmcan21.canFilter.id2 = 0;
    g_mcmcan21.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan21.canNode), &(g_mcmcan21.canFilter));

    g_mcmcan21.canFilter.number = 0;
    g_mcmcan21.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan21.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan21.canFilter.id1 = 0;
    g_mcmcan21.canFilter.id2 = 0;
    g_mcmcan21.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan21.canNode), &(g_mcmcan21.canFilter));

    g_mcmcan21.rxMsg.readFromRxFifo0 = TRUE;

}

void initCAN22(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan22.canConfig, &MODULE_CAN2);
    IfxCan_Can_initModule(&g_mcmcan22.canModule, &g_mcmcan22.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan22.canNodeConfig, &g_mcmcan22.canModule);    //set default node value

    g_mcmcan22.canNodeConfig.nodeId = IfxCan_NodeId_2;  //4 node in 1 module
    g_mcmcan22.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan22.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan22.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan22.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan22.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan22.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan22.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan22.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan22.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan22.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan22.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan22.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan22.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan22.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan22.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan22.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan22.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan22.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan22.canNodeConfig.messageRAM.baseAddress = MODULE_CAN2_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan22.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan22.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan22.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan22.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan22.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan22.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan22.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN22_TX;
    g_mcmcan22.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_12;
    g_mcmcan22.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan22.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan22.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN22_RX;
    g_mcmcan22.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_10;
    g_mcmcan22.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan22.canNodeConfig.baudRate.baudrate = 500000;

    g_mcmcan22.canNodeConfig.pins = &Can22_pins;
    IfxCan_Can_initNode(&g_mcmcan22.canNode, &g_mcmcan22.canNodeConfig);

    //std filter 0
    g_mcmcan22.canFilter.number = 0;
    g_mcmcan22.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan22.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan22.canFilter.id1 = 0;
    g_mcmcan22.canFilter.id2 = 0;
    g_mcmcan22.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan22.canNode), &(g_mcmcan22.canFilter));

    g_mcmcan22.canFilter.number = 0;
    g_mcmcan22.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan22.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan22.canFilter.id1 = 0;
    g_mcmcan22.canFilter.id2 = 0;
    g_mcmcan22.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan22.canNode), &(g_mcmcan22.canFilter));

    g_mcmcan22.rxMsg.readFromRxFifo0 = TRUE;


}

void initCAN23(void)
{
    IfxCan_Can_initModuleConfig(&g_mcmcan23.canConfig, &MODULE_CAN2);
    IfxCan_Can_initModule(&g_mcmcan23.canModule, &g_mcmcan23.canConfig);
    IfxCan_Can_initNodeConfig(&g_mcmcan23.canNodeConfig, &g_mcmcan23.canModule);    //set default node value

    g_mcmcan23.canNodeConfig.nodeId = IfxCan_NodeId_3;  //4 node in 1 module
    g_mcmcan23.canNodeConfig.clockSource = IfxCan_ClockSource_both;

    g_mcmcan23.canNodeConfig.frame.type = IfxCan_FrameType_transmitAndReceive;
    g_mcmcan23.canNodeConfig.frame.mode = IfxCan_FrameMode_standard;  //

    g_mcmcan23.canNodeConfig.txConfig.txMode = IfxCan_TxMode_fifo;
    g_mcmcan23.canNodeConfig.txConfig.txFifoQueueSize = 20;
    g_mcmcan23.canNodeConfig.txConfig.dedicatedTxBuffersNumber = 0;
    g_mcmcan23.canNodeConfig.txConfig.txEventFifoSize = 0;
    g_mcmcan23.canNodeConfig.txConfig.txBufferDataFieldSize = IfxCan_DataFieldSize_8;

    g_mcmcan23.canNodeConfig.rxConfig.rxMode = IfxCan_RxMode_fifo0;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo0Size = 20;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo0DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo1Size = 0;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo1DataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan23.canNodeConfig.rxConfig.rxBufferDataFieldSize = IfxCan_DataFieldSize_64;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo0WatermarkLevel = 0;    //event use
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo1WatermarkLevel = 0;
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo0OperatingMode = IfxCan_RxFifoMode_overwrite;   //or block
    g_mcmcan23.canNodeConfig.rxConfig.rxFifo1OperatingMode = IfxCan_RxFifoMode_overwrite;

    g_mcmcan23.canNodeConfig.filterConfig.messageIdLength = IfxCan_MessageIdLength_both;
    g_mcmcan23.canNodeConfig.filterConfig.standardListSize = 32;  //Standard Frame
    g_mcmcan23.canNodeConfig.filterConfig.extendedListSize = 16;  //Extended Frame
    g_mcmcan23.canNodeConfig.filterConfig.rejectRemoteFramesWithStandardId = TRUE;
    g_mcmcan23.canNodeConfig.filterConfig.rejectRemoteFramesWithExtendedId = TRUE;
    g_mcmcan23.canNodeConfig.filterConfig.standardFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;
    g_mcmcan23.canNodeConfig.filterConfig.extendedFilterForNonMatchingFrames = IfxCan_NonMatchingFrame_reject;

    //Message RAM
    g_mcmcan23.canNodeConfig.messageRAM.baseAddress = MODULE_CAN2_RAM;
    //Standard Frame, 32 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan23.canNodeConfig.messageRAM.standardFilterListStartAddress = 0x0 + NODE0_RAM_OFFSET;
    //Extended Frame, 16 elements => 32 words => 128 Bytes => 0x80
    g_mcmcan23.canNodeConfig.messageRAM.extendedFilterListStartAddress = 0x80 + NODE0_RAM_OFFSET;
    //RxFIFO0, 20  elements => 360 words => 1440 Bytes => 0x5A0
    //g_mcmcan23.canNodeConfig.messageRAM.rxBuffersStartAddress = 0x100 + NODE2_RAM_OFFSET;
    g_mcmcan23.canNodeConfig.messageRAM.rxFifo0StartAddress = 0x200 + NODE0_RAM_OFFSET;
    //Tx FIFO Buffers, 20  elements => 360 words => 1440 Bytes => 0x5A0
    g_mcmcan23.canNodeConfig.messageRAM.txBuffersStartAddress = 0x6A0 + NODE0_RAM_OFFSET;
    //Total: 128 + 128 + 1440 + 1440 = 3136 Bytes
/*
    //transmit interrupt
    g_mcmcan23.canNodeConfig.interruptConfig.transmissionCompletedEnabled = TRUE;
    g_mcmcan23.canNodeConfig.interruptConfig.traco.priority = ISR_PRIORITY_CAN23_TX;
    g_mcmcan23.canNodeConfig.interruptConfig.traco.interruptLine = IfxCan_InterruptLine_14;
    g_mcmcan23.canNodeConfig.interruptConfig.traco.typeOfService = IfxSrc_Tos_cpu1;
*/
    //receive interrupt
    g_mcmcan23.canNodeConfig.interruptConfig.rxFifo0NewMessageEnabled = TRUE;
    g_mcmcan23.canNodeConfig.interruptConfig.rxf0n.priority = ISR_PRIORITY_CAN23_RX;
    g_mcmcan23.canNodeConfig.interruptConfig.rxf0n.interruptLine = IfxCan_InterruptLine_11;
    g_mcmcan23.canNodeConfig.interruptConfig.rxf0n.typeOfService = IfxSrc_Tos_cpu1;

    g_mcmcan23.canNodeConfig.baudRate.baudrate = 500000;

    g_mcmcan23.canNodeConfig.pins = &Can23_pins;
    IfxCan_Can_initNode(&g_mcmcan23.canNode, &g_mcmcan23.canNodeConfig);

    //std filter 0
    g_mcmcan23.canFilter.number = 0;
    g_mcmcan23.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan23.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan23.canFilter.id1 = 0;
    g_mcmcan23.canFilter.id2 = 0;
    g_mcmcan23.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;  //maybe need change
    IfxCan_Can_setStandardFilter(&(g_mcmcan23.canNode), &(g_mcmcan23.canFilter));

    g_mcmcan23.canFilter.number = 0;
    g_mcmcan23.canFilter.elementConfiguration = IfxCan_FilterElementConfiguration_storeInRxFifo0;
    g_mcmcan23.canFilter.type = IfxCan_FilterType_classic;
    g_mcmcan23.canFilter.id1 = 0;
    g_mcmcan23.canFilter.id2 = 0;
    g_mcmcan23.canFilter.rxBufferOffset = IfxCan_RxBufferId_0;
    IfxCan_Can_setExtendedFilter(&(g_mcmcan23.canNode), &(g_mcmcan23.canFilter));

    g_mcmcan23.rxMsg.readFromRxFifo0 = TRUE;


}

void configCAN00(void)
{
    IfxCan_Can_initMessage(&g_mcmcan00.txMsg);
    g_mcmcan00.txMsg.messageId = CAN_MESSAGE_TX_ID00;
    g_mcmcan00.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan00.txMsg.bufferNumber = 0;
    g_mcmcan00.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan00.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan00.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan00.txData[0] = 0x01234567;
    g_mcmcan00.txData[1] = 0x89abcdef;
}

void configCAN01(void)
{
    IfxCan_Can_initMessage(&g_mcmcan01.txMsg);
    g_mcmcan01.txMsg.messageId = CAN_MESSAGE_TX_ID01;
    g_mcmcan01.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan01.txMsg.bufferNumber = 0;
    g_mcmcan01.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan01.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan01.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan01.txData[0] = 0x01234567;
    g_mcmcan01.txData[1] = 0x89abcdef;
}

void configCAN02(void)
{
    IfxCan_Can_initMessage(&g_mcmcan02.txMsg);
    g_mcmcan02.txMsg.messageId = CAN_MESSAGE_TX_ID02;
    g_mcmcan02.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan02.txMsg.bufferNumber = 0;
    g_mcmcan02.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan02.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
//    g_mcmcan02.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan02.txMsg.messageIdLength=IfxCan_MessageIdLength_standard;  //Standard Frame，20221107
    g_mcmcan02.txData[0] = 0x01234567;
    g_mcmcan02.txData[1] = 0x89abcdef;
}

void configCAN03(void)
{
    IfxCan_Can_initMessage(&g_mcmcan03.txMsg);
    g_mcmcan03.txMsg.messageId = CAN_MESSAGE_TX_ID03;
    g_mcmcan03.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan03.txMsg.bufferNumber = 0;
    g_mcmcan03.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan03.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan03.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan03.txData[0] = 0x01234567;
    g_mcmcan03.txData[1] = 0x89abcdef;
}

void configCAN10(void)
{
    IfxCan_Can_initMessage(&g_mcmcan10.txMsg);
    g_mcmcan10.txMsg.messageId = CAN_MESSAGE_TX_ID10;
    g_mcmcan10.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan10.txMsg.bufferNumber = 0;
    g_mcmcan10.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan10.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan10.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan10.txData[0] = 0x01234567;
    g_mcmcan10.txData[1] = 0x89abcdef;
}

void configCAN11(void)
{
    IfxCan_Can_initMessage(&g_mcmcan11.txMsg);
    g_mcmcan11.txMsg.messageId = CAN_MESSAGE_TX_ID11;
    g_mcmcan11.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan11.txMsg.bufferNumber = 0;
    g_mcmcan11.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan11.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan11.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan11.txData[0] = 0x01234567;
    g_mcmcan11.txData[1] = 0x89abcdef;
}

void configCAN12(void)
{
    IfxCan_Can_initMessage(&g_mcmcan12.txMsg);
    g_mcmcan12.txMsg.messageId = CAN_MESSAGE_TX_ID12;
    g_mcmcan12.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan12.txMsg.bufferNumber = 0;
    g_mcmcan12.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan12.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan12.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan12.txData[0] = 0x01234567;
    g_mcmcan12.txData[1] = 0x89abcdef;
}

void configCAN13(void)
{
    IfxCan_Can_initMessage(&g_mcmcan13.txMsg);
    g_mcmcan13.txMsg.messageId = CAN_MESSAGE_TX_ID13;
    g_mcmcan13.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan13.txMsg.bufferNumber = 0;
    g_mcmcan13.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan13.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan13.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan13.txData[0] = 0x01234567;
    g_mcmcan13.txData[1] = 0x89abcdef;
}



/* *** Add by yinjun, 2022.9.5 */
void configCAN20(void)
{
    IfxCan_Can_initMessage(&g_mcmcan20.txMsg);
    g_mcmcan20.txMsg.messageId = CAN_MESSAGE_TX_ID20;
    g_mcmcan20.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan20.txMsg.bufferNumber = 0;
    g_mcmcan20.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan20.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan20.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan20.txData[0] = 0x01234567;
    g_mcmcan20.txData[1] = 0x89abcdef;
}

void configCAN21(void)
{
    IfxCan_Can_initMessage(&g_mcmcan21.txMsg);
    g_mcmcan21.txMsg.messageId = CAN_MESSAGE_TX_ID21;
    g_mcmcan21.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan21.txMsg.bufferNumber = 0;
    g_mcmcan21.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan21.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan21.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan21.txData[0] = 0x01234567;
    g_mcmcan21.txData[1] = 0x89abcdef;
}

void configCAN22(void)
{
    IfxCan_Can_initMessage(&g_mcmcan22.txMsg);
    g_mcmcan22.txMsg.messageId = CAN_MESSAGE_TX_ID22;
    g_mcmcan22.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan22.txMsg.bufferNumber = 0;
    g_mcmcan22.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan22.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan22.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan22.txData[0] = 0x01234567;
    g_mcmcan22.txData[1] = 0x89abcdef;
}

void configCAN23(void)
{
    IfxCan_Can_initMessage(&g_mcmcan23.txMsg);
    g_mcmcan23.txMsg.messageId = CAN_MESSAGE_TX_ID23;
    g_mcmcan23.txMsg.remoteTransmitRequest = FALSE;
    g_mcmcan23.txMsg.bufferNumber = 0;
    g_mcmcan23.txMsg.dataLengthCode = IfxCan_DataLengthCode_8;//8 bytes
    g_mcmcan23.txMsg.frameMode = IfxCan_FrameMode_standard;   //Classic CAN
    g_mcmcan23.txMsg.messageIdLength=IfxCan_MessageIdLength_extended;  //Extended Frame
    g_mcmcan23.txData[0] = 0x01234567;
    g_mcmcan23.txData[1] = 0x89abcdef;
}




void sendDataCAN00(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan00.txMsg.messageId = messageId;
    memcpy(g_mcmcan00.txData, bufSend,8);

    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan00.canNode, &g_mcmcan00.txMsg, &g_mcmcan00.txData[0]) && cnt--);
}
void sendDataCAN01(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan01.txMsg.messageId = messageId;
    memcpy(g_mcmcan01.txData, bufSend,8);

    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan01.canNode, &g_mcmcan01.txMsg, &g_mcmcan01.txData[0]) && cnt--);
}

void sendDataCAN02(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan02.txMsg.messageId = messageId;
    memcpy(g_mcmcan02.txData, bufSend,8);

    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan02.canNode, &g_mcmcan02.txMsg, &g_mcmcan02.txData[0]) && cnt--);
}

void sendDataCAN03(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan03.txMsg.messageId = messageId;
    memcpy(g_mcmcan03.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan03.canNode, &g_mcmcan03.txMsg, &g_mcmcan03.txData[0]) && cnt--);
}

void sendDataCAN10(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan10.txMsg.messageId = messageId;
    memcpy(g_mcmcan10.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan10.canNode, &g_mcmcan10.txMsg, &g_mcmcan10.txData[0]) && cnt--);
}

void sendDataCAN11(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan11.txMsg.messageId = messageId;
    memcpy(g_mcmcan11.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan11.canNode, &g_mcmcan11.txMsg, &g_mcmcan11.txData[0]) && cnt--);
}

void sendDataCAN12(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan12.txMsg.messageId = messageId;
    memcpy(g_mcmcan12.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan12.canNode, &g_mcmcan12.txMsg, &g_mcmcan12.txData[0]) && cnt--);
}

void sendDataCAN13(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan13.txMsg.messageId = messageId;
    memcpy(g_mcmcan13.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan13.canNode, &g_mcmcan13.txMsg, &g_mcmcan13.txData[0]) && cnt--);
}



/* *** Add by yinjun, 2022.9.5 */
void sendDataCAN20(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan20.txMsg.messageId = messageId;
    memcpy(g_mcmcan20.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan20.canNode, &g_mcmcan20.txMsg, &g_mcmcan20.txData[0]) && cnt--);
}

void sendDataCAN21(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan21.txMsg.messageId = messageId;
    memcpy(g_mcmcan21.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan21.canNode, &g_mcmcan21.txMsg, &g_mcmcan21.txData[0]) && cnt--);
}

void sendDataCAN22(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan22.txMsg.messageId = messageId;
    memcpy(g_mcmcan22.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan22.canNode, &g_mcmcan22.txMsg, &g_mcmcan22.txData[0]) && cnt--);
}

void sendDataCAN23(uint32 messageId, uint8 *bufSend)
{
    int cnt = CAN_RESEND_CNT;
    g_mcmcan23.txMsg.messageId = messageId;
    memcpy(g_mcmcan23.txData, bufSend,8);
    while(IfxCan_Status_notSentBusy ==
                    IfxCan_Can_sendMessage(&g_mcmcan23.canNode, &g_mcmcan23.txMsg, &g_mcmcan23.txData[0]) && cnt--);
}


/***********************************************************************************************************************
* Function Name : Can_Send_Message
* Description   : 闁瀚ㄩ幐鍥х暰閻ㄥ嚋AN闁岸浜鹃敍瀛婣N ID閿涘瓓uf閵嗗倸褰傞柅浣规殶閹癸拷
* Arguments     : 
* Return Value  : 
* Author        : Turing
* Date          : 2022.00.00
***********************************************************************************************************************/

void Can_Send_Message(uint8 Channle,uint32 messageId, uint8 *bufSend)
{
    switch (Channle)
    {
        
        case 1: sendDataCAN00(messageId, bufSend); break;
        case 2: sendDataCAN01(messageId, bufSend); break;
        case 3: sendDataCAN02(messageId, bufSend); break;
        case 4: sendDataCAN03(messageId, bufSend); break;
        case 5: sendDataCAN10(messageId, bufSend); break;
        case 6: sendDataCAN11(messageId, bufSend); break;
        case 7: sendDataCAN12(messageId, bufSend); break;
        case 8: sendDataCAN13(messageId, bufSend); break;
        /* *** Add by yinjun, 2022.9.5 */
        case 9: sendDataCAN20(messageId, bufSend); break;
        case 10: sendDataCAN21(messageId, bufSend); break;
        case 11: sendDataCAN22(messageId, bufSend); break;
        case 12: sendDataCAN23(messageId, bufSend); break;
        default:
            Ifx_Console_print("CAN Channel ID Err.(ID:1~8)\r\n");
            break;
    }
}


/***********************************************************************************************************************
* Function Name : Can send Message test
* Description   : 鐠嬪啰鏁ら崥搴″絺闁焦瀵氱�规氨娈戦弫鐗堝祦
* Arguments     :
* Return Value  :
* Author        : yinjun
* Date          : 2022.9.6
***********************************************************************************************************************/
void tztek_can_test(void)
{
    static int cnt = 0;
    uint8 databuf[8] = {0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07};

//    if (cnt == 60000)
    {
//        sendDataCAN00((uint32)0x20, databuf);
        sendDataCAN01((uint32)0x21, databuf);
        sendDataCAN02((uint32)0x22, databuf);
        sendDataCAN03((uint32)0x23, databuf);
        sendDataCAN10((uint32)0x24, databuf);
        sendDataCAN11((uint32)0x25, databuf);
        sendDataCAN12((uint32)0x26, databuf);
        sendDataCAN13((uint32)0x27, databuf);
        sendDataCAN20((uint32)0x28, databuf);
        sendDataCAN21((uint32)0x29, databuf);
        sendDataCAN22((uint32)0x2a, databuf);
        sendDataCAN23((uint32)0x2b, databuf); 
        cnt  = 0;       
    }
    
    cnt++;

}

void can_init(void)
{
    initCAN00();
    initCAN01();
    
    initCAN02();
    initCAN03();

    initCAN10();
    initCAN11();
    initCAN12();
    initCAN13();

    configCAN00();
    configCAN01();
    configCAN02();
    configCAN03();

    configCAN10();
    configCAN11();
    configCAN12();
    configCAN13();
    /* *** Add by yinjun, 2022.9.5 */
    initCAN20();
    initCAN21();
    initCAN22();
    initCAN23();

    configCAN20();
    configCAN21();
    configCAN22();
    configCAN23();
//    Ifx_print("can init ok\r\n");
}

