#ifndef __TZTEK_CAN_H_
#define __TZTEK_CAN_H_
#include "IfxCan_Can.h"
#include "IfxCan.h"
#include "IfxCpu_Irq.h"
#include "Ifx_Console.h"
//#include "UART_Logging.h"
#include <string.h>


#define CAN_MESSAGE_ID 0x777

#define MODULE_CAN0_RAM 0xF0200000
#define MODULE_CAN1_RAM 0xF0210000
#define MODULE_CAN2_RAM 0xF0220000

#define NODE0_RAM_OFFSET 0x0
#define NODE1_RAM_OFFSET 0x1000

/* *** Add by Turing, 2022.2.14 */
#define NODE2_RAM_OFFSET   0x2000
#define NODE3_RAM_OFFSET   0x3000

#define CAN_MESSAGE_TX_ID00             (uint32)0x1234500
#define CAN_MESSAGE_TX_ID01             (uint32)0x1234501
#define CAN_MESSAGE_TX_ID02             (uint32)0x1234502
#define CAN_MESSAGE_TX_ID03             (uint32)0x1234503
#define CAN_MESSAGE_TX_ID10             (uint32)0x1234510
#define CAN_MESSAGE_TX_ID11             (uint32)0x1234511
#define CAN_MESSAGE_TX_ID12             (uint32)0x1234512
#define CAN_MESSAGE_TX_ID13             (uint32)0x1234513
/* *** Add by yinjun, 2022.9.5 */
#define CAN_MESSAGE_TX_ID20             (uint32)0x1234520
#define CAN_MESSAGE_TX_ID21             (uint32)0x1234521
#define CAN_MESSAGE_TX_ID22             (uint32)0x1234522
#define CAN_MESSAGE_TX_ID23             (uint32)0x1234523

#define CAN_MESSAGE_RX_ID00             (uint32)0x1234500
#define CAN_MESSAGE_RX_ID01             (uint32)0x1234501
#define CAN_MESSAGE_RX_ID02             (uint32)0x1234502
#define CAN_MESSAGE_RX_ID03             (uint32)0x1234503
#define CAN_MESSAGE_RX_ID10             (uint32)0x1234510
#define CAN_MESSAGE_RX_ID11             (uint32)0x1234511
#define CAN_MESSAGE_RX_ID12             (uint32)0x1234512
#define CAN_MESSAGE_RX_ID13             (uint32)0x1234513
/* *** Add by yinjun, 2022.9.5 */
#define CAN_MESSAGE_RX_ID20             (uint32)0x1234520
#define CAN_MESSAGE_RX_ID21             (uint32)0x1234521
#define CAN_MESSAGE_RX_ID22             (uint32)0x1234522
#define CAN_MESSAGE_RX_ID23             (uint32)0x1234523

#define ISR_PRIORITY_CAN00_TX         100                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN00_RX         101                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN01_TX         102                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN01_RX         103                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN02_TX         104                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN02_RX         105                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN03_TX         106                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN03_RX         107                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN10_TX         108                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN10_RX         109                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN11_TX         110                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN11_RX         111                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN12_TX         112                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN12_RX         113                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN13_TX         114                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN13_RX         115                       /* Define the CAN RX interrupt priority                 */

/* *** Add by yinjun, 2022.9.5 */
#define ISR_PRIORITY_CAN20_TX         116                      /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN20_RX         117                      /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN21_TX         118                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN21_RX         119                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN22_TX         120                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN22_RX         121                       /* Define the CAN RX interrupt priority                 */
#define ISR_PRIORITY_CAN23_TX         122                       /* Define the CAN TX interrupt priority                 */
#define ISR_PRIORITY_CAN23_RX         123                       /* Define the CAN RX interrupt priority                 */
#define MAXIMUM_CAN_DATA_PAYLOAD    2                           /* Define maximum classical CAN payload in 4-byte words */



#define NODE_RAM_OFFSET 0x1000

typedef struct
{
    IfxCan_Can_Config canConfig;                            /* CAN module configuration structure                   */
    IfxCan_Can canModule;                                   /* CAN module handle                                    */
    IfxCan_Can_Node canNode;                             /* CAN source node handle data structure                */
    IfxCan_Can_NodeConfig canNodeConfig;                    /* CAN node configuration structure                     */
    IfxCan_Filter canFilter;                                /* CAN filter configuration structure                   */
    IfxCan_Message txMsg;                                   /* Transmitted CAN message structure                    */
    IfxCan_Message rxMsg;                                   /* Received CAN message structure                       */
    uint32 txData[MAXIMUM_CAN_DATA_PAYLOAD];                /* Transmitted CAN data array                           */
    uint32 rxData[MAXIMUM_CAN_DATA_PAYLOAD];                /* Received CAN data array                              */
} McmcanType;


void initCAN00(void);
void initCAN01(void);
void initCAN02(void);
void initCAN03(void);

void initCAN10(void);
void initCAN11(void);
void initCAN12(void);
void initCAN13(void);

void initCAN20(void);
void initCAN21(void);
void initCAN22(void);
void initCAN23(void);

void configCAN00(void);
void configCAN01(void);
void configCAN02(void);
void configCAN03(void);


void configCAN10(void);
void configCAN11(void);
void configCAN12(void);
void configCAN13(void);

void configCAN20(void);
void configCAN21(void);
void configCAN22(void);
void configCAN23(void);

void sendDataCAN00(uint32 messageId, uint8 *bufSend);
void sendDataCAN01(uint32 messageId, uint8 *bufSend);
void sendDataCAN02(uint32 messageId, uint8 *bufSend);
void sendDataCAN03(uint32 messageId, uint8 *bufSend);

void sendDataCAN10(uint32 messageId, uint8 *bufSend);
void sendDataCAN11(uint32 messageId, uint8 *bufSend);
void sendDataCAN12(uint32 messageId, uint8 *bufSend);
void sendDataCAN13(uint32 messageId, uint8 *bufSend);

void sendDataCAN20(uint32 messageId, uint8 *bufSend);
void sendDataCAN21(uint32 messageId, uint8 *bufSend);
void sendDataCAN22(uint32 messageId, uint8 *bufSend);
void sendDataCAN23(uint32 messageId, uint8 *bufSend);
void Can_Send_Message(uint8 Channle,uint32 messageId, uint8 *bufSend);
void tztek_can_test(void);

void can_init(void);

#endif
