#include "tztek_gpio.h"
#include "Ifx_Console.h"

#define WAIT_TIME       230


void tztek_gpio_init(void)
{
    IfxPort_setPinMode(GPIO_EXTERNAL_PIN_1, IfxPort_Mode_outputPushPullGeneral);
    IfxPort_setPinMode(GPIO_EXTERNAL_PIN_2, IfxPort_Mode_outputPushPullGeneral);

    IfxPort_setPinMode(MCU_B_TO_ORIN_MASTER_0, IfxPort_Mode_inputNoPullDevice);
    IfxPort_setPinMode(MCU_B_TO_ORIN_MASTER_1, IfxPort_Mode_inputNoPullDevice);
    IfxPort_setPinMode(MCU_B_TO_ORIN_SLAVE_0, IfxPort_Mode_inputNoPullDevice);
    IfxPort_setPinMode(MCU_B_TO_ORIN_SLAVE_1, IfxPort_Mode_inputNoPullDevice);

    IfxPort_setPinMode(MCU_A_TO_MCU_B_0, IfxPort_Mode_inputNoPullDevice);
    IfxPort_setPinMode(MCU_A_TO_MCU_B_1, IfxPort_Mode_outputPushPullGeneral);

    IfxPort_setPinHigh(GPIO_EXTERNAL_PIN_2);
    IfxPort_setPinHigh(GPIO_EXTERNAL_PIN_1);

    //鍥犱负Orin涓婄數闂涓存椂鍏抽棴锛?
//    IfxPort_setPinLow(MCU_B_TO_ORIN_MASTER_0);
//    IfxPort_setPinLow(MCU_B_TO_ORIN_SLAVE_0);
//    IfxPort_setPinLow(MCU_B_TO_ORIN_MASTER_1);
//    IfxPort_setPinLow(MCU_B_TO_ORIN_SLAVE_1);
//    IfxPort_setPinHigh(MCU_A_TO_MCU_B_0);
    IfxPort_setPinHigh(MCU_A_TO_MCU_B_1);
}



void tztek_gpio_test(void)
{
    static uint8 Value150 = 0, Value151 = 0, Value344 = 0, Value345 = 0,
            pre_value_Mcu_B = 99, pre_value_Orin_A = 99;
    static int cnt = 0;
    static int cnt2 = 0;

    if(cnt == 60000) {

        if(cnt2 > 100) {
            IfxPort_togglePin(GPIO_EXTERNAL_PIN_1);
            IfxPort_togglePin(GPIO_EXTERNAL_PIN_2);

            waitTime(IfxStm_getTicksFromMilliseconds(BSP_DEFAULT_TIMER, WAIT_TIME));

            if(IfxPort_getPinState(MCU_A_TO_MCU_B_0) == 0){
                IfxPort_togglePin(MCU_A_TO_MCU_B_1);
                Value150 = IfxPort_getPinState(MCU_A_TO_MCU_B_0);
                Value151 = IfxPort_getPinState(MCU_A_TO_MCU_B_1);
                if((pre_value_Mcu_B + Value151) == 1)
                    Ifx_Console_print("mcu_B to mcu_A gpio is ok!\n");
                pre_value_Mcu_B = Value151;
//                Ifx_Console_print("Pin state of P15_1 were : %d\r\n", Value151);
            }
            /*MCU鍜孫RIN_A涔嬮棿GPIO鍥炵幆娴嬭瘯*/
            if(IfxPort_getPinState(MCU_B_TO_ORIN_MASTER_1) != Value345){
                IfxPort_togglePin(MCU_B_TO_ORIN_MASTER_0);
                Value344 = IfxPort_getPinState(MCU_B_TO_ORIN_MASTER_0);
                Value345 = IfxPort_getPinState(MCU_B_TO_ORIN_MASTER_1);
				if((pre_value_Orin_A + Value344) == 1)
                    Ifx_Console_print("Mcu_B to Orin_A gpio is ok!\n");
                pre_value_Orin_A = Value344;
//                Ifx_Console_print("Pin state of P34_4, P34_5 were :%d, %d\r\n", Value344, Value345);
            }
            /*MCU鍜孫RIN_B涔嬮棿GPIO鍥炵幆娴嬭瘯*/
    #ifdef orintest
            else if(IfxPort_getPinState(MCU_B_TO_ORIN_SLAVE_0) != Value150){
                IfxPort_togglePin(MCU_B_TO_ORIN_SLAVE_1);
            }
    #endif
            Value150 = IfxPort_getPinState(MCU_B_TO_ORIN_SLAVE_0);
            Value151 = IfxPort_getPinState(MCU_B_TO_ORIN_SLAVE_1);
            Ifx_Console_print("P22_6: %d  P23_7: %d, \r\n", Value150, Value151);
            cnt2 = 0;
        }
        cnt2++;
        cnt = 0;
    }
    cnt++;

}
