#ifndef __TZTEK_GPS_H
#define __TZTEK_GPS_H

#include "Ifx_Types.h"
#include "Bsp.h"
#include "IfxCpu.h"
#include "IfxScuWdt.h"
#include "Ifx_Console.h"
#include "UART_Logging.h"
#include "IfxAsclin_Asc.h"
#include "IfxCpu_Irq.h"
#include <string.h>

#define GPS_CMD_SAVE               "$PCAS00*01\r\n"
#define GPS_CMD_SET_BAUD_115200    "$PCAS01,5*19\r\n"
#define GPS_CMD_SET_FREQ           "$PCAS02,1000*2E\r\n"
#define GPS_CMD_SET_NMEA_MSG       "$PCAS03,1,0,0,0,1,0,0,0,0,0,,,0,0*02\r\n"
#define GPS_CMD_SET_SATELLITE      "$PCAS04,7*1E\r\n"
#define GPS_CMD_SET_PRO            "$PCAS05,2*1A\r\n"
#define GPS_CMD_SET_HOT_REBOOT     "$PCAS10,0*1C\r\n"
#define GPS_CMD_SET_RUN_MODE       "$PCAS11,0*1D\r\n"
#define GPS_CMD_SET_TIME           "\xC2\xBA\xC3\x8E\x10\x00\x06\x03\x40\x42\x0F\x00\xC2\xA0\xC2\x86\x01\x00\x02\x00\x01\x05\x00\x00\x00\x00\xC3\xB2\xC3\x88\x17\x08"


#define SERIAL_BAUDRATE_9600           9600                                        /* Baud rate in bit/s                   */
#define SERIAL_BAUDRATE_115200         115200                                      /* Baud rate in bit/s                   */

#define GPS_PIN_RX           IfxAsclin8_RXD_P33_6_IN                     /* RX pin of the board                  */
#define GPS_PIN_TX           IfxAsclin8_TX_P33_7_OUT                     /* TX pin of the board                  */

/* Priority of the ISR*/
#define INTPRIO_ASCLIN8_GPS_TX      29
#define INTPRIO_ASCLIN8_GPS_RX      28
#define INTPRIO_ASCLIN8_GPS_ER      33

#define ASC_TX_BUFFER_SIZE      1024                                          /* Definition of the buffer size        */
#define ASC_RX_BUFFER_SIZE      1024                                          /* Definition of the buffer size        */


void tztek_lin8_Init(void);
void tztek_gps_config(void);
void tztek_SendMseeage_2_Gps(const void *data, Ifx_SizeT count);

#endif
