#include "tztek_spi.h"

/* 閫夋嫨鐑у啓鐨凪CU涓轰富鏈烘ā寮忚繕鏄粠鏈烘ā寮� 锛堜富MCU鐑т富鏈烘ā寮忥紝浠嶮CU鐑т粠鏈烘ā寮忥級*/
//#define M_MCU
#define S_MCU

/* mcu与主orin通信时，mcu作为主机还是从机 */
#define MASTER
//#define SLAVE

/* mcu鐨剆pi1浣滀负浠庢満妯″紡 */
//#define SPI1_SLAVE

uint8 flag = 0;

qspiComm g_qspi_mcu;
qspiComm g_qspi_m_orin;
qspiComm g_qspi_s_orin;


IFX_INTERRUPT(mcuTxISR, 0, ISR_PRIORITY_MCU_TX);                    /* SPI ISR for transmit data          */
IFX_INTERRUPT(mcuRxISR, 0, ISR_PRIORITY_MCU_RX);                    /* SPI ISR for receive data           */
IFX_INTERRUPT(mcuErISR, 0, ISR_PRIORITY_MCU_ER);                    /* SPI ISR for error                  */

IFX_INTERRUPT(morinTxISR, 0, ISR_PRIORITY_M_ORIN_SLAVE_TX);         /* SPI Slave ISR for transmit data          */
IFX_INTERRUPT(morinRxISR, 0, ISR_PRIORITY_M_ORIN_SLAVE_RX);         /* SPI Slave ISR for receive data           */
IFX_INTERRUPT(morinErISR, 0, ISR_PRIORITY_M_ORIN_SLAVE_ER);         /* SPI Slave ISR for error                  */

IFX_INTERRUPT(sorinTxISR, 0, ISR_PRIORITY_S_ORIN_SLAVE_TX);         /* SPI Slave ISR for transmit data          */
IFX_INTERRUPT(sorinRxISR, 0, ISR_PRIORITY_S_ORIN_SLAVE_RX);         /* SPI Slave ISR for receive data           */
IFX_INTERRUPT(sorinErISR, 0, ISR_PRIORITY_S_ORIN_SLAVE_ER);         /* SPI Slave ISR for error                  */


#ifdef M_MCU
void mcuTxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrTransmit(&g_qspi_mcu.spiMaster);
}

void mcuRxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrReceive(&g_qspi_mcu.spiMaster);

}

void mcuErISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrError(&g_qspi_mcu.spiMaster);
}

#endif


#ifdef S_MCU
void mcuTxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrTransmit(&g_qspi_mcu.spiSlave);
}

void mcuRxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrReceive(&g_qspi_mcu.spiSlave);
}

void mcuErISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrError(&g_qspi_mcu.spiSlave);
}
#endif

#ifdef SLAVE
void morinTxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrTransmit(&g_qspi_m_orin.spiSlave);
}

void morinRxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrReceive(&g_qspi_m_orin.spiSlave);
}

void morinErISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiSlave_isrError(&g_qspi_m_orin.spiSlave);
}
#endif

#ifdef MASTER
void morinTxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrTransmit(&g_qspi_m_orin.spiMaster);
}

void morinRxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrReceive(&g_qspi_m_orin.spiMaster);
}

void morinErISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrError(&g_qspi_m_orin.spiMaster);
}

#endif

void sorinTxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrError(&g_qspi_s_orin.spiMaster);
}

void sorinRxISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrError(&g_qspi_s_orin.spiMaster);
}

void sorinErISR()
{
    IfxCpu_enableInterrupts();
    IfxQspi_SpiMaster_isrError(&g_qspi_s_orin.spiMaster);
}

#ifdef M_MCU
/********************************************************************************************************************
 * Function Name : initQSPIMcuConfig
 * Description   : 鍒濆鍖栦富MCU鐨剆pi鎺у埗鍣�
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPIMcuConfig(void)
{
    IfxQspi_SpiMaster_Config spiMasterConfig;                             /* Define the Master configuration           */

    IfxQspi_SpiMaster_initModuleConfig(&spiMasterConfig, QSPI_MCU);    /* Initialize it with default values        */

    spiMasterConfig.base.mode = SpiIf_Mode_master;                      /* Configure the mode                       */

    /* Select the port pins for communication */
    const IfxQspi_SpiMaster_Pins qspi4MasterPins = {
        &IfxQspi4_SCLK_P22_3_OUT, IfxPort_OutputMode_pushPull,           /* SCLK Pin                       (CLK)     */
        &IfxQspi4_MTSR_P22_0_OUT, IfxPort_OutputMode_pushPull,           /* MasterTransmitSlaveReceive pin (MOSI)    */
        &IfxQspi4_MRSTB_P22_1_IN, IfxPort_InputMode_pullDown,          /* MasterReceiveSlaveTransmit pin (MISO)    */
        IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
    };
    spiMasterConfig.pins = &qspi4MasterPins;                              /* Assign Matser port pins                   */

    /* Set the ISR priorities and the service provider */
    spiMasterConfig.base.txPriority = ISR_PRIORITY_MCU_TX;
    spiMasterConfig.base.rxPriority = ISR_PRIORITY_MCU_RX;
    spiMasterConfig.base.erPriority = ISR_PRIORITY_MCU_ER;
    spiMasterConfig.base.isrProvider = IfxSrc_Tos_cpu0;

    /* Initialize QSPI Master module */
    IfxQspi_SpiMaster_initModule(&g_qspi_mcu.spiMaster, &spiMasterConfig);
}

/********************************************************************************************************************
 * Function Name : initQSPI4MasterChannel
 * Description   : 鍒濆鍖杝pi涓绘満閫氶亾
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPI4MasterChannel(void)
{
    IfxQspi_SpiMaster_ChannelConfig spiMasterChannelConfig;             /* Define a Master Channel configuration    */

    /* Initialize the configuration with default values */
    IfxQspi_SpiMaster_initChannelConfig(&spiMasterChannelConfig, &g_qspi_mcu.spiMaster);

    spiMasterChannelConfig.base.baudrate = MASTER_CHANNEL_BAUDRATE;     /* Set SCLK frequency to 1 MHz              */

    /* Select the port pin for the Chip Select signal */
    const IfxQspi_SpiMaster_Output qspi4SlaveSelect = {                 /* QSPI2 Master selects the QSPI3 Slave     */
        &IfxQspi4_SLSO3_P22_2_OUT, IfxPort_OutputMode_pushPull,         /* Slave Select port pin (CS)               */
        IfxPort_PadDriver_cmosAutomotiveSpeed1                          /* Pad driver mode                          */
    };
    spiMasterChannelConfig.sls.output = qspi4SlaveSelect;

    /* Initialize the QSPI Master channel */
    IfxQspi_SpiMaster_initChannel(&g_qspi_mcu.spiMasterChannel, &spiMasterChannelConfig);
}

#endif


#ifdef S_MCU
/********************************************************************************************************************
 * Function Name : initQSPIMcuConfig
 * Description   : 鍒濆鍖栦粠MCU鐨剆pi鎺у埗鍣�
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPIMcuConfig(void)
{
    IfxQspi_SpiSlave_Config spiSlaveConfig;                             /* Define the Slave configuration           */

    IfxQspi_SpiSlave_initModuleConfig(&spiSlaveConfig, QSPI_MCU);    /* Initialize it with default values        */

    /* Select the port pins for communication */
    const IfxQspi_SpiSlave_Pins qspi4SlavePins = {
        &IfxQspi4_SCLKB_P22_3_IN, IfxPort_InputMode_pullDown,           /* SCLK Pin                       (CLK)     */
        &IfxQspi4_MTSRB_P22_0_IN, IfxPort_InputMode_pullDown,           /* MasterTransmitSlaveReceive pin (MOSI)    */
        &IfxQspi4_MRST_P22_1_OUT, IfxPort_OutputMode_pushPull,          /* MasterReceiveSlaveTransmit pin (MISO)    */
        &IfxQspi4_SLSIB_P22_2_IN, IfxPort_InputMode_pullDown,           /* SlaveSelect Pin                (CS)      */
        IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
    };
    spiSlaveConfig.pins = &qspi4SlavePins;                              /* Assign Slave port pins                   */

    /* Set the ISR priorities and the service provider */
    spiSlaveConfig.base.txPriority = ISR_PRIORITY_MCU_TX;
    spiSlaveConfig.base.rxPriority = ISR_PRIORITY_MCU_RX;
    spiSlaveConfig.base.erPriority = ISR_PRIORITY_MCU_ER;
    spiSlaveConfig.base.isrProvider = IfxSrc_Tos_cpu0;

    /* Initialize QSPI Slave module */
    IfxQspi_SpiSlave_initModule(&g_qspi_mcu.spiSlave, &spiSlaveConfig);
}
#endif


/********************************************************************************************************************
 * Function Name : initQSPIMOrinConfig
 * Description   : 鍒濆鍖栦富orin瀵瑰簲鐨剆pi
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
#ifdef SLAVE
void initQSPIMOrinConfig(void)
{
    IfxQspi_SpiSlave_Config spiSlaveConfig;                             /* Define the Slave configuration           */

    IfxQspi_SpiSlave_initModuleConfig(&spiSlaveConfig, QSPI_M_ORIN);    /* Initialize it with default values        */


    const IfxQspi_SpiSlave_Pins qspi0SlavePins = {
        &IfxQspi0_SCLKA_P20_11_IN, IfxPort_InputMode_pullDown,           /* SCLK Pin                       (CLK)     */
        &IfxQspi0_MTSRA_P20_14_IN, IfxPort_InputMode_pullDown,           /* MasterTransmitSlaveReceive pin (MOSI)    */
        &IfxQspi0_MRST_P20_12_OUT, IfxPort_OutputMode_pushPull,          /* MasterReceiveSlaveTransmit pin (MISO)    */
        &IfxQspi0_SLSIA_P20_13_IN, IfxPort_InputMode_pullDown,           /* SlaveSelect Pin                (CS)      */
        IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
    };
    spiSlaveConfig.pins = &qspi0SlavePins;                              /* Assign Slave port pins                   */

    /* Set the ISR priorities and the service provider */
    spiSlaveConfig.base.txPriority = ISR_PRIORITY_M_ORIN_SLAVE_TX;
    spiSlaveConfig.base.rxPriority = ISR_PRIORITY_M_ORIN_SLAVE_RX;
    spiSlaveConfig.base.erPriority = ISR_PRIORITY_M_ORIN_SLAVE_ER;
    spiSlaveConfig.base.isrProvider = IfxSrc_Tos_cpu0;

    /* Initialize QSPI Slave module */
    IfxQspi_SpiSlave_initModule(&g_qspi_m_orin.spiSlave, &spiSlaveConfig);
}
#endif

#ifdef MASTER

void initQSPIMOrinConfig(void)
{
    IfxQspi_SpiMaster_Config spiMasterConfig;                           /* Define a Master configuration            */

    IfxQspi_SpiMaster_initModuleConfig(&spiMasterConfig, QSPI_M_ORIN); /* Initialize it with default values        */

    spiMasterConfig.base.mode = SpiIf_Mode_master;                      /* Configure the mode                       */

    const IfxQspi_SpiMaster_Pins qspi0MasterPins = {
            &IfxQspi0_SCLK_P20_11_OUT, IfxPort_OutputMode_pushPull,          /* SCLK Pin                       (CLK)     */
            &IfxQspi0_MTSR_P20_14_OUT, IfxPort_OutputMode_pushPull,          /* MasterTransmitSlaveReceive pin (MOSI)    */
            &IfxQspi0_MRSTA_P20_12_IN, IfxPort_InputMode_pullDown,           /* MasterReceiveSlaveTransmit pin (MISO)    */
            IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
        };
    spiMasterConfig.pins = &qspi0MasterPins;                            /* Assign the Master's port pins            */

    /* Set the ISR priorities and the service provider */
    spiMasterConfig.base.txPriority = ISR_PRIORITY_M_ORIN_SLAVE_TX;
    spiMasterConfig.base.rxPriority = ISR_PRIORITY_M_ORIN_SLAVE_RX;
    spiMasterConfig.base.erPriority = ISR_PRIORITY_M_ORIN_SLAVE_ER;
    spiMasterConfig.base.isrProvider = IfxSrc_Tos_cpu0;

    /* Initialize the QSPI Master module */
    IfxQspi_SpiMaster_initModule(&g_qspi_m_orin.spiMaster, &spiMasterConfig);
}

void initQSPI0MasterChannel(void)
{
    IfxQspi_SpiMaster_ChannelConfig spiMasterChannelConfig;             /* Define a Master Channel configuration    */

    /* Initialize the configuration with default values */
    IfxQspi_SpiMaster_initChannelConfig(&spiMasterChannelConfig, &g_qspi_m_orin.spiMaster);

    spiMasterChannelConfig.base.baudrate = MASTER_CHANNEL_BAUDRATE;     /* Set SCLK frequency to 1 MHz              */

    /* Select the port pin for the Chip Select signal */
    const IfxQspi_SpiMaster_Output qspi0SlaveSelect = {                 /* QSPI2 Master selects the QSPI3 Slave     */
        &IfxQspi0_SLSO2_P20_13_OUT, IfxPort_OutputMode_pushPull,         /* Slave Select port pin (CS)               */
        IfxPort_PadDriver_cmosAutomotiveSpeed1                          /* Pad driver mode                          */
    };
    spiMasterChannelConfig.sls.output = qspi0SlaveSelect;

    /* Initialize the QSPI Master channel */
    IfxQspi_SpiMaster_initChannel(&g_qspi_m_orin.spiMasterChannel, &spiMasterChannelConfig);
}

#endif

/********************************************************************************************************************
 * Function Name : initQSPISOrinConfig
 * Description   : 鍒濆鍖栦粠orin瀵瑰簲鐨剆pi
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPISOrinConfig(void)
{
    IfxQspi_SpiMaster_Config spiMasterConfig;                           /* Define a Master configuration            */

    IfxQspi_SpiMaster_initModuleConfig(&spiMasterConfig, QSPI_S_ORIN); /* Initialize it with default values        */

    spiMasterConfig.base.mode = SpiIf_Mode_master;                      /* Configure the mode                       */

    /* Select the port pins for communication */
    const IfxQspi_SpiMaster_Pins qspi1MasterPins = {
        &IfxQspi1_SCLK_P10_2_OUT, IfxPort_OutputMode_pushPull,          /* SCLK Pin                       (CLK)     */
        &IfxQspi1_MTSR_P10_3_OUT, IfxPort_OutputMode_pushPull,          /* MasterTransmitSlaveReceive pin (MOSI)    */
        &IfxQspi1_MRSTA_P10_1_IN, IfxPort_InputMode_pullDown,           /* MasterReceiveSlaveTransmit pin (MISO)    */
        IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
    };
    spiMasterConfig.pins = &qspi1MasterPins;                            /* Assign the Master's port pins            */

    /* Set the ISR priorities and the service provider */
    spiMasterConfig.base.txPriority = ISR_PRIORITY_S_ORIN_SLAVE_TX;
    spiMasterConfig.base.rxPriority = ISR_PRIORITY_S_ORIN_SLAVE_RX;
    spiMasterConfig.base.erPriority = ISR_PRIORITY_S_ORIN_SLAVE_ER;
    spiMasterConfig.base.isrProvider = IfxSrc_Tos_cpu0;

    /* Initialize the QSPI Master module */
    IfxQspi_SpiMaster_initModule(&g_qspi_s_orin.spiMaster, &spiMasterConfig);
}

/********************************************************************************************************************
 * Function Name : initQSPI2SOrinChannel
 * Description   : 鍒濆鍖栦粠orin瀵瑰簲鐨剆pi閫氶亾
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPI2SOrinChannel(void)
{
    IfxQspi_SpiMaster_ChannelConfig spiMasterChannelConfig;             /* Define a Master Channel configuration    */

    /* Initialize the configuration with default values */
    IfxQspi_SpiMaster_initChannelConfig(&spiMasterChannelConfig, &g_qspi_s_orin.spiMaster);

    spiMasterChannelConfig.base.baudrate = MASTER_CHANNEL_BAUDRATE;     /* Set SCLK frequency to 1 MHz              */

    /* Select the port pin for the Chip Select signal */
    const IfxQspi_SpiMaster_Output qspi1SlaveSelect = {                 /* QSPI2 Master selects the QSPI3 Slave     */
        &IfxQspi1_SLSO10_P10_0_OUT, IfxPort_OutputMode_pushPull,         /* Slave Select port pin (CS)               */
        IfxPort_PadDriver_cmosAutomotiveSpeed1                          /* Pad driver mode                          */
    };
    spiMasterChannelConfig.sls.output = qspi1SlaveSelect;

    /* Initialize the QSPI Master channel */
    IfxQspi_SpiMaster_initChannel(&g_qspi_s_orin.spiMasterChannel, &spiMasterChannelConfig);
}

#ifdef SPI1_SLAVE
/********************************************************************************************************************
 * Function Name : initQSPISOrinConfig
 * Description   : 鍒濆鍖栦粠orin瀵瑰簲鐨剆pi鎺у埗鍣�
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPISOrinConfig(void)
{
    IfxQspi_SpiSlave_Config spiSlaveConfig;                             /* Define the Slave configuration           */

    IfxQspi_SpiSlave_initModuleConfig(&spiSlaveConfig, QSPI_S_ORIN);    /* Initialize it with default values        */

    /* Select the port pins for communication */
    const IfxQspi_SpiSlave_Pins qspi1SlavePins = {
        &IfxQspi1_SCLKA_P10_2_IN, IfxPort_InputMode_pullDown,           /* SCLK Pin                       (CLK)     */
        &IfxQspi1_MTSRA_P10_3_IN, IfxPort_InputMode_pullDown,           /* MasterTransmitSlaveReceive pin (MOSI)    */
        &IfxQspi1_MRST_P10_1_OUT, IfxPort_OutputMode_pushPull,          /* MasterReceiveSlaveTransmit pin (MISO)    */
        &IfxQspi0_SLSIA_P20_13_IN, IfxPort_InputMode_pullDown,           /* SlaveSelect Pin                (CS)      */
        IfxPort_PadDriver_cmosAutomotiveSpeed3                          /* Pad driver mode                          */
    };
    spiSlaveConfig.pins = &qspi1SlavePins;                              /* Assign Slave port pins                   */

    /* Set the ISR priorities and the service provider */
    spiSlaveConfig.base.txPriority = ISR_PRIORITY_S_ORIN_SLAVE_TX;
    spiSlaveConfig.base.rxPriority = ISR_PRIORITY_S_ORIN_SLAVE_RX;
    spiSlaveConfig.base.erPriority = ISR_PRIORITY_S_ORIN_SLAVE_ER;
    spiSlaveConfig.base.isrProvider = IfxSrc_Tos_cpu3;

    /* Initialize QSPI Slave module */
    IfxQspi_SpiSlave_initModule(&g_qspi_s_orin.spiSlave, &spiSlaveConfig);
}

#endif


#ifdef M_MCU
/********************************************************************************************************************
 * Function Name : initQSPIMcuBuffers
 * Description   : 鍒濆鍖朚CU鏀跺彂鍣╞uff
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPIMcuBuffers(void)
{
    for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++)
    {
        g_qspi_mcu.spiBuffers.spiMasterTxBuffer[i] = SPI_BUFFER_SIZE-i;      /* Clear TX Slave Buffer                    */
        g_qspi_mcu.spiBuffers.spiMasterRxBuffer[i] = 0;                      /* Clear RX Slave Buffer                    */
    }
}

#endif


#ifdef S_MCU
/********************************************************************************************************************
 * Function Name : initQSPIMcuBuffers
 * Description   : 鍒濆鍖朚CU鏀跺彂鍣╞uff
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPIMcuBuffers(void)
{
    for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++)
    {
        g_qspi_mcu.spiBuffers.spiSlaveTxBuffer[i] = i;      /* Clear TX Slave Buffer                    */
        g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[i] = 0;      /* Clear RX Slave Buffer                    */
    }
}
#endif

/********************************************************************************************************************
 * Function Name : initQSPIMOrinBuffers
 * Description   : 鍒濆鍖栦富orin鐨剆pi鏀跺彂鍣╞uff
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPIMOrinBuffers(void)
{
#ifdef SLAVE
    for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++)
    {
        g_qspi_m_orin.spiBuffers.spiSlaveTxBuffer[i] = i;      /* Clear TX Slave Buffer                    */
        g_qspi_m_orin.spiBuffers.spiSlaveRxBuffer[i] = 0;      /* Clear RX Slave Buffer                    */
    }
#endif

#ifdef MASTER
    for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++)
    {
        g_qspi_m_orin.spiBuffers.spiMasterTxBuffer[i] = i;      /* Clear TX Slave Buffer                    */
        g_qspi_m_orin.spiBuffers.spiMasterRxBuffer[i] = 0;      /* Clear RX Slave Buffer                    */
    }
#endif
}

/********************************************************************************************************************
 * Function Name : initQSPISOrinBuffers
 * Description   : 鍒濆鍖栦粠orin鐨剆pi鏀跺彂鍣╞uff
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void initQSPISOrinBuffers(void)
{
    for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++)
    {
        g_qspi_s_orin.spiBuffers.spiMasterTxBuffer[i] = SPI_BUFFER_SIZE-i;      /* Clear TX Slave Buffer                    */
        g_qspi_s_orin.spiBuffers.spiMasterRxBuffer[i] = 0;                      /* Clear RX Slave Buffer                    */
    }
}



/********************************************************************************************************************
 * Function Name : init_QSPI_2_MCU_B
 * Description   : 鍒濆鍖栦笌MCU_B杩炴帴鐨勭殑spi
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void init_QSPI_2_MCU_B(void)
{
    /* Firstly initialize the Slave */
    initQSPIMcuConfig();
#ifdef M_MCU
    initQSPI4MasterChannel();
#endif
    initQSPIMcuBuffers();
}

/********************************************************************************************************************
 * Function Name : init_QSPI_2_ORIN_M
 * Description   : 鍒濆鍖栬繛鎺ュ埌涓籓RIN鐨剆pi
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void init_QSPI_2_ORIN_M(void)
{
    /* Firstly initialize the Slave */
    initQSPIMOrinConfig();
#ifdef MASTER
    initQSPI0MasterChannel();
#endif
    initQSPIMOrinBuffers();
}

/********************************************************************************************************************
 * Function Name : init_QSPI_2_ORIN_S
 * Description   : 鍒濆鍖栬繛鎺ュ埌浠嶰RIN鐨剆pi
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void init_QSPI_2_ORIN_S(void)
{
    /* Firstly initialize the Slave */
    initQSPISOrinConfig();
    initQSPI2SOrinChannel();
    initQSPISOrinBuffers();
}

/********************************************************************************************************************
 * Function Name : tztek_spi_init
 * Description   : 鍒濆鍖杝pi锛屽湪涓诲嚱鏁颁腑璋冪敤
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void tztek_spi_init(void)
{
    init_QSPI_2_MCU_B();
    init_QSPI_2_ORIN_M();
    init_QSPI_2_ORIN_S();
}

#if 0
/********************************************************************************************************************
 * Function Name : SpitransferData
 * Description   : 涓讳粠mcu浠ュ強涓讳粠orin涔嬮棿鏀跺彂鏁版嵁娴嬭瘯
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void SpitransferData(void)
{

#ifdef M_MCU
    while((IfxQspi_SpiMaster_getStatus(&g_qspi_mcu.spiMasterChannel) == SpiIf_Status_busy)
            && (IfxQspi_SpiSlave_getStatus(&g_qspi_m_orin.spiSlave) == SpiIf_Status_busy)
            && (IfxQspi_SpiMaster_getStatus(&g_qspi_s_orin.spiMasterChannel) == SpiIf_Status_busy))
    {   /* Wait until the previous communication has finished, if any */
    }

    /*mcu*/
    if(IfxQspi_SpiMaster_getStatus(&g_qspi_mcu.spiMasterChannel) != SpiIf_Status_busy) {
        IfxQspi_SpiMaster_exchange(&g_qspi_mcu.spiMasterChannel, &g_qspi_mcu.spiBuffers.spiMasterTxBuffer[0], &g_qspi_mcu.spiBuffers.spiMasterRxBuffer[0], SPI_BUFFER_SIZE);
        Ifx_Console_print("master tx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiMasterTxBuffer[i]);
        }
        Ifx_Console_print("master rx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiMasterRxBuffer[i]);
        }
        Ifx_Console_print("\n");
    }
#endif

#ifdef S_MCU
    while((IfxQspi_SpiSlave_getStatus(&g_qspi_mcu.spiSlave) == SpiIf_Status_busy)
            && (IfxQspi_SpiSlave_getStatus(&g_qspi_m_orin.spiSlave) == SpiIf_Status_busy)
            && (IfxQspi_SpiMaster_getStatus(&g_qspi_s_orin.spiMasterChannel) == SpiIf_Status_busy))
    {   /* Wait until the previous communication has finished, if any */
    }

    /*mcu*/
    if(IfxQspi_SpiSlave_getStatus(&g_qspi_mcu.spiSlave) != SpiIf_Status_busy) {
        IfxQspi_SpiSlave_exchange(&g_qspi_mcu.spiSlave, &g_qspi_mcu.spiBuffers.spiSlaveTxBuffer[0], &g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[0], SPI_BUFFER_SIZE);
        Ifx_Console_print("slave tx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiSlaveTxBuffer[i]);
        }
        Ifx_Console_print("slave rx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[i]);
        }
        Ifx_Console_print("\n");
    }
#endif


    /* m_orin */
    if(IfxQspi_SpiSlave_getStatus(&g_qspi_m_orin.spiSlave) != SpiIf_Status_busy) {
        IfxQspi_SpiSlave_exchange(&g_qspi_m_orin.spiSlave, &g_qspi_m_orin.spiBuffers.spiSlaveTxBuffer[0], &g_qspi_m_orin.spiBuffers.spiSlaveRxBuffer[0], SPI_BUFFER_SIZE);
        Ifx_Console_print("morin tx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiSlaveTxBuffer[i]);
        }
        Ifx_Console_print("morin rx = ");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiSlaveRxBuffer[i]);
        }
        Ifx_Console_print("\n");
    }

    /* s_orin */
    if(IfxQspi_SpiMaster_getStatus(&g_qspi_s_orin.spiMasterChannel) != SpiIf_Status_busy) {
        IfxQspi_SpiMaster_exchange(&g_qspi_s_orin.spiMasterChannel, &g_qspi_s_orin.spiBuffers.spiMasterTxBuffer[0], &g_qspi_s_orin.spiBuffers.spiMasterRxBuffer[0], SPI_BUFFER_SIZE);
        Ifx_Console_print("spi s_orin tx = 0x%x, rx = 0x%x\n", g_qspi_s_orin.spiBuffers.spiMasterTxBuffer[SPI_BUFFER_SIZE - 1], g_qspi_s_orin.spiBuffers.spiMasterRxBuffer[SPI_BUFFER_SIZE - 1]);
        for (uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            g_qspi_s_orin.spiBuffers.spiMasterTxBuffer[i] = g_qspi_s_orin.spiBuffers.spiMasterRxBuffer[i];
        }
    }
}
#endif

/********************************************************************************************************************
 * Function Name : SPI_TRANSFER_2_MCU_B
 * Description   : MCU涓嶮CU_B涔嬮棿鏀跺彂鏁版嵁娴嬭瘯
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void SPI_TRANSFER_2_MCU_B(void)
{

#ifdef M_MCU
    while(IfxQspi_SpiMaster_getStatus(&g_qspi_mcu.spiMasterChannel) == SpiIf_Status_busy)
    {   /* Wait until the previous communication has finished, if any */
    }

    IfxQspi_SpiMaster_exchange(&g_qspi_mcu.spiMasterChannel, &g_qspi_mcu.spiBuffers.spiMasterTxBuffer[0], &g_qspi_mcu.spiBuffers.spiMasterRxBuffer[0], SPI_BUFFER_SIZE);
    Ifx_Console_print("master tx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiMasterTxBuffer[i]);
    }
    Ifx_Console_print("master rx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiMasterRxBuffer[i]);
    }
    Ifx_Console_print("\n");


#endif

#ifdef S_MCU
    while(IfxQspi_SpiSlave_getStatus(&g_qspi_mcu.spiSlave) == SpiIf_Status_busy)
    {   /* Wait until the previous communication has finished, if any */
    }

    IfxQspi_SpiSlave_exchange(&g_qspi_mcu.spiSlave, &g_qspi_mcu.spiBuffers.spiSlaveTxBuffer[0], &g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[0], SPI_BUFFER_SIZE);
    flag = !flag;


#endif

#if 0
    /* Instruct the SPI Slave to receive a data stream of defined length */
    IfxQspi_SpiSlave_exchange(&g_qspi.spiSlave, NULL_PTR, &g_qspi.spiBuffers.spiSlaveRxBuffer[0], SPI_BUFFER_SIZE);

    /* Send a data stream through the SPI Master */
    IfxQspi_SpiMaster_exchange(&g_qspi.spiMasterChannel, &g_qspi.spiBuffers.spiMasterTxBuffer[0], NULL_PTR, SPI_BUFFER_SIZE);

    verifyData();
#endif
}

/********************************************************************************************************************
 * Function Name : SPI_TRANSFER_2_ORIN_M
 * Description   : MCU涓庝富orin涔嬮棿鏀跺彂鏁版嵁娴嬭瘯
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.16
 ********************************************************************************************************************/
void SPI_TRANSFER_2_ORIN_M(void)
{
#ifdef SLAVE
    while(IfxQspi_SpiSlave_getStatus(&g_qspi_m_orin.spiSlave) == SpiIf_Status_busy)
    {   /* Wait until the previous communication has finished, if any */
    }

    IfxQspi_SpiSlave_exchange(&g_qspi_m_orin.spiSlave, &g_qspi_m_orin.spiBuffers.spiSlaveTxBuffer[0], &g_qspi_m_orin.spiBuffers.spiSlaveRxBuffer[0], SPI_BUFFER_SIZE);
    Ifx_Console_print("morin tx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiSlaveTxBuffer[i]);
    }
    Ifx_Console_print("morin rx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiSlaveRxBuffer[i]);
    }
    Ifx_Console_print("\n");
#endif

#ifdef MASTER
    while(IfxQspi_SpiMaster_getStatus(&g_qspi_m_orin.spiMasterChannel) == SpiIf_Status_busy)
    {   /* Wait until the previous communication has finished, if any */
    }

    IfxQspi_SpiMaster_exchange(&g_qspi_m_orin.spiMasterChannel, &g_qspi_m_orin.spiBuffers.spiMasterTxBuffer[0], &g_qspi_m_orin.spiBuffers.spiMasterRxBuffer[0], SPI_BUFFER_SIZE);

    Ifx_Console_print("mcub(master) orin_m(slave) tx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiMasterTxBuffer[i]);
    }
    Ifx_Console_print("mcub(master) orin_m(slave) rx = ");
    for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
        Ifx_Console_print("%d ", g_qspi_m_orin.spiBuffers.spiMasterRxBuffer[i]);
    }
    Ifx_Console_print("\n");
#endif
}

/********************************************************************************************************************
 * Function Name : tztek_spi_slave_rec
 * Description   : 从机接收数据
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.29
 ********************************************************************************************************************/
void tztek_spi_slave_rec(void)
{
    static int cnt = 0;
    static int cnt2 = 0;

    if (cnt == 60000)
    {
        //杈撳嚭4.821V 100娆�
        if (cnt2 > 95)
        {
            SPI_TRANSFER_2_MCU_B();
            cnt2 = 0;
        }
        cnt2++;
        cnt = 0;
    }
    cnt++;
}

/********************************************************************************************************************
 * Function Name : tztek_spi_test
 * Description   : 打印从机接收到的数据
 * Arguments     :
 * Return Value  :
 * Author        : yinjun
 * Data          : 2022.9.29
 ********************************************************************************************************************/
void tztek_spi_test(void)
{
    static uint8 i = 0;
    static int cnt = 0;
    static int cnt2 = 0;
    uint8 cnt3 = 0;

    if(i != flag) {
//        Ifx_Console_print("mcba(slave) mcub(master) tx = ");
//        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
//            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiSlaveTxBuffer[i]);
//        }
//        Ifx_Console_print("mcba(slave) mcub(master) rx = ");
//        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
//            Ifx_Console_print("%d ", g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[i]);
//        }
//        Ifx_Console_print("\n");
        for(uint8 i = 0; i < SPI_BUFFER_SIZE; i++) {
            if(g_qspi_mcu.spiBuffers.spiSlaveRxBuffer[i] == SPI_BUFFER_SIZE - i)
                cnt3++;
            else
                break;
        }
        if(cnt3 == SPI_BUFFER_SIZE)
            Ifx_Console_print("MCUB MCUA spi is ok!\n");
        else
            Ifx_Console_print("MCUB MCUA spi fail!\n");

        i = flag;
    }

    if (cnt == 60000)
    {
        //杈撳嚭4.821V 100娆�
        if (cnt2 > 100)
        {
//            SPI_TRANSFER_2_ORIN_M();
            cnt2 = 0;
        }
        cnt2++;
        cnt = 0;
    }
    cnt++;

}




