#ifndef __TZTEK_SPI_H_
#define __TZTEK_SPI_H_

#include "Ifx_Types.h"
#include "Bsp.h"
#include "IfxCpu.h"
#include "IfxScuWdt.h"
//#include "drv.h"
#include "IfxQspi_SpiMaster.h"
#include "IfxQspi_SpiSlave.h"
#include "Ifx_Console.h"
#include "UART_Logging.h"



/* QSPI modules */
#define QSPI_MCU                  &MODULE_QSPI4   /* 涓庡彟涓�涓狹CU閫氫俊 */
#define QSPI_M_ORIN               &MODULE_QSPI0   /* 涓庝富orin閫氫俊 */
#define QSPI_S_ORIN               &MODULE_QSPI1   /* 涓庝粠orin閫氫俊 */


#define SPI_BUFFER_SIZE             8            /* Size of the SPI buffer in bytes  */
#define MASTER_CHANNEL_BAUDRATE     1000000      /* Master channel baud rate         */

/* Interrupt Service Routine priorities for Master and Slave SPI communication */
#define ISR_PRIORITY_MCU_TX                50
#define ISR_PRIORITY_MCU_RX                51
#define ISR_PRIORITY_MCU_ER                52

#define ISR_PRIORITY_M_ORIN_SLAVE_TX       53
#define ISR_PRIORITY_M_ORIN_SLAVE_RX       54
#define ISR_PRIORITY_M_ORIN_SLAVE_ER       55

#define ISR_PRIORITY_S_ORIN_SLAVE_TX       56
#define ISR_PRIORITY_S_ORIN_SLAVE_RX       57
#define ISR_PRIORITY_S_ORIN_SLAVE_ER       58

/*********************************************************************************************************************/
/*-------------------------------------------------Data Structures---------------------------------------------------*/
/*********************************************************************************************************************/
typedef struct
{
    uint8 spiMasterTxBuffer[SPI_BUFFER_SIZE];       /* QSPI Master Transmit buffer   */
    uint8 spiMasterRxBuffer[SPI_BUFFER_SIZE];       /* QSPI Master Receive buffer    */
    uint8 spiSlaveTxBuffer[SPI_BUFFER_SIZE];        /* QSPI Slave Transmit buffer    */
    uint8 spiSlaveRxBuffer[SPI_BUFFER_SIZE];        /* QSPI Slave Receive buffer     */
} qspiBuffers;

typedef struct
{
    qspiBuffers               spiBuffers;           /* Buffers instance              */
    IfxQspi_SpiMaster         spiMaster;            /* QSPI Master handle            */
    IfxQspi_SpiMaster_Channel spiMasterChannel;     /* QSPI Master Channel handle    */
    IfxQspi_SpiSlave          spiSlave;             /* QSPI Slave handle             */
} qspiComm;




/*********************************************************************************************************************/
/*------------------------------------------------Function Prototypes------------------------------------------------*/
/*********************************************************************************************************************/

void tztek_spi_init(void);
void SPI_TRANSFER_2_MCU_B(void);
void SPI_TRANSFER_2_ORIN_M(void);
void tztek_spi_test(void);
void tztek_spi_slave_rec(void);

#endif
