//#ifndef __TZTEK_UART_H_
//#define __TZTEK_UART_H_
//#include "Bsp.h"
//
//
//
//void tztek_uart_init(void);
//void tztek_uart_sendMessage(char * msg, Ifx_SizeT count);
//void tztek_uart_test(void);
//#endif

#ifndef __TZTEK_UART_H_
#define __TZTEK_UART_H_
#include "Bsp.h"
#include "IfxAsclin_Asc.h"
#include "Ifx_Fifo.h"
#include "IfxCpu_Irq.h"

#define SERIAL_LIN_BAUDRATE         115200                           /* Baud rate in bit/s */

#define LIN11_PIN_RX                IfxAsclin11_RXB_P10_4_IN         /* RX pin of the board */
#define LIN11_PIN_TX                IfxAsclin11_TX_P21_5_OUT         /* TX pin of the board */
#define LIN6_PIN_RX                 IfxAsclin6_RXC_P32_6_IN          /* RX pin of the board */
#define LIN6_PIN_TX                 IfxAsclin6_TX_P32_7_OUT          /* TX pin of the board */

#define INTPRIO_ASCLIN11_TX         21
#define INTPRIO_ASCLIN11_RX         20                               /* Priority of the ISR */
#define INTPRIO_ASCLIN6_TX          3
#define INTPRIO_ASCLIN6_RX          5                                /* Priority of the ISR */

#define ASCLIN11_TX_BUFFER_SIZE     64                               /* Definition of the buffer size */
#define ASCLIN11_RX_BUFFER_SIZE     64                               /* Definition of the buffer size */
#define ASCLIN6_TX_BUFFER_SIZE      1024                             /* Definition of the buffer size */
#define ASCLIN6_RX_BUFFER_SIZE      1024                             /* Definition of the buffer size */

void tztek_uart_6_11_init(void);
void tztek_uart_11_sendMessage(char * msg, Ifx_SizeT count);
void tztek_uart_6_RingBack_Test(void);
void tztek_uart_test(void);
#endif
