/**
 * \file IfxGtm_PinMap.c
 * \brief GTM I/O map
 * \ingroup IfxLld_Gtm
 *
 * \version iLLD_1_0_1_12_0
 * \copyright Copyright (c) 2017 Infineon Technologies AG. All rights reserved.
 *
 *
 *                                 IMPORTANT NOTICE
 *
 * Use of this file is subject to the terms of use agreed between (i) you or
 * the company in which ordinary course of business you are acting and (ii)
 * Infineon Technologies AG or its licensees. If and as long as no such terms
 * of use are agreed, use of this file is subject to following:
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer, must
 * be included in all copies of the Software, in whole or in part, and all
 * derivative works of the Software, unless such copies or derivative works are
 * solely in the form of machine-executable object code generated by a source
 * language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 */

#include "IfxGtm_PinMap.h"

IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0N_TOUT112_P01_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 112, {&MODULE_P01, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0N_TOUT17_P00_8_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0N_TOUT43_P23_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0N_TOUT54_P21_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0N_TOUT7_P02_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT0_P02_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT48_P22_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT53_P21_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT85_P14_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 85, {&MODULE_P14, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT8_P02_8_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_0_TOUT9_P00_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT113_P01_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 113, {&MODULE_P01, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT14_P00_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT39_P32_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT41_P23_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT4_P02_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT50_P22_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT53_P21_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT55_P21_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT57_P21_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1N_TOUT61_P20_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT10_P00_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT116_P02_9_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT11_P00_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT1_P02_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT31_P33_9_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT47_P22_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 47, {&MODULE_P22, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT54_P21_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_1_TOUT84_P14_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT114_P01_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT15_P00_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT23_P33_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT40_P32_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT41_P23_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT44_P23_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT56_P21_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT58_P21_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT5_P02_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2N_TOUT65_P20_9_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT117_P02_10_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT12_P00_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT2_P02_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT33_P33_11_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT42_P23_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT46_P23_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT55_P21_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_2_TOUT83_P14_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 83, {&MODULE_P14, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT115_P01_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT16_P00_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT24_P33_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT42_P23_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT45_P23_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT59_P20_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT66_P20_10_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3N_TOUT6_P02_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT118_P02_11_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT13_P00_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT38_P32_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT3_P02_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT49_P22_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT56_P21_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT60_P20_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_3_TOUT82_P14_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4N_TOUT118_P02_11_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4N_TOUT135_P22_9_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4N_TOUT13_P00_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4N_TOUT147_P34_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4N_TOUT3_P02_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT146_P34_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 146, {&MODULE_P34, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT14_P00_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT29_P33_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT39_P32_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT4_P02_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT50_P22_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT57_P21_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT61_P20_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_4_TOUT81_P14_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT0_P02_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT136_P22_10_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT148_P34_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT26_P33_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT8_P02_8_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5N_TOUT9_P00_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT15_P00_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT23_P33_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT40_P32_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT41_P23_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT58_P21_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_5_TOUT5_P02_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT10_P00_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT116_P02_9_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT11_P00_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT137_P22_11_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT149_P34_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT1_P02_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6N_TOUT27_P33_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT106_P10_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT16_P00_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT24_P33_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT42_P23_1_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT59_P20_0_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_6_TOUT6_P02_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7N_TOUT117_P02_10_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7N_TOUT12_P00_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7N_TOUT150_P34_5_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7N_TOUT28_P33_6_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7N_TOUT2_P02_2_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7_TOUT17_P00_8_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7_TOUT25_P33_3_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7_TOUT45_P23_4_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7_TOUT64_P20_8_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM0_7_TOUT7_P02_7_OUT = {IfxGtm_Atom_0, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_0_TOUT174_P31_0_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_0_TOUT190_P30_0_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 190, {&MODULE_P30, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_0_TOUT230_P24_8_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_1_TOUT175_P31_1_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_1_TOUT191_P30_1_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 191, {&MODULE_P30, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_1_TOUT231_P24_9_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_2_TOUT176_P31_2_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_2_TOUT192_P30_2_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 192, {&MODULE_P30, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_2_TOUT232_P24_10_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_3_TOUT177_P31_3_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_3_TOUT193_P30_3_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 193, {&MODULE_P30, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_3_TOUT233_P24_11_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_4_TOUT178_P31_4_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_4_TOUT194_P30_4_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 194, {&MODULE_P30, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_4_TOUT234_P24_12_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 234, {&MODULE_P24,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_5_TOUT179_P31_5_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_5_TOUT195_P30_5_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 195, {&MODULE_P30, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_5_TOUT235_P24_13_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 235, {&MODULE_P24,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_6_TOUT180_P31_6_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_6_TOUT196_P30_6_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 196, {&MODULE_P30, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_6_TOUT236_P24_14_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 236, {&MODULE_P24,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_7_TOUT181_P31_7_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_7_TOUT197_P30_7_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 197, {&MODULE_P30, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM10_7_TOUT237_P24_15_OUT = {IfxGtm_Atom_10, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 237, {&MODULE_P24,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_0_TOUT182_P31_8_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 182, {&MODULE_P31, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_0_TOUT198_P30_8_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 198, {&MODULE_P30, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_0_TOUT214_P25_8_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 214, {&MODULE_P25, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_0_TOUT242_P15_10_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_0_TOUT265_P10_9_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_1_TOUT183_P31_9_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 183, {&MODULE_P31, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_1_TOUT199_P30_9_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 199, {&MODULE_P30, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_1_TOUT215_P25_9_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 215, {&MODULE_P25, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_1_TOUT243_P15_11_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_1_TOUT266_P10_10_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_2_TOUT184_P31_10_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 184, {&MODULE_P31,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_2_TOUT200_P30_10_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 200, {&MODULE_P30,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_2_TOUT216_P25_10_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 216, {&MODULE_P25,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_2_TOUT244_P15_12_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_2_TOUT269_P10_11_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_3_TOUT185_P31_11_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 185, {&MODULE_P31,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_3_TOUT201_P30_11_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 201, {&MODULE_P30,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_3_TOUT217_P25_11_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 217, {&MODULE_P25,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_3_TOUT245_P15_13_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_3_TOUT268_P10_13_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_4_TOUT186_P31_12_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_4_TOUT202_P30_12_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_4_TOUT218_P25_12_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_4_TOUT246_P15_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_4_TOUT267_P10_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_5_TOUT187_P31_13_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_5_TOUT203_P30_13_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_5_TOUT219_P25_13_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_5_TOUT247_P15_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_5_TOUT270_P10_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_6_TOUT127_P11_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 127, {&MODULE_P11,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_6_TOUT188_P31_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_6_TOUT204_P30_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_6_TOUT220_P25_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_7_TOUT126_P11_14_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_7_TOUT189_P31_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_7_TOUT205_P30_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM11_7_TOUT221_P25_15_OUT = {IfxGtm_Atom_11, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0N_TOUT112_P01_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 112, {&MODULE_P01, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0N_TOUT17_P00_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0N_TOUT7_P02_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT0_P02_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT109_P10_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT68_P20_12_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT76_P15_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT77_P15_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT87_P14_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT8_P02_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_0_TOUT9_P00_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT102_P10_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT113_P01_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 113, {&MODULE_P01, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT14_P00_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT39_P32_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT4_P02_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT61_P20_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1N_TOUT72_P15_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT103_P10_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT10_P00_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT116_P02_9_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT11_P00_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT1_P02_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT31_P33_9_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT69_P20_13_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT78_P15_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT79_P15_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_1_TOUT86_P14_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT110_P10_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT114_P01_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT15_P00_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT23_P33_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT40_P32_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT41_P23_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT5_P02_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2N_TOUT73_P15_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT104_P10_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT107_P10_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT117_P02_10_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT12_P00_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT2_P02_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT33_P33_11_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT70_P20_14_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_2_TOUT80_P14_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT106_P10_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT115_P01_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT16_P00_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT24_P33_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT42_P23_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT6_P02_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3N_TOUT74_P15_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT105_P10_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT108_P10_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT118_P02_11_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT13_P00_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT38_P32_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT3_P02_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT60_P20_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_3_TOUT71_P15_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT105_P10_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT108_P10_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT118_P02_11_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT131_P22_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT13_P00_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT147_P34_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT3_P02_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT71_P15_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4N_TOUT75_P15_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT102_P10_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT130_P22_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT146_P34_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 146, {&MODULE_P34, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT14_P00_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT29_P33_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_l, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT39_P32_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT4_P02_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT61_P20_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_4_TOUT72_P15_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT0_P02_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT109_P10_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT132_P22_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT148_P34_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT26_P33_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_l, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT76_P15_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT77_P15_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT8_P02_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5N_TOUT9_P00_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT110_P10_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT15_P00_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT23_P33_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT40_P32_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT41_P23_0_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT5_P02_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT65_P20_9_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_5_TOUT73_P15_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT103_P10_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT10_P00_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT116_P02_9_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT11_P00_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT133_P22_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT149_P34_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT1_P02_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT27_P33_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_l, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6N_TOUT78_P15_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT106_P10_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_l, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT16_P00_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT24_P33_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT42_P23_1_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT66_P20_10_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT6_P02_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_6_TOUT74_P15_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT104_P10_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT107_P10_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT117_P02_10_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT12_P00_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT134_P22_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT150_P34_5_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT28_P33_6_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_l, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT2_P02_2_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7N_TOUT79_P15_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT17_P00_8_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT25_P33_3_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT45_P23_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT67_P20_11_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT75_P15_4_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM1_7_TOUT7_P02_7_OUT = {IfxGtm_Atom_1, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT101_P11_12_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT108_P10_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT12_P00_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT144_P33_15_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT25_P33_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT32_P33_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0N_TOUT37_P32_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0_TOUT109_P10_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0_TOUT18_P00_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0_TOUT26_P33_4_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0_TOUT32_P33_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_0_TOUT94_P13_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT105_P10_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT167_P00_13_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT22_P33_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT30_P33_8_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT34_P33_12_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT51_P21_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT90_P14_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT91_P13_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT98_P11_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1N_TOUT9_P00_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT102_P10_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT19_P00_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT27_P33_5_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT43_P23_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT90_P14_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_1_TOUT95_P11_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT106_P10_4_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT10_P00_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT114_P01_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT138_P23_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 138, {&MODULE_P23, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT166_P00_14_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT23_P33_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT31_P33_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT35_P33_13_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT52_P21_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT91_P13_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT92_P13_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2N_TOUT99_P11_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT103_P10_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT20_P00_11_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT28_P33_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT44_P23_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT88_P14_8_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_2_TOUT96_P11_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT100_P11_11_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT107_P10_5_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT115_P01_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT11_P00_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT139_P23_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 139, {&MODULE_P23, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT143_P33_14_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT168_P00_15_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT24_P33_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT33_P33_11_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT36_P32_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT62_P20_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT92_P13_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3N_TOUT93_P13_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3_TOUT104_P10_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3_TOUT21_P00_12_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3_TOUT29_P33_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3_TOUT89_P14_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_3_TOUT97_P11_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4N_TOUT29_P33_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4N_TOUT57_P21_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4N_TOUT86_P14_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4N_TOUT97_P11_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT167_P00_13_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT22_P33_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT30_P33_8_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT34_P33_12_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT51_P21_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT90_P14_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_4_TOUT98_P11_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5N_TOUT120_P11_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5N_TOUT26_P33_4_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5N_TOUT59_P20_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5N_TOUT87_P14_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5N_TOUT94_P13_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT138_P23_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_a, 138, {&MODULE_P23, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT166_P00_14_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT35_P33_13_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT52_P21_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT65_P20_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT91_P13_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_5_TOUT99_P11_10_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6N_TOUT27_P33_5_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6N_TOUT60_P20_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6N_TOUT88_P14_8_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6N_TOUT95_P11_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT100_P11_11_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT139_P23_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_a, 139, {&MODULE_P23, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT143_P33_14_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT168_P00_15_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT36_P32_0_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT62_P20_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_6_TOUT92_P13_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7N_TOUT28_P33_6_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7N_TOUT61_P20_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7N_TOUT89_P14_9_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7N_TOUT96_P11_3_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT101_P11_12_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT140_P32_5_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_a, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT144_P33_15_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT37_P32_1_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT63_P20_7_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM2_7_TOUT93_P13_2_OUT = {IfxGtm_Atom_2, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT101_P11_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT144_P33_15_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT17_P00_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT25_P33_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT32_P33_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT37_P32_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_l, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT63_P20_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0N_TOUT76_P15_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0_TOUT18_P00_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0_TOUT26_P33_4_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0_TOUT32_P33_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0_TOUT65_P20_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_0_TOUT94_P13_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT14_P00_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT167_P00_13_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT22_P33_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT30_P33_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT34_P33_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT51_P21_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT79_P15_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT90_P14_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT91_P13_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1N_TOUT98_P11_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT111_P01_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT128_P12_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT19_P00_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT27_P33_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT43_P23_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT64_P20_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT90_P14_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_1_TOUT95_P11_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT114_P01_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT15_P00_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT166_P00_14_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT23_P33_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT31_P33_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT35_P33_13_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT52_P21_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT78_P15_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT91_P13_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT92_P13_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2N_TOUT99_P11_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT112_P01_4_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_a, 112, {&MODULE_P01, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT20_P00_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT28_P33_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT44_P23_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT63_P20_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT88_P14_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_2_TOUT96_P11_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT100_P11_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT115_P01_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT143_P33_14_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT168_P00_15_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT16_P00_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT24_P33_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT33_P33_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT36_P32_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT62_P20_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT77_P15_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT92_P13_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3N_TOUT93_P13_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT113_P01_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_a, 113, {&MODULE_P01, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT21_P00_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT29_P33_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT62_P20_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT89_P14_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_3_TOUT97_P11_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT135_P22_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT21_P00_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT29_P33_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT57_P21_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT86_P14_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4N_TOUT97_P11_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT114_P01_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_a, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT131_P22_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT167_P00_13_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT22_P33_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT30_P33_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT34_P33_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT51_P21_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT90_P14_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_4_TOUT98_P11_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT120_P11_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT136_P22_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT18_P00_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT26_P33_4_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT59_P20_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT87_P14_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5N_TOUT94_P13_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT115_P01_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_a, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT132_P22_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT166_P00_14_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT35_P33_13_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT52_P21_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT64_P20_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT91_P13_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_5_TOUT99_P11_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT137_P22_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT19_P00_10_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT27_P33_5_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT60_P20_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT88_P14_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6N_TOUT95_P11_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT100_P11_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT133_P22_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT143_P33_14_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_l, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT168_P00_15_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT36_P32_0_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT62_P20_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_6_TOUT92_P13_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7N_TOUT20_P00_11_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7N_TOUT28_P33_6_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7N_TOUT61_P20_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7N_TOUT89_P14_9_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7N_TOUT96_P11_3_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT101_P11_12_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT134_P22_8_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT144_P33_15_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_l, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT37_P32_1_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT63_P20_7_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM3_7_TOUT93_P13_2_OUT = {IfxGtm_Atom_3, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0N_TOUT87_P14_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT109_P10_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT39_P32_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT48_P22_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT53_P21_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT68_P20_12_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT76_P15_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT77_P15_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT85_P14_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 85, {&MODULE_P14, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_0_TOUT87_P14_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT102_P10_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT44_P23_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT50_P22_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT53_P21_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT57_P21_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT72_P15_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT85_P14_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 85, {&MODULE_P14, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1N_TOUT86_P14_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT103_P10_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT41_P23_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT47_P22_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 47, {&MODULE_P22, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT54_P21_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT69_P20_13_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT78_P15_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT79_P15_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT84_P14_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_1_TOUT86_P14_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT110_P10_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT45_P23_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT52_P21_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT58_P21_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT65_P20_9_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT73_P15_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2N_TOUT81_P14_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT104_P10_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT107_P10_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT42_P23_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT46_P23_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT55_P21_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT70_P20_14_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT80_P14_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_2_TOUT83_P14_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 83, {&MODULE_P14, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT106_P10_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT46_P23_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT51_P21_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT59_P20_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT66_P20_10_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT74_P15_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3N_TOUT80_P14_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT105_P10_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT108_P10_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT43_P23_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT49_P22_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT56_P21_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT71_P15_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_3_TOUT82_P14_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT105_P10_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT108_P10_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT132_P22_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT21_P00_12_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT56_P21_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT71_P15_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT75_P15_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4N_TOUT95_P11_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT102_P10_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT111_P01_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT131_P22_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT264_P13_15_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT44_P23_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT50_P22_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT57_P21_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT72_P15_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_4_TOUT81_P14_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT109_P10_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT121_P11_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT133_P22_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT18_P00_9_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT76_P15_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5N_TOUT77_P15_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT110_P10_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT116_P02_9_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_a, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT128_P12_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT130_P22_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT45_P23_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT56_P21_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT58_P21_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT65_P20_9_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_5_TOUT73_P15_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6N_TOUT103_P10_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6N_TOUT134_P22_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6N_TOUT19_P00_10_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6N_TOUT78_P15_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6N_TOUT97_P11_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT106_P10_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT117_P02_10_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_a, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT129_P12_1_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 129, {&MODULE_P12, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT139_P23_7_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 139, {&MODULE_P23, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT46_P23_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT59_P20_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT66_P20_10_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_6_TOUT74_P15_3_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT104_P10_2_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT107_P10_5_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT124_P11_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT135_P22_9_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT20_P00_11_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7N_TOUT79_P15_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT118_P02_11_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_a, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT119_P11_0_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT138_P23_6_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 138, {&MODULE_P23, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT40_P32_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT64_P20_8_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT67_P20_11_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM4_7_TOUT75_P15_4_OUT = {IfxGtm_Atom_4, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT126_P11_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT134_P22_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_l, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT150_P34_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_l, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT161_P01_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT181_P31_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT213_P25_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT261_P14_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0N_TOUT264_P13_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT119_P11_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT130_P22_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT146_P34_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 146, {&MODULE_P34, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT155_P01_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT162_P01_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT174_P31_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT206_P25_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT249_P13_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_0_TOUT258_P14_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT123_P11_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT128_P12_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT135_P22_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_l, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT140_P32_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT158_P01_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT178_P31_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT210_P25_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT245_P15_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT248_P13_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT260_P14_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1N_TOUT268_P10_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT120_P11_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT131_P22_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT147_P34_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT156_P01_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT164_P01_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT175_P31_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT207_P25_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT242_P15_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT253_P13_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_1_TOUT265_P10_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT124_P11_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT136_P22_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_l, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT141_P32_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 141, {&MODULE_P32, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT159_P01_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT179_P31_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT211_P25_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT246_P15_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT250_P13_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT259_P14_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2N_TOUT269_P10_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT121_P11_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT132_P22_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT148_P34_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT152_P02_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT157_P01_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT176_P31_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT208_P25_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT243_P15_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT254_P13_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_2_TOUT266_P10_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT123_P11_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT125_P11_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 125, {&MODULE_P11,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT137_P22_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_l, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT142_P32_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 142, {&MODULE_P32, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT160_P01_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT180_P31_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT212_P25_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT212_P26_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT247_P15_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT249_P13_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT263_P14_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3N_TOUT270_P10_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT122_P11_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT133_P22_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT149_P34_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT163_P01_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT165_P01_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT177_P31_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT209_P25_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT244_P15_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT255_P13_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_3_TOUT267_P10_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT122_P11_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT129_P12_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 129, {&MODULE_P12, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT163_P01_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT165_P01_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT177_P31_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT209_P25_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4N_TOUT267_P10_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT123_P11_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT134_P22_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT150_P34_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT158_P01_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT178_P31_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT210_P25_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT245_P15_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT248_P13_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_4_TOUT268_P10_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5N_TOUT119_P11_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5N_TOUT155_P01_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5N_TOUT162_P01_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5N_TOUT174_P31_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5N_TOUT206_P25_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT124_P11_8_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT135_P22_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_k, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT140_P32_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT159_P01_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT179_P31_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT211_P25_5_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT246_P15_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT250_P13_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_5_TOUT269_P10_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT120_P11_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT156_P01_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT158_P01_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT175_P31_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT207_P25_1_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6N_TOUT96_P11_3_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT125_P11_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 125, {&MODULE_P11,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT136_P22_10_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT141_P32_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 141, {&MODULE_P32, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT160_P01_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT180_P31_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT212_P25_6_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT212_P26_0_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT247_P15_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT249_P13_12_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_6_TOUT270_P10_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7N_TOUT121_P11_4_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7N_TOUT152_P02_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7N_TOUT157_P01_15_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7N_TOUT176_P31_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7N_TOUT208_P25_2_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT126_P11_14_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT137_P22_11_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT142_P32_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 142, {&MODULE_P32, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT161_P01_13_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT181_P31_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT213_P25_7_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM5_7_TOUT248_P13_9_OUT = {IfxGtm_Atom_5, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0N_TOUT161_P01_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0N_TOUT189_P31_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0N_TOUT221_P25_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0N_TOUT264_P13_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_k, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT127_P11_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 127, {&MODULE_P11,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT141_P32_6_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 141, {&MODULE_P32, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT155_P01_0_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT162_P01_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT182_P31_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 182, {&MODULE_P31, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT214_P25_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 214, {&MODULE_P25, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT242_P15_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_0_TOUT250_P13_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1N_TOUT158_P01_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1N_TOUT186_P31_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1N_TOUT218_P25_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1N_TOUT254_P13_5_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1N_TOUT261_P14_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_k, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT128_P12_0_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT142_P32_7_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 142, {&MODULE_P32, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT156_P01_2_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT164_P01_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT183_P31_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 183, {&MODULE_P31, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT215_P25_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 215, {&MODULE_P25, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT251_P13_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_1_TOUT258_P14_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2N_TOUT159_P01_1_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2N_TOUT187_P31_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2N_TOUT219_P25_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2N_TOUT255_P13_6_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_k, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT129_P12_1_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 129, {&MODULE_P12, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT143_P33_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT152_P02_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT157_P01_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT184_P31_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 184, {&MODULE_P31,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT216_P25_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 216, {&MODULE_P25,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT252_P13_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_2_TOUT259_P14_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3N_TOUT160_P01_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3N_TOUT188_P31_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3N_TOUT220_P25_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3N_TOUT256_P13_7_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3N_TOUT263_P14_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_k, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT111_P01_3_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT144_P33_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT163_P01_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT165_P01_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT185_P31_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 185, {&MODULE_P31,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT217_P25_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 217, {&MODULE_P25,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT253_P13_4_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_3_TOUT260_P14_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT163_P01_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_l, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT165_P01_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT185_P31_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 185, {&MODULE_P31,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT217_P25_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 217, {&MODULE_P25,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT253_P13_4_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4N_TOUT260_P14_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_k, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT140_P32_5_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT143_P33_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT158_P01_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT186_P31_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT218_P25_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT254_P13_5_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT261_P14_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_4_TOUT31_P33_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5N_TOUT155_P01_0_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5N_TOUT162_P01_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_l, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5N_TOUT182_P31_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 182, {&MODULE_P31, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5N_TOUT214_P25_8_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 214, {&MODULE_P25, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5N_TOUT250_P13_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT146_P34_1_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 146, {&MODULE_P34, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT159_P01_1_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT187_P31_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT219_P25_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT243_P15_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT255_P13_6_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_5_TOUT262_P13_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 262, {&MODULE_P13,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT156_P01_2_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT158_P01_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_l, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT183_P31_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 183, {&MODULE_P31, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT215_P25_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 215, {&MODULE_P25, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT251_P13_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6N_TOUT258_P14_11_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_k, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT147_P34_2_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT160_P01_9_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT188_P31_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT220_P25_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT256_P13_7_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_6_TOUT263_P14_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT152_P02_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_l, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT157_P01_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT184_P31_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 184, {&MODULE_P31,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT216_P25_10_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 216, {&MODULE_P25,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT252_P13_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7N_TOUT259_P14_14_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT148_P34_3_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT161_P01_13_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT189_P31_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT221_P25_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT244_P15_12_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM6_7_TOUT264_P13_15_OUT = {IfxGtm_Atom_6, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT149_P34_4_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT162_P01_8_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT190_P30_0_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 190, {&MODULE_P30, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT222_P24_0_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 222, {&MODULE_P24, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT249_P13_12_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_0_TOUT258_P14_11_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT150_P34_5_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT163_P01_10_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT191_P30_1_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 191, {&MODULE_P30, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT223_P24_1_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 223, {&MODULE_P24, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT242_P15_10_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT245_P15_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT253_P13_4_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_j, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_1_TOUT265_P10_9_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT164_P01_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT192_P30_2_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 192, {&MODULE_P30, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT224_P24_2_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 224, {&MODULE_P24, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT243_P15_11_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT246_P15_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT254_P13_5_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_j, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_2_TOUT266_P10_10_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT166_P00_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT193_P30_3_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 193, {&MODULE_P30, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT225_P24_3_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 225, {&MODULE_P24, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT244_P15_12_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT247_P15_15_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT255_P13_6_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_j, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_3_TOUT267_P10_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT167_P00_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT194_P30_4_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 194, {&MODULE_P30, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT226_P24_4_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 226, {&MODULE_P24, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT245_P15_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT248_P13_9_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_j, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_4_TOUT268_P10_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT168_P00_15_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT195_P30_5_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 195, {&MODULE_P30, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT227_P24_5_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 227, {&MODULE_P24, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT246_P15_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT251_P13_10_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_5_TOUT269_P10_11_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT151_P02_12_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT153_P02_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT196_P30_6_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 196, {&MODULE_P30, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT228_P24_6_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 228, {&MODULE_P24, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT247_P15_15_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT249_P13_12_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_j, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_6_TOUT270_P10_15_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT152_P02_15_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT154_P02_14_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT161_P01_13_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_k, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT197_P30_7_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 197, {&MODULE_P30, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT229_P24_7_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 229, {&MODULE_P24, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT248_P13_9_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM7_7_TOUT261_P14_12_OUT = {IfxGtm_Atom_7, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_0_TOUT162_P01_8_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_0_TOUT198_P30_8_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 198, {&MODULE_P30, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_0_TOUT230_P24_8_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_c, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_0_TOUT242_P15_10_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_j, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_0_TOUT250_P13_11_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_d, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_1_TOUT163_P01_10_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_1_TOUT199_P30_9_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 199, {&MODULE_P30, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_1_TOUT231_P24_9_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_c, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_1_TOUT251_P13_10_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_1_TOUT258_P14_11_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_d, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_2_TOUT164_P01_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_2_TOUT200_P30_10_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 200, {&MODULE_P30,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_2_TOUT232_P24_10_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_c, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_2_TOUT252_P13_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_2_TOUT259_P14_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_d, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_3_TOUT166_P00_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_3_TOUT201_P30_11_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 201, {&MODULE_P30,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_3_TOUT233_P24_11_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_c, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_3_TOUT253_P13_4_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_3_TOUT260_P14_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_d, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_4_TOUT167_P00_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_4_TOUT202_P30_12_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_4_TOUT234_P24_12_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_c, 234, {&MODULE_P24,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_4_TOUT254_P13_5_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_4_TOUT261_P14_12_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_d, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT168_P00_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT203_P30_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT235_P24_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_c, 235, {&MODULE_P24,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT243_P15_11_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_j, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT255_P13_6_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_5_TOUT262_P13_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_d, 262, {&MODULE_P13,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT151_P02_12_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT153_P02_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT204_P30_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT236_P24_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_c, 236, {&MODULE_P24,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT256_P13_7_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_6_TOUT263_P14_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_d, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT152_P02_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT154_P02_14_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT161_P01_13_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_l, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT205_P30_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT237_P24_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_c, 237, {&MODULE_P24,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT244_P15_12_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_j, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM8_7_TOUT264_P13_15_OUT = {IfxGtm_Atom_8, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_d, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_0_TOUT206_P25_0_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_0_TOUT222_P24_0_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_0, IfxGtm_ToutSel_i, 222, {&MODULE_P24, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_1_TOUT207_P25_1_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_1_TOUT223_P24_1_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_1, IfxGtm_ToutSel_i, 223, {&MODULE_P24, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_2_TOUT208_P25_2_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_2_TOUT224_P24_2_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_2, IfxGtm_ToutSel_i, 224, {&MODULE_P24, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_3_TOUT209_P25_3_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_3_TOUT225_P24_3_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_3, IfxGtm_ToutSel_i, 225, {&MODULE_P24, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_4_TOUT210_P25_4_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_4_TOUT226_P24_4_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_4, IfxGtm_ToutSel_i, 226, {&MODULE_P24, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_5_TOUT211_P25_5_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_5_TOUT227_P24_5_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_5, IfxGtm_ToutSel_i, 227, {&MODULE_P24, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_6_TOUT212_P25_6_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_6_TOUT212_P26_0_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_6_TOUT228_P24_6_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_6, IfxGtm_ToutSel_i, 228, {&MODULE_P24, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_7_TOUT213_P25_7_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Atom_ToutMap IfxGtm_ATOM9_7_TOUT229_P24_7_OUT = {IfxGtm_Atom_9, IfxGtm_Atom_Ch_7, IfxGtm_ToutSel_i, 229, {&MODULE_P24, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Clk_Out IfxGtm_CLK0_P23_1_OUT = {&MODULE_GTM, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt4};
IfxGtm_Clk_Out IfxGtm_CLK1_P32_4_OUT = {&MODULE_GTM, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt4};
IfxGtm_Clk_Out IfxGtm_CLK2_P11_12_OUT = {&MODULE_GTM, {&MODULE_P11,12}, IfxPort_OutputIdx_alt3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P00_9_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P00, 9}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P02_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P02, 0}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P10_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P10, 7}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P13_12_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P13,12}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P14_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P14, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P14_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P14, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P15_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P15, 6}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P21_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P21, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P22_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P22, 1}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P33_10_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P33,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_0_P33_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_0, {&MODULE_P33, 4}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P00_10_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P00,10}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P02_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P02, 1}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P10_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P10, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P10_9_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P10, 9}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P14_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P14, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P15_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P15, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P21_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P21, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P22_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P22, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P33_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P33, 5}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_1_P33_9_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_1, {&MODULE_P33, 9}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P00_11_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P00,11}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P02_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P02, 2}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P02_9_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P02, 9}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P10_10_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P10,10}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P10_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P10, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P10_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P10, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P15_8_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P15, 8}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P21_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P21, 4}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P23_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P23, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P33_11_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P33,11}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_2_P33_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_2, {&MODULE_P33, 6}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P00_12_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P00,12}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P02_10_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P02,10}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P02_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P02, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P10_14_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P10,14}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P10_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P10, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P10_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P10, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P14_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P14, 0}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P21_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P21, 5}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P22_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P22, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P32_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P32, 2}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_3_P33_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_3, {&MODULE_P33, 7}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P02_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P02, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P10_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P10, 0}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P10_13_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P10,13}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P14_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P14, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P21_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P21, 6}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P22_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P22, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P32_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P32, 3}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P33_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P33, 0}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_4_P33_8_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_4, {&MODULE_P33, 8}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P01_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P01, 3}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P02_5_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P02, 5}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P10_11_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P10,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P10_8_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P10, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P14_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P14, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P21_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P21, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P23_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P23, 0}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P32_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P32, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_5_P33_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_5, {&MODULE_P33, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P01_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P01, 4}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P02_6_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P02, 6}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P10_15_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P10,15}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P10_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P10, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P14_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P14, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P20_0_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P20, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P23_1_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P23, 1}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P23_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P23, 2}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_6_P33_2_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_6, {&MODULE_P33, 2}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P02_11_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P02,11}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P02_7_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P02, 7}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P11_15_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P11,15}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P14_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P14, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P20_8_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P20, 8}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P23_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P23, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P23_4_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P23, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM0_7_P33_3_IN = {IfxGtm_Tim_0, IfxGtm_Tim_Ch_7, {&MODULE_P33, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P00_9_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P00, 9}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P02_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P02, 0}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P10_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P10, 7}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P14_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P14, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P14_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P14, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P15_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P15, 6}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P21_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P21, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P22_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P22, 1}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P33_10_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P33,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM1_0_P33_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_0, {&MODULE_P33, 4}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P00_10_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P00,10}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P02_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P02, 1}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P10_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P10, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P14_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P14, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P15_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P15, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P21_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P21, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P22_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P22, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P33_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P33, 5}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_1_P33_9_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_1, {&MODULE_P33, 9}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P00_11_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P00,11}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P02_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P02, 2}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P10_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P10, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P10_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P10, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P15_8_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P15, 8}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P21_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P21, 4}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P23_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P23, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P23_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P23, 6}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P33_11_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P33,11}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_2_P33_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_2, {&MODULE_P33, 6}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P00_12_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P00,12}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P02_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P02, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P10_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P10, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P10_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P10, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P14_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P14, 0}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P21_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P21, 5}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P22_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P22, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P23_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P23, 7}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P32_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P32, 2}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_3_P33_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_3, {&MODULE_P33, 7}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P02_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P02, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P10_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P10, 0}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P14_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P14, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P20_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P20, 0}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P21_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P21, 6}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P22_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P22, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P32_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P32, 3}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P33_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P33, 0}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_4_P33_8_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_4, {&MODULE_P33, 8}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P02_5_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P02, 5}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P10_8_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P10, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P14_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P14, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P20_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P20, 7}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P21_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P21, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P23_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P23, 0}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P32_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P32, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_5_P33_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_5, {&MODULE_P33, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P02_6_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P02, 6}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P10_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P10, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P14_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P14, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P20_0_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P20, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P23_1_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P23, 1}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P23_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P23, 2}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_6_P33_2_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_6, {&MODULE_P33, 2}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P02_7_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P02, 7}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P14_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P14, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P20_8_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P20, 8}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P23_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P23, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P23_4_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P23, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM1_7_P33_3_IN = {IfxGtm_Tim_1, IfxGtm_Tim_Ch_7, {&MODULE_P33, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P00_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P00, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P01_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P01, 3}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P02_8_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P02, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P11_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P11, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P11_10_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P11,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P13_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P13, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P15_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P15, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P20_12_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P20,12}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P31_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P31, 0}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P33_12_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P33,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_0_P33_14_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_0, {&MODULE_P33,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P00_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P00, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P00_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P00, 2}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P01_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P01, 4}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P11_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P11, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P11_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P11, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P15_10_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P15,10}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P20_13_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P20,13}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P31_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P31, 1}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P33_13_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P33,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_1_P33_15_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_1, {&MODULE_P33,15}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P00_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P00, 3}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P01_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P01, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P11_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P11, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P11_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P11, 4}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P14_8_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P14, 8}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P15_11_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P15,11}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P15_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P15, 6}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P20_14_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P20,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P31_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P31, 2}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_2_P32_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_2, {&MODULE_P32, 0}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P00_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P00, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P01_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P01, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P11_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P11, 5}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P11_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P11, 6}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P14_9_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P14, 9}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P15_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P15, 0}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P15_12_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P15,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P20_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P20, 1}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P31_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P31, 3}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_3_P34_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_3, {&MODULE_P34, 1}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P00_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P00, 5}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P02_14_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P02,14}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P11_7_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P11, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P11_9_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P11, 9}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P14_10_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P14,10}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P15_13_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P15,13}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P15_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P15, 1}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P20_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P20, 3}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P21_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P21, 0}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P31_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P31, 4}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM2_4_P34_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_4, {&MODULE_P34, 2}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P00_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P00, 6}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P01_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P01, 6}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P02_15_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P02,15}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P11_10_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P11,10}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P11_8_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P11, 8}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P13_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P13, 0}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P15_14_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P15,14}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P15_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P15, 2}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P20_9_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P20, 9}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P21_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P21, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P31_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P31, 5}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM2_5_P34_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_5, {&MODULE_P34, 3}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P00_7_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P00, 7}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P01_0_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P01, 0}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P11_11_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P11,11}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P11_13_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P11,13}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P13_1_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P13, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P15_15_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P15,15}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P15_3_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P15, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P20_10_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P20,10}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P20_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P20, 6}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P22_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P22, 6}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P31_6_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P31, 6}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM2_6_P34_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_6, {&MODULE_P34, 4}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P00_8_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P00, 8}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P01_7_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P01, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P11_12_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P11,12}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P11_14_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P11,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P13_2_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P13, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P13_9_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P13, 9}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P15_4_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P15, 4}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P20_11_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P20,11}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P20_7_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P20, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P31_7_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P31, 7}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM2_7_P34_5_IN = {IfxGtm_Tim_2, IfxGtm_Tim_Ch_7, {&MODULE_P34, 5}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P00_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P00, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P00_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P00, 5}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P02_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P02, 6}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P02_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P02, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P11_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P11,11}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P12_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P12, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P13_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P13,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P13_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P13, 3}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P15_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P15, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P20_12_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P20,12}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P22_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P22, 4}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P25_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P25, 0}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P33_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P33, 0}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM3_0_P33_12_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_0, {&MODULE_P33,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P00_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P00, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P00_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P00, 2}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P00_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P00, 6}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P02_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P02, 7}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P11_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P11, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P12_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P12, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P13_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P13,10}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P14_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P14,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P20_13_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P20,13}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P22_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P22, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P25_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P25, 1}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P33_13_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P33,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_1_P33_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_1, {&MODULE_P33, 1}, (IfxGtm_ChXSel)15};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P00_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P00, 3}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P00_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P00, 7}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P02_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P02, 8}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P11_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P11, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P13_14_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P13,14}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P14_14_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P14,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P14_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P14, 8}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P20_14_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P20,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P22_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P22, 6}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P25_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P25, 2}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P32_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P32, 0}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_2_P33_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_2, {&MODULE_P33, 2}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P00_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P00, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P00_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P00, 8}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P02_9_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P02, 9}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P11_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P11, 6}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P13_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P13, 4}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P14_13_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P14,13}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P14_9_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P14, 9}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P15_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P15, 0}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P20_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P20, 1}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P22_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P22, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P25_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P25, 3}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P32_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P32, 1}, (IfxGtm_ChXSel)15};
IfxGtm_Tim_TinMap IfxGtm_TIM3_3_P33_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_3, {&MODULE_P33, 3}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P00_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P00, 5}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P02_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P02,10}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P11_9_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P11, 9}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P13_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P13, 5}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P14_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P14,10}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P14_12_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P14,12}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P15_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P15, 1}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P20_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P20, 3}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P21_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P21, 0}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P22_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P22, 8}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P25_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P25, 4}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_4_P34_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_4, {&MODULE_P34, 1}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P00_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P00, 6}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P02_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P02,11}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P11_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P11,10}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P13_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P13, 0}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P13_13_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P13,13}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P13_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P13, 6}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P15_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P15, 2}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P20_9_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P20, 9}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P21_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P21, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P22_9_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P22, 9}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P25_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P25, 5}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P32_5_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P32, 5}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_5_P34_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_5, {&MODULE_P34, 2}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P00_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P00, 7}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P02_12_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P02,12}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P11_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P11,11}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P13_1_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P13, 1}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P13_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P13, 7}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P14_15_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P14,15}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P15_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P15, 3}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P20_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P20,10}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P20_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P20, 6}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P22_10_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P22,10}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P25_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P25, 6}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P26_0_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P26, 0}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P32_6_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P32, 6}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_6_P34_3_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_6, {&MODULE_P34, 3}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P00_8_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P00, 8}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P02_13_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P02,13}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P11_12_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P11,12}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P13_15_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P13,15}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P13_2_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P13, 2}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P15_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P15, 4}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P20_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P20,11}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P20_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P20, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P22_11_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P22,11}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P25_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P25, 7}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P32_7_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P32, 7}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM3_7_P34_4_IN = {IfxGtm_Tim_3, IfxGtm_Tim_Ch_7, {&MODULE_P34, 4}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P00_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P00,13}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P00_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P00, 9}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P01_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P01,12}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P02_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P02,12}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P10_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P10, 0}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P10_8_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P10, 8}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P11_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P11, 0}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P12_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P12, 0}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P13_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P13,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P21_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P21, 0}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P24_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P24, 0}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P25_8_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P25, 8}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P30_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P30, 0}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_0_P32_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_0, {&MODULE_P32, 7}, (IfxGtm_ChXSel)15};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P00_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P00,10}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P00_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P00,15}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P01_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P01, 1}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P02_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P02,15}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P10_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P10, 9}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P11_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P11, 1}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P12_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P12, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P15_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P15,10}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P21_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P21, 1}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P24_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P24, 1}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P25_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P25, 9}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P30_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P30, 1}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_1_P32_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_1, {&MODULE_P32, 5}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P00_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P00,11}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P01_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P01, 9}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P02_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P02,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P02_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P02, 9}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P10_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P10,10}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P10_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P10, 6}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P11_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P11, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P15_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P15,11}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P21_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P21, 6}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P23_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P23, 6}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P24_2_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P24, 2}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P25_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P25,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_2_P30_2_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_2, {&MODULE_P30, 2}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P00_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P00,12}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P01_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P01,13}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P02_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P02,10}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P02_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P02,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P10_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P10,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P10_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P10, 5}, (IfxGtm_ChXSel)13};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P11_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P11, 5}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P15_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P15,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P21_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P21, 7}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P23_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P23, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P24_3_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P24, 3}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P25_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P25,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_3_P30_3_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_3, {&MODULE_P30, 3}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P01_0_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P01, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P01_8_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P01, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P02_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P02,11}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P10_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P10,13}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P10_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P10, 1}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P11_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P11, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P15_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P15,13}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P20_1_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P20, 1}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P24_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P24, 4}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P25_12_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P25,12}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P30_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P30, 4}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P32_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P32, 6}, (IfxGtm_ChXSel)15};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P33_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P33,10}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM4_4_P33_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_4, {&MODULE_P33, 4}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P01_10_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P01,10}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P01_2_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P01, 2}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P01_3_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P01, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P10_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P10,11}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P10_2_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P10, 2}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P11_8_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P11, 8}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P15_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P15,14}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P20_3_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P20, 3}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P24_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P24, 5}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P25_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P25,13}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P30_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P30, 5}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P33_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P33,14}, (IfxGtm_ChXSel)14};
IfxGtm_Tim_TinMap IfxGtm_TIM4_5_P33_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_5, {&MODULE_P33, 5}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P01_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P01,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P01_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P01,15}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P01_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P01, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P10_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P10,15}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P10_3_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P10, 3}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P11_13_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P11,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P15_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P15,15}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P24_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P24, 6}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P25_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P25,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P30_6_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P30, 6}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_6_P33_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_6, {&MODULE_P33,15}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P00_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P00,14}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P01_11_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P01,11}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P10_4_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P10, 4}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P11_14_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P11,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P11_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P11,15}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P13_9_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P13, 9}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P14_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P14, 7}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P24_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P24, 7}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P25_15_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P25,15}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P30_7_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P30, 7}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM4_7_P34_5_IN = {IfxGtm_Tim_4, IfxGtm_Tim_Ch_7, {&MODULE_P34, 5}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P00_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P00,13}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P01_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P01,12}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P01_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P01, 8}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P02_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P02,12}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P13_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P13,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P22_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P22, 8}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P24_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P24, 8}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P30_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P30, 8}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P31_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P31, 8}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_0_P33_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_0, {&MODULE_P33,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P00_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P00,15}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P01_1_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P01, 1}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P01_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P01, 9}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P02_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P02,15}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P13_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P13,10}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P14_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P14,11}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P22_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P22, 9}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P24_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P24, 9}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P30_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P30, 9}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P31_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P31, 9}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_1_P33_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_1, {&MODULE_P33,15}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P01_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P01,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P01_9_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P01, 9}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P02_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P02,13}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P13_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P13,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P14_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P14,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P22_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P22,10}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P24_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P24,10}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P30_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P30,10}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_2_P31_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_2, {&MODULE_P31,10}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P01_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P01,11}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P01_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P01,13}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P01_5_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P01, 5}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P02_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P02,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P13_4_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P13, 4}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P14_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P14,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P22_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P22,11}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P24_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P24,11}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P30_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P30,11}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P31_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P31,11}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_3_P34_1_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_3, {&MODULE_P34, 1}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P00_0_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P00, 0}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P01_0_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P01, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P01_8_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P01, 8}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P13_5_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P13, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P14_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P14,12}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P21_2_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P21, 2}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P24_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P24,12}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P30_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P30,12}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P31_12_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P31,12}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_4_P34_2_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_4, {&MODULE_P34, 2}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P00_1_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P00, 1}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P01_10_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P01,10}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P01_2_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P01, 2}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P01_6_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P01, 6}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P13_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P13,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P13_6_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P13, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P21_3_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P21, 3}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P24_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P24,13}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P30_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P30,13}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P31_13_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P31,13}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P32_5_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P32, 5}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_5_P34_3_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_5, {&MODULE_P34, 3}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P00_2_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P00, 2}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P01_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P01,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P01_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P01,15}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P01_6_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P01, 6}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P13_7_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P13, 7}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P14_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P14,15}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P21_4_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P21, 4}, (IfxGtm_ChXSel)12};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P24_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P24,14}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P30_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P30,14}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P31_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P31,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P32_6_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P32, 6}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM5_6_P34_4_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_6, {&MODULE_P34, 4}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P00_14_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P00,14}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P00_3_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P00, 3}, (IfxGtm_ChXSel)10};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P01_11_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P01,11}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P01_7_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P01, 7}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P13_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P13,15}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P21_5_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P21, 5}, (IfxGtm_ChXSel)11};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P24_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P24,15}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P30_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P30,15}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P31_15_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P31,15}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P32_7_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P32, 7}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM5_7_P34_5_IN = {IfxGtm_Tim_5, IfxGtm_Tim_Ch_7, {&MODULE_P34, 5}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P01_12_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P01,12}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P10_9_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P10, 9}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P13_4_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P13, 4}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P20_6_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P20, 6}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P23_7_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P23, 7}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P24_0_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P24, 0}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P25_0_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P25, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P30_8_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P30, 8}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_0_P31_8_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_0, {&MODULE_P31, 8}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P01_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P01,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P10_10_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P10,10}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P13_5_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P13, 5}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P20_7_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P20, 7}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P23_6_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P23, 6}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P24_1_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P24, 1}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P25_1_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P25, 1}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P30_9_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P30, 9}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_1_P31_9_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_1, {&MODULE_P31, 9}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P01_14_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P01,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P10_11_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P10,11}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P13_6_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P13, 6}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P20_8_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P20, 8}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P23_5_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P23, 5}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P24_2_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P24, 2}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P25_2_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P25, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P30_10_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P30,10}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_2_P31_10_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_2, {&MODULE_P31,10}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P01_15_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P01,15}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P10_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P10,13}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P13_7_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P13, 7}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P20_9_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P20, 9}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P23_4_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P23, 4}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P24_3_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P24, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P25_3_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P25, 3}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P30_11_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P30,11}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_3_P31_11_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_3, {&MODULE_P31,11}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P00_4_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P00, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P13_9_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P13, 9}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P14_12_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P14,12}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P23_3_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P23, 3}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P24_4_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P24, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P25_4_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P25, 4}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P30_12_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P30,12}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_4_P31_12_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_4, {&MODULE_P31,12}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P00_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P00,13}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P13_10_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P13,10}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P14_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P14,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P23_2_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P23, 2}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P24_5_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P24, 5}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P25_5_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P25, 5}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P30_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P30,13}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_5_P31_13_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_5, {&MODULE_P31,13}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P00_14_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P00,14}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P13_11_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P13,11}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P14_14_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P14,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P23_1_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P23, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P24_6_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P24, 6}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P25_6_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P25, 6}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P26_0_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P26, 0}, (IfxGtm_ChXSel)9};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P30_14_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P30,14}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_6_P31_14_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_6, {&MODULE_P31,14}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P00_15_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P00,15}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P13_12_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P13,12}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P14_15_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P14,15}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P23_0_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P23, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P24_7_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P24, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P25_7_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P25, 7}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P30_15_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P30,15}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM6_7_P31_15_IN = {IfxGtm_Tim_6, IfxGtm_Tim_Ch_7, {&MODULE_P31,15}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P10_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P10,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P13_13_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P13,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P15_10_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P15,10}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P22_3_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P22, 3}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P24_8_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P24, 8}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P25_8_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P25, 8}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P30_0_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P30, 0}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM7_0_P31_0_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_0, {&MODULE_P31, 0}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P10_15_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P10,15}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P13_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P13,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P15_11_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P15,11}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P22_2_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P22, 2}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P24_9_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P24, 9}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P25_9_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P25, 9}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P30_1_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P30, 1}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM7_1_P31_1_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_1, {&MODULE_P31, 1}, (IfxGtm_ChXSel)8};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P13_15_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P13,15}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P15_12_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P15,12}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P22_1_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P22, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P24_10_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P24,10}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P25_10_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P25,10}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P30_2_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P30, 2}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_2_P31_2_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_2, {&MODULE_P31, 2}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P12_0_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P12, 0}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P15_13_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P15,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P22_0_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P22, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P24_11_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P24,11}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P25_11_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P25,11}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P30_3_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P30, 3}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_3_P31_3_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_3, {&MODULE_P31, 3}, (IfxGtm_ChXSel)7};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P12_1_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P12, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P15_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P15,14}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P24_12_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P24,12}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P25_12_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P25,12}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P30_4_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P30, 4}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_4_P31_4_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_4, {&MODULE_P31, 4}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P11_0_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P11, 0}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P15_15_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P15,15}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P24_13_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P24,13}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P25_13_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P25,13}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P30_5_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P30, 5}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_5_P31_5_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_5, {&MODULE_P31, 5}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P11_1_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P11, 1}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P14_11_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P14,11}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P24_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P24,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P25_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P25,14}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P30_6_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P30, 6}, (IfxGtm_ChXSel)5};
IfxGtm_Tim_TinMap IfxGtm_TIM7_6_P31_6_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_6, {&MODULE_P31, 6}, (IfxGtm_ChXSel)6};
IfxGtm_Tim_TinMap IfxGtm_TIM7_7_P11_4_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_7, {&MODULE_P11, 4}, (IfxGtm_ChXSel)1};
IfxGtm_Tim_TinMap IfxGtm_TIM7_7_P24_14_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_7, {&MODULE_P24,14}, (IfxGtm_ChXSel)3};
IfxGtm_Tim_TinMap IfxGtm_TIM7_7_P24_15_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_7, {&MODULE_P24,15}, (IfxGtm_ChXSel)2};
IfxGtm_Tim_TinMap IfxGtm_TIM7_7_P30_7_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_7, {&MODULE_P30, 7}, (IfxGtm_ChXSel)4};
IfxGtm_Tim_TinMap IfxGtm_TIM7_7_P31_7_IN = {IfxGtm_Tim_7, IfxGtm_Tim_Ch_7, {&MODULE_P31, 7}, (IfxGtm_ChXSel)5};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT106_P10_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT17_P00_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT25_P33_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT34_P33_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT51_P21_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT61_P20_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT72_P15_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT7_P02_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT91_P13_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0N_TOUT9_P00_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT0_P02_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT109_P10_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT151_P02_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_g, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT18_P00_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT26_P33_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT32_P33_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT53_P21_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT76_P15_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT77_P15_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT85_P14_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 85, {&MODULE_P14, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_0_TOUT87_P14_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_10_TOUT12_P00_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_10_TOUT2_P02_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_10_TOUT41_P23_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_10_TOUT46_P23_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_10_TOUT96_P11_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_11_TOUT13_P00_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_11_TOUT3_P02_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_11_TOUT43_P23_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_11_TOUT49_P22_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_11_TOUT97_P11_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_12_TOUT14_P00_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_12_TOUT44_P23_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_12_TOUT4_P02_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_12_TOUT50_P22_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_12_TOUT98_P11_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_13_TOUT15_P00_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_13_TOUT5_P02_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_13_TOUT99_P11_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_14_TOUT100_P11_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_14_TOUT16_P00_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_14_TOUT6_P02_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_15_TOUT101_P11_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_15_TOUT17_P00_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_15_TOUT42_P23_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_15_TOUT7_P02_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT107_P10_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT10_P00_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT14_P00_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT22_P33_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT30_P33_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT35_P33_13_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT39_P32_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT4_P02_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT52_P21_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT57_P21_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT73_P15_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT90_P14_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1N_TOUT92_P13_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT103_P10_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT116_P02_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT19_P00_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT1_P02_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT27_P33_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT31_P33_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT54_P21_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT78_P15_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_1_TOUT86_P14_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT108_P10_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT11_P00_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT143_P33_14_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_g, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT15_P00_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT23_P33_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT40_P32_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_g, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT58_P21_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT5_P02_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT74_P15_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2N_TOUT93_P13_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT104_P10_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT107_P10_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT117_P02_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_g, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT20_P00_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT28_P33_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT2_P02_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT33_P33_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT55_P21_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT79_P15_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_2_TOUT88_P14_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT109_P10_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT12_P00_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT144_P33_15_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT16_P00_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT24_P33_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT42_P23_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT59_P20_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT60_P20_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT6_P02_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT75_P15_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3N_TOUT94_P13_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT105_P10_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT108_P10_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT118_P02_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT21_P00_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT29_P33_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT38_P32_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT3_P02_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT56_P21_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT71_P15_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT80_P14_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_3_TOUT89_P14_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT10_P00_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT143_P33_14_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT147_P34_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT1_P02_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT29_P33_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT36_P32_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT54_P21_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT56_P21_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT65_P20_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT73_P15_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT89_P14_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT8_P02_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT95_P11_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4N_TOUT96_P11_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT0_P02_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT102_P10_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT124_P11_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT22_P33_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT30_P33_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT37_P32_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT39_P32_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT53_P21_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT57_P21_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT64_P20_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT72_P15_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT81_P14_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT90_P14_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT94_P13_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_4_TOUT9_P00_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT121_P11_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT12_P00_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT144_P33_15_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT148_P34_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT26_P33_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT28_P33_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT32_P33_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT37_P32_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT3_P02_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT53_P21_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT56_P21_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT67_P20_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT76_P15_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT77_P15_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT87_P14_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5N_TOUT97_P11_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT110_P10_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT11_P00_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT128_P12_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT23_P33_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT27_P33_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT2_P02_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT40_P32_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT55_P21_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT58_P21_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT66_P20_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT74_P15_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT82_P14_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT91_P13_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_5_TOUT96_P11_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT149_P34_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT14_P00_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT27_P33_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT30_P33_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT31_P33_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT38_P32_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT40_P32_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT49_P22_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT54_P21_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT5_P02_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT69_P20_13_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT78_P15_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT82_P14_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT86_P14_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT91_P13_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT97_P11_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6N_TOUT99_P11_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT106_P10_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT129_P12_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 129, {&MODULE_P12, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT13_P00_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT24_P33_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT29_P33_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT42_P23_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT48_P22_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT4_P02_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT59_P20_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT68_P20_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT80_P14_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT83_P14_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 83, {&MODULE_P14, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT92_P13_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_6_TOUT98_P11_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT100_P11_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT123_P11_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT130_P22_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT150_P34_5_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT16_P00_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT28_P33_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT32_P33_10_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT33_P33_11_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT39_P32_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT42_P23_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT55_P21_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT71_P15_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT79_P15_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT7_P02_7_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT84_P14_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT88_P14_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7N_TOUT93_P13_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT101_P11_12_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT119_P11_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT15_P00_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT25_P33_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT31_P33_9_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT45_P23_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT50_P22_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT6_P02_6_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT70_P20_14_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT81_P14_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT84_P14_4_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT92_P13_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_7_TOUT93_P13_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT0_P02_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT48_P22_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT51_P21_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT8_P02_8_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT94_P13_3_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT95_P11_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_8_TOUT9_P00_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_9_TOUT10_P00_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_9_TOUT11_P00_2_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_9_TOUT1_P02_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_9_TOUT47_P22_0_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 47, {&MODULE_P22, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM0_9_TOUT52_P21_1_OUT = {IfxGtm_Tom_0, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0N_TOUT17_P00_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0N_TOUT25_P33_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0N_TOUT34_P33_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0N_TOUT75_P15_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0N_TOUT7_P02_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT0_P02_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT18_P00_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT26_P33_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT32_P33_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT68_P20_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT76_P15_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT77_P15_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT85_P14_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 85, {&MODULE_P14, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT8_P02_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_0_TOUT9_P00_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_10_TOUT143_P33_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_10_TOUT266_P10_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_10_TOUT2_P02_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_10_TOUT62_P20_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_11_TOUT144_P33_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_11_TOUT267_P10_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_11_TOUT3_P02_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_11_TOUT60_P20_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_11_TOUT63_P20_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_12_TOUT268_P10_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_12_TOUT34_P33_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_12_TOUT4_P02_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_12_TOUT61_P20_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_13_TOUT146_P34_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 146, {&MODULE_P34, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_13_TOUT269_P10_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_13_TOUT35_P33_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_13_TOUT5_P02_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_13_TOUT65_P20_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_14_TOUT147_P34_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_14_TOUT270_P10_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_14_TOUT36_P32_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_14_TOUT66_P20_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_14_TOUT6_P02_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_15_TOUT148_P34_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_15_TOUT150_P34_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_15_TOUT37_P32_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_15_TOUT67_P20_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_15_TOUT7_P02_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT14_P00_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT22_P33_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT245_P15_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT30_P33_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT35_P33_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT39_P32_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_h, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT4_P02_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1N_TOUT72_P15_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT10_P00_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT116_P02_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT11_P00_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT19_P00_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT1_P02_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT242_P15_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT27_P33_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT31_P33_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT69_P20_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT78_P15_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_1_TOUT86_P14_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT143_P33_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_h, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT15_P00_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT23_P33_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT246_P15_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_g, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT40_P32_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_h, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT41_P23_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT5_P02_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2N_TOUT73_P15_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT117_P02_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT12_P00_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT20_P00_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT243_P15_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT28_P33_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT2_P02_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT33_P33_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT70_P20_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_2_TOUT79_P15_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT144_P33_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_h, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT16_P00_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT247_P15_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT24_P33_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT43_P23_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT6_P02_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3N_TOUT74_P15_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT118_P02_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT13_P00_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT21_P00_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT244_P15_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT29_P33_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT38_P32_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT3_P02_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT71_P15_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_3_TOUT80_P14_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT10_P00_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT13_P00_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT143_P33_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 143, {&MODULE_P33,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT147_P34_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 147, {&MODULE_P34, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT1_P02_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT21_P00_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 21, {&MODULE_P00,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT244_P15_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT29_P33_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT36_P32_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT54_P21_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT65_P20_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT71_P15_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT73_P15_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT8_P02_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4N_TOUT95_P11_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT0_P02_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT124_P11_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT14_P00_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT22_P33_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 22, {&MODULE_P33, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT245_P15_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT30_P33_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT37_P32_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT39_P32_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT53_P21_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT64_P20_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_g, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT72_P15_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT81_P14_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT94_P13_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_4_TOUT9_P00_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_h, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT12_P00_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT144_P33_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 144, {&MODULE_P33,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT148_P34_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 148, {&MODULE_P34, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT18_P00_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 18, {&MODULE_P00, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT26_P33_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 26, {&MODULE_P33, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT28_P33_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT32_P33_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT37_P32_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT3_P02_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 3, {&MODULE_P02, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT56_P21_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT67_P20_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT76_P15_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT77_P15_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT97_P11_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5N_TOUT9_P00_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 9, {&MODULE_P00, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT11_P00_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT15_P00_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT23_P33_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 23, {&MODULE_P33, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT246_P15_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT27_P33_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT2_P02_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 2, {&MODULE_P02, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT40_P32_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT41_P23_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 41, {&MODULE_P23, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT55_P21_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT66_P20_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_g, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT73_P15_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT74_P15_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT82_P14_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_5_TOUT96_P11_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_h, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT10_P00_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 10, {&MODULE_P00, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT11_P00_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 11, {&MODULE_P00, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT149_P34_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT14_P00_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 14, {&MODULE_P00, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT19_P00_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 19, {&MODULE_P00,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT242_P15_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT27_P33_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 27, {&MODULE_P33, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT30_P33_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 30, {&MODULE_P33, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT31_P33_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT38_P32_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 38, {&MODULE_P32, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT40_P32_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 40, {&MODULE_P32, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT49_P22_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT5_P02_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 5, {&MODULE_P02, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT69_P20_13_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT78_P15_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT82_P14_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 82, {&MODULE_P14, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT91_P13_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6N_TOUT99_P11_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT13_P00_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 13, {&MODULE_P00, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT16_P00_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT247_P15_15_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT24_P33_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 24, {&MODULE_P33, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT29_P33_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 29, {&MODULE_P33, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT43_P23_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT48_P22_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT4_P02_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 4, {&MODULE_P02, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT68_P20_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT74_P15_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT80_P14_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 80, {&MODULE_P14, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT83_P14_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 83, {&MODULE_P14, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_6_TOUT98_P11_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_h, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT100_P11_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT12_P00_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 12, {&MODULE_P00, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT130_P22_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT150_P34_5_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 150, {&MODULE_P34, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT16_P00_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 16, {&MODULE_P00, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT20_P00_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 20, {&MODULE_P00,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT243_P15_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT28_P33_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 28, {&MODULE_P33, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT32_P33_10_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 32, {&MODULE_P33,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT33_P33_11_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 33, {&MODULE_P33,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT39_P32_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 39, {&MODULE_P32, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT42_P23_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 42, {&MODULE_P23, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT71_P15_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT79_P15_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT7_P02_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 7, {&MODULE_P02, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT84_P14_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7N_TOUT93_P13_2_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT101_P11_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT15_P00_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 15, {&MODULE_P00, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT17_P00_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 17, {&MODULE_P00, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT248_P13_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT25_P33_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 25, {&MODULE_P33, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT31_P33_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 31, {&MODULE_P33, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT44_P23_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT45_P23_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT50_P22_3_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT64_P20_8_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT6_P02_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 6, {&MODULE_P02, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT70_P20_14_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT75_P15_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT81_P14_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 81, {&MODULE_P14, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT84_P14_4_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 84, {&MODULE_P14, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_7_TOUT92_P13_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_8_TOUT0_P02_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 0, {&MODULE_P02, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_8_TOUT128_P12_0_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 128, {&MODULE_P12, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_8_TOUT141_P32_6_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 141, {&MODULE_P32, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_8_TOUT249_P13_12_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_9_TOUT129_P12_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 129, {&MODULE_P12, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_9_TOUT142_P32_7_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 142, {&MODULE_P32, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_9_TOUT1_P02_1_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 1, {&MODULE_P02, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM1_9_TOUT265_P10_9_OUT = {IfxGtm_Tom_1, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT101_P11_12_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT126_P11_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_g, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT264_P13_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT43_P23_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 43, {&MODULE_P23, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT51_P21_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT61_P20_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT76_P15_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 76, {&MODULE_P15, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0N_TOUT91_P13_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT119_P11_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT120_P11_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_g, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT250_P13_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT48_P22_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 48, {&MODULE_P22, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT53_P21_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT65_P20_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT87_P14_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT94_P13_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_0_TOUT95_P11_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_g, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT104_P10_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT107_P10_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT133_P22_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT260_P14_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT62_P20_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_10_TOUT70_P20_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 70, {&MODULE_P20,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT105_P10_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT108_P10_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT134_P22_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT261_P14_12_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT63_P20_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_11_TOUT71_P15_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 71, {&MODULE_P15, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_12_TOUT102_P10_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_12_TOUT135_P22_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_12_TOUT262_P13_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 262, {&MODULE_P13,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_12_TOUT34_P33_12_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 34, {&MODULE_P33,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_12_TOUT72_P15_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 72, {&MODULE_P15, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT110_P10_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT136_P22_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT263_P14_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT35_P33_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 35, {&MODULE_P33,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT65_P20_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 65, {&MODULE_P20, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_13_TOUT73_P15_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 73, {&MODULE_P15, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_14_TOUT137_P22_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_14_TOUT264_P13_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_14_TOUT36_P32_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 36, {&MODULE_P32, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_14_TOUT66_P20_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 66, {&MODULE_P20,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_14_TOUT74_P15_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 74, {&MODULE_P15, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_15_TOUT149_P34_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 149, {&MODULE_P34, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_15_TOUT37_P32_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 37, {&MODULE_P32, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_15_TOUT67_P20_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 67, {&MODULE_P20,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_15_TOUT75_P15_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 75, {&MODULE_P15, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT123_P11_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT124_P11_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT254_P13_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT44_P23_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 44, {&MODULE_P23, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT50_P22_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT52_P21_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT57_P21_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT61_P20_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT79_P15_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 79, {&MODULE_P15, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT90_P14_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT92_P13_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1N_TOUT98_P11_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT120_P11_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT127_P11_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 127, {&MODULE_P11,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT251_P13_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT47_P22_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 47, {&MODULE_P22, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT54_P21_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT64_P20_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_1_TOUT95_P11_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT124_P11_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT255_P13_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT46_P23_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT58_P21_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT78_P15_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 78, {&MODULE_P15, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT93_P13_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2N_TOUT99_P11_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT121_P11_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT125_P11_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 125, {&MODULE_P11,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT252_P13_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT46_P23_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 46, {&MODULE_P23, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT50_P22_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT55_P21_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT63_P20_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 63, {&MODULE_P20, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT88_P14_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_2_TOUT96_P11_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT100_P11_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT106_P10_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT122_P11_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT256_P13_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT45_P23_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 45, {&MODULE_P23, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT59_P20_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3N_TOUT77_P15_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 77, {&MODULE_P15, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT122_P11_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT126_P11_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT253_P13_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT49_P22_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 49, {&MODULE_P22, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT56_P21_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT60_P20_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT62_P20_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 62, {&MODULE_P20, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT89_P14_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_3_TOUT97_P11_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT106_P10_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT120_P11_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT122_P11_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT126_P11_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT137_P22_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT253_P13_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT56_P21_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 56, {&MODULE_P21, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT60_P20_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 60, {&MODULE_P20, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT89_P14_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 89, {&MODULE_P14, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4N_TOUT97_P11_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 97, {&MODULE_P11, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT102_P10_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 102, {&MODULE_P10, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT123_P11_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 123, {&MODULE_P11, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT133_P22_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT254_P13_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT50_P22_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 50, {&MODULE_P22, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT57_P21_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 57, {&MODULE_P21, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT61_P20_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 61, {&MODULE_P20, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT90_P14_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 90, {&MODULE_P14,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_4_TOUT98_P11_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT107_P10_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 107, {&MODULE_P10, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT119_P11_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 119, {&MODULE_P11, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT136_P22_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT250_P13_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT53_P21_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 53, {&MODULE_P21, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT87_P14_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 87, {&MODULE_P14, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5N_TOUT94_P13_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 94, {&MODULE_P13, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT103_P10_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT124_P11_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 124, {&MODULE_P11, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT132_P22_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT255_P13_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT58_P21_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 58, {&MODULE_P21, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT91_P13_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 91, {&MODULE_P13, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_5_TOUT99_P11_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 99, {&MODULE_P11,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT108_P10_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 108, {&MODULE_P10, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT120_P11_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 120, {&MODULE_P11, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT122_P11_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_g, 122, {&MODULE_P11, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT135_P22_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT251_P13_10_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT54_P21_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 54, {&MODULE_P21, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT86_P14_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 86, {&MODULE_P14, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6N_TOUT95_P11_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 95, {&MODULE_P11, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT100_P11_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 100, {&MODULE_P11,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT104_P10_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 104, {&MODULE_P10, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT106_P10_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 106, {&MODULE_P10, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT125_P11_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 125, {&MODULE_P11,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT131_P22_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT256_P13_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT59_P20_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 59, {&MODULE_P20, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_6_TOUT92_P13_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 92, {&MODULE_P13, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT109_P10_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT121_P11_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 121, {&MODULE_P11, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT134_P22_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT252_P13_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT55_P21_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 55, {&MODULE_P21, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT88_P14_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 88, {&MODULE_P14, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT96_P11_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 96, {&MODULE_P11, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7N_TOUT98_P11_9_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 98, {&MODULE_P11, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT101_P11_12_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 101, {&MODULE_P11,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT105_P10_3_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 105, {&MODULE_P10, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT126_P11_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 126, {&MODULE_P11,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT130_P22_4_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT264_P13_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_g, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT64_P20_8_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 64, {&MODULE_P20, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_7_TOUT93_P13_2_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 93, {&MODULE_P13, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT109_P10_7_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 109, {&MODULE_P10, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT127_P11_15_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 127, {&MODULE_P11,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT131_P22_5_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT258_P14_11_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT51_P21_0_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 51, {&MODULE_P21, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_8_TOUT68_P20_12_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 68, {&MODULE_P20,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_9_TOUT103_P10_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 103, {&MODULE_P10, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_9_TOUT132_P22_6_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_9_TOUT259_P14_14_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_9_TOUT52_P21_1_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 52, {&MODULE_P21, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM2_9_TOUT69_P20_13_OUT = {IfxGtm_Tom_2, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 69, {&MODULE_P20,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0N_TOUT134_P22_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_g, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0N_TOUT161_P01_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0N_TOUT181_P31_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0N_TOUT213_P25_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0N_TOUT8_P02_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT110_P10_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT115_P01_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT130_P22_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 130, {&MODULE_P22, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT155_P01_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT162_P01_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT174_P31_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_0_TOUT206_P25_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT164_P01_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT184_P31_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 184, {&MODULE_P31,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT188_P31_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_e, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT216_P25_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 216, {&MODULE_P25,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT220_P25_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_e, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_10_TOUT266_P10_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT166_P00_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT185_P31_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 185, {&MODULE_P31,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT189_P31_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_e, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT217_P25_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 217, {&MODULE_P25,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT221_P25_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_e, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_11_TOUT267_P10_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_12_TOUT167_P00_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_12_TOUT186_P31_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_12_TOUT218_P25_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_12_TOUT268_P10_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_13_TOUT138_P23_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 138, {&MODULE_P23, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_13_TOUT168_P00_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_13_TOUT187_P31_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_13_TOUT219_P25_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_13_TOUT269_P10_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT139_P23_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 139, {&MODULE_P23, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT151_P02_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT153_P02_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT188_P31_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT220_P25_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_14_TOUT270_P10_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_15_TOUT140_P32_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_15_TOUT152_P02_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_15_TOUT154_P02_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_15_TOUT189_P31_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_15_TOUT221_P25_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT116_P02_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT135_P22_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_g, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT158_P01_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT178_P31_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT210_P25_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT245_P15_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1N_TOUT268_P10_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT111_P01_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT114_P01_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT131_P22_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 131, {&MODULE_P22, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT156_P01_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT163_P01_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT175_P31_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT207_P25_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT242_P15_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_1_TOUT265_P10_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT117_P02_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT136_P22_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_g, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT159_P01_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT179_P31_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT211_P25_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT246_P15_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2N_TOUT267_P10_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT112_P01_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 112, {&MODULE_P01, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT132_P22_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 132, {&MODULE_P22, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT157_P01_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT164_P01_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT176_P31_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT208_P25_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT243_P15_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_2_TOUT266_P10_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT118_P02_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT137_P22_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_g, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT160_P01_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT180_P31_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT212_P25_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT212_P26_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT247_P15_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3N_TOUT270_P10_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT113_P01_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 113, {&MODULE_P01, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT133_P22_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 133, {&MODULE_P22, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT165_P01_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT177_P31_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT209_P25_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT244_P15_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_3_TOUT269_P10_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4N_TOUT151_P02_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4N_TOUT165_P01_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4N_TOUT177_P31_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4N_TOUT209_P25_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4N_TOUT244_P15_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT110_P10_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 110, {&MODULE_P10, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT111_P01_3_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT114_P01_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT134_P22_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 134, {&MODULE_P22, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT158_P01_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT178_P31_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT210_P25_4_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_4_TOUT245_P15_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 245, {&MODULE_P15,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT153_P02_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT155_P01_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT166_P00_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT174_P31_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT206_P25_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5N_TOUT268_P10_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 268, {&MODULE_P10,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT115_P01_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT135_P22_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 135, {&MODULE_P22, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT159_P01_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT179_P31_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT211_P25_5_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT246_P15_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 246, {&MODULE_P15,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_5_TOUT265_P10_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT154_P02_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT156_P01_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT175_P31_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT207_P25_1_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT242_P15_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6N_TOUT267_P10_14_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 267, {&MODULE_P10,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT136_P22_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 136, {&MODULE_P22,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT160_P01_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT180_P31_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT212_P25_6_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT212_P26_0_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT247_P15_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 247, {&MODULE_P15,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_6_TOUT266_P10_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 266, {&MODULE_P10,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT152_P02_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT157_P01_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT176_P31_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT208_P25_2_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT243_P15_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7N_TOUT270_P10_15_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 270, {&MODULE_P10,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT137_P22_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 137, {&MODULE_P22,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT161_P01_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT181_P31_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT213_P25_7_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT248_P13_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 248, {&MODULE_P13, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_7_TOUT269_P10_11_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 269, {&MODULE_P10,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT162_P01_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT182_P31_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 182, {&MODULE_P31, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT186_P31_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_e, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT214_P25_8_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 214, {&MODULE_P25, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT218_P25_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_e, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_8_TOUT249_P13_12_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 249, {&MODULE_P13,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT163_P01_10_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT183_P31_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 183, {&MODULE_P31, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT187_P31_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_e, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT215_P25_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 215, {&MODULE_P25, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT219_P25_13_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_e, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM3_9_TOUT265_P10_9_OUT = {IfxGtm_Tom_3, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 265, {&MODULE_P10, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0N_TOUT161_P01_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0N_TOUT167_P00_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0N_TOUT197_P30_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 197, {&MODULE_P30, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0N_TOUT229_P24_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 229, {&MODULE_P24, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0N_TOUT264_P13_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0_TOUT155_P01_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0_TOUT162_P01_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_f, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0_TOUT190_P30_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 190, {&MODULE_P30, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0_TOUT222_P24_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_a, 222, {&MODULE_P24, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_0_TOUT250_P13_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_10_TOUT164_P01_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_10_TOUT200_P30_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 200, {&MODULE_P30,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_10_TOUT204_P30_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_e, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_10_TOUT232_P24_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_a, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_10_TOUT260_P14_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_11_TOUT166_P00_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_11_TOUT201_P30_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 201, {&MODULE_P30,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_11_TOUT205_P30_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_e, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_11_TOUT233_P24_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_a, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_11_TOUT261_P14_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_12_TOUT167_P00_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 167, {&MODULE_P00,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_12_TOUT202_P30_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_12_TOUT230_P24_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_e, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_12_TOUT234_P24_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_a, 234, {&MODULE_P24,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_12_TOUT262_P13_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 262, {&MODULE_P13,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_13_TOUT168_P00_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 168, {&MODULE_P00,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_13_TOUT203_P30_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_13_TOUT231_P24_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_e, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_13_TOUT235_P24_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_a, 235, {&MODULE_P24,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_13_TOUT263_P14_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT151_P02_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT153_P02_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT204_P30_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT232_P24_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_e, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT236_P24_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_a, 236, {&MODULE_P24,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_14_TOUT264_P13_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_15_TOUT152_P02_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_15_TOUT154_P02_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_15_TOUT205_P30_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_15_TOUT233_P24_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_e, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_15_TOUT237_P24_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_a, 237, {&MODULE_P24,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1N_TOUT158_P01_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1N_TOUT166_P00_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 166, {&MODULE_P00,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1N_TOUT194_P30_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 194, {&MODULE_P30, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1N_TOUT226_P24_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 226, {&MODULE_P24, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1N_TOUT254_P13_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1_TOUT156_P01_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1_TOUT163_P01_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_f, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1_TOUT191_P30_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 191, {&MODULE_P30, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1_TOUT223_P24_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_a, 223, {&MODULE_P24, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_1_TOUT251_P13_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2N_TOUT159_P01_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2N_TOUT195_P30_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 195, {&MODULE_P30, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2N_TOUT227_P24_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 227, {&MODULE_P24, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2N_TOUT255_P13_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2_TOUT157_P01_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2_TOUT164_P01_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_f, 164, {&MODULE_P01,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2_TOUT192_P30_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 192, {&MODULE_P30, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2_TOUT224_P24_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_a, 224, {&MODULE_P24, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_2_TOUT252_P13_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3N_TOUT160_P01_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3N_TOUT196_P30_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 196, {&MODULE_P30, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3N_TOUT228_P24_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 228, {&MODULE_P24, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3N_TOUT256_P13_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_f, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3_TOUT165_P01_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3_TOUT193_P30_3_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 193, {&MODULE_P30, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3_TOUT225_P24_3_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_a, 225, {&MODULE_P24, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_3_TOUT253_P13_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT112_P01_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 112, {&MODULE_P01, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT151_P02_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 151, {&MODULE_P02,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT165_P01_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 165, {&MODULE_P01,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT193_P30_3_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 193, {&MODULE_P30, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT225_P24_3_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 225, {&MODULE_P24, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4N_TOUT253_P13_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_f, 253, {&MODULE_P13, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT111_P01_3_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 111, {&MODULE_P01, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT158_P01_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 158, {&MODULE_P01,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT194_P30_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 194, {&MODULE_P30, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT226_P24_4_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_a, 226, {&MODULE_P24, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT254_P13_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 254, {&MODULE_P13, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_4_TOUT8_P02_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 8, {&MODULE_P02, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT113_P01_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 113, {&MODULE_P01, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT153_P02_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 153, {&MODULE_P02,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT155_P01_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 155, {&MODULE_P01, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT190_P30_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 190, {&MODULE_P30, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT222_P24_0_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 222, {&MODULE_P24, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5N_TOUT250_P13_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_f, 250, {&MODULE_P13,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5_TOUT116_P02_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 116, {&MODULE_P02, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5_TOUT159_P01_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 159, {&MODULE_P01, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5_TOUT195_P30_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 195, {&MODULE_P30, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5_TOUT227_P24_5_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_a, 227, {&MODULE_P24, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_5_TOUT255_P13_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 255, {&MODULE_P13, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT114_P01_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 114, {&MODULE_P01, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT154_P02_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 154, {&MODULE_P02,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT156_P01_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 156, {&MODULE_P01, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT191_P30_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 191, {&MODULE_P30, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT223_P24_1_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 223, {&MODULE_P24, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6N_TOUT251_P13_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_f, 251, {&MODULE_P13,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6_TOUT117_P02_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 117, {&MODULE_P02,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6_TOUT160_P01_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 160, {&MODULE_P01, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6_TOUT196_P30_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 196, {&MODULE_P30, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6_TOUT228_P24_6_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_a, 228, {&MODULE_P24, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_6_TOUT256_P13_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 256, {&MODULE_P13, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT115_P01_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 115, {&MODULE_P01, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT152_P02_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 152, {&MODULE_P02,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT157_P01_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 157, {&MODULE_P01,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT192_P30_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 192, {&MODULE_P30, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT224_P24_2_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 224, {&MODULE_P24, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7N_TOUT252_P13_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_f, 252, {&MODULE_P13,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7_TOUT118_P02_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 118, {&MODULE_P02,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7_TOUT161_P01_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 161, {&MODULE_P01,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7_TOUT197_P30_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 197, {&MODULE_P30, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7_TOUT229_P24_7_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_a, 229, {&MODULE_P24, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_7_TOUT264_P13_15_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_h, 264, {&MODULE_P13,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_8_TOUT162_P01_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 162, {&MODULE_P01, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_8_TOUT198_P30_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 198, {&MODULE_P30, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_8_TOUT202_P30_12_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_e, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_8_TOUT230_P24_8_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_a, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_8_TOUT258_P14_11_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_9_TOUT163_P01_10_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 163, {&MODULE_P01,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_9_TOUT199_P30_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 199, {&MODULE_P30, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_9_TOUT203_P30_13_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_e, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_9_TOUT231_P24_9_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_a, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM4_9_TOUT259_P14_14_OUT = {IfxGtm_Tom_4, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT140_P32_5_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 140, {&MODULE_P32, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT174_P31_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 174, {&MODULE_P31, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT190_P30_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 190, {&MODULE_P30, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT206_P25_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 206, {&MODULE_P25, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT222_P24_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_b, 222, {&MODULE_P24, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_0_TOUT242_P15_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_0, IfxGtm_ToutSel_e, 242, {&MODULE_P15,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT184_P31_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 184, {&MODULE_P31,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT188_P31_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_f, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT200_P30_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 200, {&MODULE_P30,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT204_P30_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_f, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT216_P25_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 216, {&MODULE_P25,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT220_P25_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_f, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_10_TOUT232_P24_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_10, IfxGtm_ToutSel_b, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT185_P31_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 185, {&MODULE_P31,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT189_P31_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_f, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT201_P30_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 201, {&MODULE_P30,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT205_P30_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_f, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT217_P25_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 217, {&MODULE_P25,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT221_P25_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_f, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_11_TOUT233_P24_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_11, IfxGtm_ToutSel_b, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_12_TOUT186_P31_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_12_TOUT202_P30_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_12_TOUT218_P25_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_12_TOUT230_P24_8_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_f, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_12_TOUT234_P24_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_12, IfxGtm_ToutSel_b, 234, {&MODULE_P24,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_13_TOUT187_P31_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_13_TOUT203_P30_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_13_TOUT219_P25_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_13_TOUT231_P24_9_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_f, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_13_TOUT235_P24_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_13, IfxGtm_ToutSel_b, 235, {&MODULE_P24,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_14_TOUT188_P31_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 188, {&MODULE_P31,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_14_TOUT204_P30_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 204, {&MODULE_P30,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_14_TOUT220_P25_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 220, {&MODULE_P25,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_14_TOUT232_P24_10_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_f, 232, {&MODULE_P24,10}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_14_TOUT236_P24_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_14, IfxGtm_ToutSel_b, 236, {&MODULE_P24,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_15_TOUT189_P31_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 189, {&MODULE_P31,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_15_TOUT205_P30_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 205, {&MODULE_P30,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_15_TOUT221_P25_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 221, {&MODULE_P25,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_15_TOUT233_P24_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_f, 233, {&MODULE_P24,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_15_TOUT237_P24_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_15, IfxGtm_ToutSel_b, 237, {&MODULE_P24,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT141_P32_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 141, {&MODULE_P32, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT175_P31_1_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 175, {&MODULE_P31, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT191_P30_1_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 191, {&MODULE_P30, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT207_P25_1_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 207, {&MODULE_P25, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT223_P24_1_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_b, 223, {&MODULE_P24, 1}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_1_TOUT243_P15_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_1, IfxGtm_ToutSel_e, 243, {&MODULE_P15,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT142_P32_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 142, {&MODULE_P32, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT176_P31_2_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 176, {&MODULE_P31, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT192_P30_2_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 192, {&MODULE_P30, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT208_P25_2_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 208, {&MODULE_P25, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT224_P24_2_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_b, 224, {&MODULE_P24, 2}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_2_TOUT244_P15_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_2, IfxGtm_ToutSel_e, 244, {&MODULE_P15,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT138_P23_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 138, {&MODULE_P23, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT177_P31_3_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 177, {&MODULE_P31, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT193_P30_3_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 193, {&MODULE_P30, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT209_P25_3_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 209, {&MODULE_P25, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT212_P25_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_j, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT212_P26_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_j, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT225_P24_3_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_b, 225, {&MODULE_P24, 3}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_3_TOUT258_P14_11_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_3, IfxGtm_ToutSel_e, 258, {&MODULE_P14,11}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT139_P23_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 139, {&MODULE_P23, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT178_P31_4_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 178, {&MODULE_P31, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT194_P30_4_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 194, {&MODULE_P30, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT210_P25_4_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 210, {&MODULE_P25, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT226_P24_4_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_b, 226, {&MODULE_P24, 4}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_4_TOUT261_P14_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_4, IfxGtm_ToutSel_e, 261, {&MODULE_P14,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_5_TOUT179_P31_5_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 179, {&MODULE_P31, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_5_TOUT195_P30_5_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 195, {&MODULE_P30, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_5_TOUT211_P25_5_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 211, {&MODULE_P25, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_5_TOUT227_P24_5_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_b, 227, {&MODULE_P24, 5}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_5_TOUT260_P14_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_5, IfxGtm_ToutSel_e, 260, {&MODULE_P14,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT180_P31_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 180, {&MODULE_P31, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT196_P30_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 196, {&MODULE_P30, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT212_P25_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 212, {&MODULE_P25, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT212_P26_0_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 212, {&MODULE_P26, 0}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT228_P24_6_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_b, 228, {&MODULE_P24, 6}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_6_TOUT259_P14_14_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_6, IfxGtm_ToutSel_e, 259, {&MODULE_P14,14}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_7_TOUT181_P31_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 181, {&MODULE_P31, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_7_TOUT197_P30_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 197, {&MODULE_P30, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_7_TOUT213_P25_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 213, {&MODULE_P25, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_7_TOUT229_P24_7_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_b, 229, {&MODULE_P24, 7}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_7_TOUT263_P14_15_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_7, IfxGtm_ToutSel_e, 263, {&MODULE_P14,15}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT182_P31_8_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 182, {&MODULE_P31, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT186_P31_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_f, 186, {&MODULE_P31,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT198_P30_8_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 198, {&MODULE_P30, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT202_P30_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_f, 202, {&MODULE_P30,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT214_P25_8_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 214, {&MODULE_P25, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT218_P25_12_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_f, 218, {&MODULE_P25,12}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_8_TOUT230_P24_8_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_8, IfxGtm_ToutSel_b, 230, {&MODULE_P24, 8}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT183_P31_9_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 183, {&MODULE_P31, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT187_P31_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_f, 187, {&MODULE_P31,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT199_P30_9_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 199, {&MODULE_P30, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT203_P30_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_f, 203, {&MODULE_P30,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT215_P25_9_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 215, {&MODULE_P25, 9}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT219_P25_13_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_f, 219, {&MODULE_P25,13}, IfxPort_OutputIdx_alt1};
IfxGtm_Tom_ToutMap IfxGtm_TOM5_9_TOUT231_P24_9_OUT = {IfxGtm_Tom_5, IfxGtm_Tom_Ch_9, IfxGtm_ToutSel_b, 231, {&MODULE_P24, 9}, IfxPort_OutputIdx_alt1};

#include "IfxGtm_bf.h"

void IfxGtm_PinMap_setTimTin(IfxGtm_Tim_TinMap *config, IfxPort_InputMode inputMode)
{
    uint32 shift = config->channel * 4;

    __ldmst_c(&(MODULE_GTM.TIMINSEL[config->tim].U), (0xFU << shift), ((uint32)config->select) << shift);

    if (inputMode != IfxPort_InputMode_undefined)
    
{        IfxPort_setPinModeInput(config->pin.port, config->pin.pinIndex, inputMode);
    }
}

void IfxGtm_PinMap_setAtomTout(IfxGtm_Atom_ToutMap *config, IfxPort_OutputMode outputMode, IfxPort_PadDriver padDriver)
{
    uint32 outselReg = (config->toutn >> 3);
    uint32 shift = (config->toutn & 0x7U) * 4;
    uint32 outsel = (uint32)config->toutSel << shift;
    uint32 mask = 0xFU << shift;
    
    __ldmst_c(&(MODULE_GTM.TOUTSEL[outselReg].U), mask, outsel);

    IfxPort_setPinModeOutput(config->pin.port, config->pin.pinIndex, outputMode, config->select);
    IfxPort_setPinPadDriver(config->pin.port, config->pin.pinIndex, padDriver);
}
void IfxGtm_PinMap_setTomTout(IfxGtm_Tom_ToutMap *config, IfxPort_OutputMode outputMode, IfxPort_PadDriver padDriver)
{
    uint32 outselReg = (config->toutn >> 3);
    uint32 shift = (config->toutn & 0x7U) * 4;
    uint32 outsel = (uint32)config->toutSel << shift;
    uint32 mask = 0xFU << shift;

    __ldmst_c(&(MODULE_GTM.TOUTSEL[outselReg].U), mask, outsel);

    IfxPort_setPinModeOutput(config->pin.port, config->pin.pinIndex, outputMode, config->select);
    IfxPort_setPinPadDriver(config->pin.port, config->pin.pinIndex, padDriver);
}
